/*
 * BBS implementation dependendent part
 * The only two interfaces you must provide
 * #include "inntobbs.h" int receive_article(); 0 success not 0 fail
 * if (storeDB(HEADER[MID_H], hispaths) < 0) { .... fail }
 * int cancel_article_front( char *msgid );          0 success not 0 fail
 * char *ptr = (char*)DBfetch(msgid);
 * 줧峹e (body)b char *BODY, Y (header)b char *HEADER[]
 * SUBJECT_H, FROM_H, DATE_H, MID_H, NEWSGROUPS_H, NNTPPOSTINGHOST_H,
 * NNTPHOST_H, CONTROL_H, PATH_H, ORGANIZATION_H
 *
 * Sample Implementation
 * receive_article()         --> post_article()   --> bbspost_write_post();
 * cacnel_article_front(mid) --> cancel_article() --> bbspost_write_cancel();
 */

#define DECODE          /* ѽX */
#define STRIP_ANSI      /* hmⱱX */
#define CHECK_BAD_POST  /* dI峹 */

#ifndef PowerBBS
#include "innbbsconf.h"
#include "daemon.h"
#include "bbslib.h"
#include "inntobbs.h"

extern int Junkhistory;

char *post_article ARG((char *, char *, char *, int (*) (), char *, char *));
int cancel_article ARG((char *, char *, char *));


#ifdef  MapleBBS

#define _BBS_UTIL_C_
#include "record.c"

#else
report()
{
  /* Function called from record.o */
  /* Please leave this function empty */
}
#endif


#if defined(PalmBBS)

#ifndef PATH
# define PATH XPATH
#endif

#ifndef HEADER
# define HEADER XHEADER
#endif

#endif

/* ----------------------------------------------------- */
/* BBS stuff                                             */
/* ----------------------------------------------------- */

void
str_lower(t, s)
  char *t, *s;
{
  register uschar ch;

  do
  {
    ch = *s++;
    *t++ = char_lower(ch);
  } while (ch);
}

int

bad_post(ident)
  char *ident;
{
  static char *invalid[] = { "talu@abo.com.tw", "book@peacock.tnjc.edu.tw",
        "phone@trace.com.tw", "vanessa@mail.eastnet.net.tw",
        "law@ms2.hinet.net", "today@mail.eastnet.net.tw",
        "blueboy@top2.ficnet.net.tw", "araska@email.gcn.net.tw",
        "jupiter227.hkstar.com", "w", "ɩ", "iRkĴMCv",
        "ӧa! ڳwYj!", "Golden Lotus y ~ z",
        "f866@ms3.hinet.net", "a0057@ms7.hinet.net", "wokaa@ms6.hinet.net",
        "tzyy@dynavan.net.tw", "jiann622@ms3.hinet.net",
        "lee00001@ms3.hinet.net", "d1203005@ccms.ntu.edu.tw",
        "c13@ms11.hinet.net", "norton@ms8.hinet.net", "hotmail.com",
	"hotmail.com.tw","star.net.tw","mail.ivy.net.tw",
        "ؿ","CF168","SPEDIA","ID=angellee","<no organization>",
	"none444.yet", NULL};

  char buf[1024];
  int i;

  if (!ident) return 0;

/* leeym
  str_lower(buf, ident);
*/

  strcpy(buf, ident);
  for (i = 0; invalid[i]; i++)
    if (strstr(buf, invalid[i]))
      return 1;
  return 0;
}

dbt_board(ident)
  char *ident;
{
  static char *invalid[] = {"feeling","handicapped","society","boy-girl", 
			    "MapleSob","linux","lists","philosophy",
			    "medicine","religion","movie","story",
			    "tayal",NULL};

  char buf[128];
  int i;
  if (!ident) return 0;
/* leeym
  str_lower(buf, ident);
*/
  strcpy(buf, ident);
  for (i = 0; invalid[i]; i++)
    if (strstr(buf, invalid[i]))
      return 1;
  return 0;
}


/* ----------------------------------------------------- */
/* strip ansi control coed                               */
/* ----------------------------------------------------- */

void
strip_ansi(buf, str)
  char *buf, *str;
{
  register int ch, ansi;

  if(!*str) *buf = '\0';

  for (ansi = 0; ch = *str; str++)
  {
    if (ch == '\n')
    {
      break;
    }
    else if (ch == 27)
    {
      ansi = 1;
    }
    else if (ansi)
    {
      if (!strchr("[01234567;", ch))
        ansi = 0;
    }
    else
    {
      *buf++ = ch;
    }
  }
  *buf = '\0';
}

/* ----------------------------------------------------- */
/* judge & decode QP / BASE64                            */
/* ----------------------------------------------------- */

static int
qp_code(x)
  register int x;
{
  if (x >= '0' && x <= '9')
    return x - '0';
  if (x >= 'a' && x <= 'f')
    return x - 'a' + 10;
  if (x >= 'A' && x <= 'F')
    return x - 'A' + 10;
  return -1;
}

static int
base64_code(x)
  register int x;
{
  if (x >= 'A' && x <= 'Z')
    return x - 'A';
  if (x >= 'a' && x <= 'z')
    return x - 'a' + 26;
  if (x >= '0' && x <= '9')
    return x - '0' + 52;
  if (x == '+')
    return 62;
  if (x == '/')
    return 63;
  return -1;
}

/* ----------------------------------------------------- */
/* judge & decode QP / BASE64                            */
/* ----------------------------------------------------- */
int 
ignorestr(str)
char *str;
{
      char *s;
        
      for(s=str;*s != '\0'; s++) {
          if(!isalnum(*s) &&!ispunct(*s)&&!isspace(*s)) 
             return 1;
      }
      return 0;
}

void
str_decode(dst, src)
  register unsigned char *dst, *src;
{
  register int is_qp, is_base64, is_done;
  register int c1, c2, c3, c4;

  char *dsttmp;
  char *srctmp;
  char srcbuf[256];
  int pos;

  if(ignorestr(src))
  {
     strcpy(dst,src);
     return;
  }

  memcpy(srcbuf, src, 256);
 dsttmp = dst;
  srctmp = src;
  pos = (int)src - (int)srctmp;

  for (is_done = is_qp = is_base64 = 0; c1 = *src; src++)
  {
    pos = (int)src - (int)srctmp;
    if (pos > 254) {
        memcpy(dsttmp, srcbuf, 256);
        return;
    }
    if (c1 == '?' && src[1] == '=')
    {
      src++;
      continue;
    }
    else if (c1 == '\n')        /* chuan: multi line encoding */
    {
      src++;
      is_done = is_qp = is_base64 = 0;
      continue;
    }
    else if (is_qp && c1 == '=')
    {
      pos = (int)src - (int)srctmp;
      if (pos > 254) {
          memcpy(dsttmp, srcbuf, 256);
          return;
      }
      c1 = *++src;

      pos = (int)src - (int)srctmp;
      if (pos > 254) {
          memcpy(dsttmp, srcbuf, 256);
          return;
      }
      c2 = *++src;
      *dst++ = (qp_code(c1) << 4) | qp_code(c2);
    }
    else if (is_base64 && !is_done)
    {
      while (isspace(c1))
      {
        pos = (int)src - (int)srctmp;
        if (pos > 254) {
            memcpy(dsttmp, srcbuf, 256);
            return;
        }

        c1 = *++src;
      }
      if (!c1)
        break;
      do
      {
        pos = (int)src - (int)srctmp;
        if (pos > 254) {
            memcpy(dsttmp, srcbuf, 256);
            return;
        }
        c2 = *++src;
      } while (isspace(c2));
      if (!c2)
        break;
      do
      {
        pos = (int)src - (int)srctmp;
        if (pos > 254) {
            memcpy(dsttmp, srcbuf, 256);
            return;
        }

        c3 = *++src;
      } while (isspace(c3));
      if (!c3)
        break;
      do
      {
        pos = (int)src - (int)srctmp;
        if (pos > 254) {
            memcpy(dsttmp, srcbuf, 256);
            return;
        }
        c4 = *++src;
      } while (isspace(c4));
      if (!c4)
        break;
      if (c1 == '=' || c2 == '=')
      {
        is_done = 1;
        continue;
      }
      c2 = base64_code(c2);
      *dst++ = (base64_code(c1) << 2) | ((c2 & 0x30) >> 4);
      if (c3 == '=')
        is_done = 1;
      else
      {
        c3 = base64_code(c3);
        *dst++ = ((c2 & 0xF) << 4) | ((c3 & 0x3c) >> 2);
        if (c4 == '=')
          is_done = 1;
        else
        {
          *dst++ = ((c3 & 0x03) << 6) | base64_code(c4);
        }
      }
    }
    else if ((c1 == '=') && (src[1] == '?'))
    {
      /* c2 : qmarks, c3 : code_kind */

      c2 = c3 = 0;

      for (;;)
      {
        pos = (int)src - (int)srctmp;
        if (pos > 254) {
            memcpy(dsttmp, srcbuf, 256);
            return;
        }

        c1 = *++src;
        if (c1 != '?')
        {
          if (c2 == 2)
            c3 = c1 | 0x20;
        }
        else
        {
          if (++c2 >= 3)
            break;
        }
      }

      if (c3 == 'q')
        is_qp = 1;
      else if (c3 == 'b')
       is_base64 = 1;
    }
    else
      *dst++ = c1;
  }
  *dst = '\0';
}

/* ----------------------------------------------------- */
/* receive article                                       */
/* ----------------------------------------------------- */

/* process post write */
bbspost_write_post(fh, board, filename)
  int fh;
  char *board;
  char *filename;
{
  char *fptr, *ptr;
  FILE *fhfd = fdopen(fh, "w");

  if (fhfd == NULL)
  {
    bbslog("can't fdopen, maybe disk full\n");
    return -1;
  }

  fprintf(fhfd, "oHH: %.60s, ݪO: %s\n", FROM, board);
  fprintf(fhfd, "  D: %.70s\n", SUBJECT);
  fprintf(fhfd, "oH: %.43s (%s)\n", SITE, DATE);
  fprintf(fhfd, "H: %.70s\n", PATH);

#ifndef MapleBBS
  if (POSTHOST != NULL)
  {
    fprintf(fhfd, "Origin: %.70s\n", POSTHOST);
  }
#endif

  fprintf(fhfd, "\n");
  for (fptr = BODY, ptr = strchr(fptr, '\r'); ptr != NULL && *ptr != '\0'; fptr = ptr + 1, ptr = strchr(fptr, '\r'))
  {
    int ch = *ptr;
    *ptr = '\0';
    fputs(fptr, fhfd);
    *ptr = ch;
  }
  fputs(fptr, fhfd);

  fflush(fhfd);
  fclose(fhfd);
  return 0;
}

#ifdef  KEEP_NETWORK_CANCEL
/* process cancel write */
bbspost_write_cancel(fh, board, filename)
  int fh;
  char *board, *filename;
{
  char *fptr, *ptr;
  FILE *fhfd = fdopen(fh, "w"), *fp;
  char buffer[256];

  if (fhfd == NULL)
  {
    bbslog("can't fdopen, maybe disk full\n");
    return -1;
  }

  fprintf(fhfd, "oHH: %s, H: %s\n", FROM, board);
  fprintf(fhfd, "  D: %s\n", SUBJECT);
  fprintf(fhfd, "oH: %.43s (%s)\n", SITE, DATE);
  fprintf(fhfd, "H: %.70s\n", PATH);
  if (HEADER[CONTROL_H] != NULL)
  {
    fprintf(fhfd, "Control: %s\n", HEADER[CONTROL_H]);
  }
  if (POSTHOST != NULL)
  {
    fprintf(fhfd, "Origin: %s\n", POSTHOST);
  }
  fprintf(fhfd, "\n");
  for (fptr = BODY, ptr = strchr(fptr, '\r'); ptr != NULL && *ptr != '\0'; fptr = ptr + 1, ptr = strchr(fptr, '\r'))
  {
    int ch = *ptr;
    *ptr = '\0';
    fputs(fptr, fhfd);
    *ptr = ch;
  }
  fputs(fptr, fhfd);
  if (POSTHOST != NULL)
  {
    fprintf(fhfd, "\n * Origin:  %.26s  From: %.40s\n", SITE, POSTHOST);
  }
  fprintf(fhfd, "\n---------------------\n");
  fp = fopen(filename, "r");
  if (fp == NULL)
  {
    bbslog("can't open %s\n", filename);
    return -1;
  }
  while (fgets(buffer, sizeof buffer, fp) != NULL)
  {
    fputs(buffer, fhfd);
  }
  fclose(fp);
  fflush(fhfd);
  fclose(fhfd);

  {
    fp = fopen(filename, "w");
    if (fp == NULL)
    {
      bbslog("can't write %s\n", filename);
      return -1;
    }
    fprintf(fp, "oHH: %s, H: %s\n", FROM, board);
    fprintf(fp, "  D: %.70s\n", SUBJECT);
    fprintf(fp, "oH: %.43s (%s)\n", SITE, DATE);
    fprintf(fp, "H: %.70s\n", PATH);
    if (POSTHOST != NULL)
    {
      fprintf(fhfd, "Origin: %s\n", POSTHOST);
    }
    if (HEADER[CONTROL_H] != NULL)
    {
      fprintf(fhfd, "Control: %s\n", HEADER[CONTROL_H]);
    }
    fprintf(fp, "\n");
    for (fptr = BODY, ptr = strchr(fptr, '\r'); ptr != NULL && *ptr != '\0'; fptr = ptr + 1, ptr = strchr(fptr, '\r'))
    {
      *ptr = '\0';
      fputs(fptr, fp);
    }
    fputs(fptr, fp);
    if (POSTHOST != NULL)
    {
      fprintf(fp, "\n * Origin:  %.26s  From: %.40s\n", SITE, POSTHOST);
    }
    fclose(fp);
  }
  return 0;
}
#endif


bbspost_write_control(fh, board, filename)
  int fh;
  char *board;
  char *filename;
{
  char *fptr, *ptr;
  FILE *fhfd = fdopen(fh, "w");

  if (fhfd == NULL)
  {
    bbslog("can't fdopen, maybe disk full\n");
    return -1;
  }

  fprintf(fhfd, "Path: %s!%s\n", MYBBSID, HEADER[PATH_H]);
  fprintf(fhfd, "From: %s\n", FROM);
  fprintf(fhfd, "Newsgroups: %s\n", GROUPS);
  fprintf(fhfd, "Subject: %s\n", SUBJECT);
  fprintf(fhfd, "Date: %s\n", DATE);
  fprintf(fhfd, "Organization: %s\n", SITE);
  if (POSTHOST != NULL)
  {
    fprintf(fhfd, "NNTP-Posting-Host: %.70s\n", POSTHOST);
  }
  if (HEADER[CONTROL_H] != NULL)
  {
    fprintf(fhfd, "Control: %s\n", HEADER[CONTROL_H]);
  }
  if (HEADER[APPROVED_H] != NULL)
  {
    fprintf(fhfd, "Approved: %s\n", HEADER[APPROVED_H]);
  }
  if (HEADER[DISTRIBUTION_H] != NULL)
  {
    fprintf(fhfd, "Distribution: %s\n", HEADER[DISTRIBUTION_H]);
  }
  fprintf(fhfd, "\n");
  for (fptr = BODY, ptr = strchr(fptr, '\r'); ptr != NULL && *ptr != '\0'; fptr = ptr + 1, ptr = strchr(fptr, '\r'))
  {
    int ch = *ptr;
    *ptr = '\0';
    fputs(fptr, fhfd);
    *ptr = ch;
  }
  fputs(fptr, fhfd);


  fflush(fhfd);
  fclose(fhfd);
  return 0;
}


time_t datevalue;


/* process cancel write */
receive_article()
{
  char *user, *userptr;
  char *ngptr, *nngptr, *pathptr;
  char **splitptr;
  static char userid[32];
  static char xdate[32];
  static char xpath[180];
  newsfeeds_t *nf;
  char *boardhome;
  char hispaths[4096], buf[MAXPATHLEN];
  char firstpath[MAXPATHLEN], *firstpathbase;
  char *lesssym, *nameptrleft, *nameptrright;
  static char sitebuf[80];

  if (FROM == NULL)
  {
    bbslog(":Err: article without usrid %s\n", MSGID);
    return 0;
  }
  user = (char *) strchr(FROM, '@');
  lesssym = (char *) strchr(FROM, '<');
  nameptrleft = NULL, nameptrright = NULL;
  if (lesssym == NULL || lesssym >= user)
  {
    lesssym = FROM;
    nameptrleft = strchr(FROM, '(');
    if (nameptrleft != NULL)
      nameptrleft++;
    nameptrright = strrchr(FROM, ')');
  }
  else
  {
    nameptrleft = FROM;
    nameptrright = strrchr(FROM, '<');
    lesssym++;
  }
  if (user != NULL)
  {
    *user = '\0';
    userptr = (char *) strchr(FROM, '.');
    if (userptr != NULL)
    {
      *userptr = '\0';
      strncpy(userid, lesssym, sizeof userid);
      *userptr = '.';
    }
    else
    {
      strncpy(userid, lesssym, sizeof userid);
    }
    *user = '@';
  }
  else
  {
    strncpy(userid, lesssym, sizeof userid);
  }
  strcat(userid, ".");
  datevalue = parsedate(DATE, NULL);

  if (datevalue > 0)
  {
    char *p;
    strncpy(xdate, ctime(&datevalue), sizeof(xdate));
    p = (char *) strchr(xdate, '\n');
    if (p != NULL)
      *p = '\0';
    DATE = xdate;
  }

#ifdef  DECODE
  if (SITE) str_decode(SITE, SITE);
#endif

  if (SITE && !strcasecmp("Computer Science & Information Engineering NCTU", SITE))
  {
    SITE = "ju News Server";
  }
  else if (SITE && !strcasecmp("Dep. Computer Sci. & Information Eng., Chiao Tung Univ., Taiwan, R.O.C",SITE))
  {
    SITE = "ju News Server";
  }
  else if (SITE && !strcasecmp("Dep. of Management Sci. National Chao-Tung University, Taiwan",SITE))
  {
    SITE = "jެ News Server";
  }
  else if (SITE && !strcasecmp("National Tsing Hua Univ. Computing Centre, Taiwan",SITE))
  {
    SITE = "Mؤj News Server";
  }
  else if (SITE && !strcasecmp("Dep. Comp.Sci.&Info.Eng., Chiao Tung Univ., Taiwan, R.O.C.",SITE))
  {
    SITE = "ju News Server";
  }
  else if (SITE && !strcasecmp("NCTU CSIE FreeBSD Server",SITE))
  {
    SITE = "ju FreeBSD Server";
  }
  else if (SITE && !strcasecmp("National Taiwan University",SITE))
  {
    SITE = "xWj News Server";
  }
  else if (SITE && !strcasecmp("CHPI PowerBBS Original Station (ؤuǰ|諰T)",SITE))
  {
    SITE = "ؤuǰ|諰T";
  }
  else if (SITE && !strcasecmp("National Tsing Hua Univ. Computing Centre, Taiwan",SITE))
  {
    SITE = "Mؤj News Server";
  }
  else if (SITE && !strcasecmp("National Sun Yat-san University, Taiwan",SITE))
  {
    SITE = "sj News Server";
  }
  else if (SITE && !strcasecmp("National Chung Hsing University Computer Center",SITE))
  {
    SITE = "j News Server";
  }
  else if (SITE && !strcasecmp("Dept. of Computer & Information Science, NCTU, Taiwan",SITE))
  {
    SITE = "j News Server";
  }
  else if (SITE && !strcasecmp("Dept. Comp. Sci. & Info. Eng., Chiao-Tung Univ., Taiwan",SITE))
  {
    SITE = "ju News Server";
  }
  else if (SITE && !strcasecmp("Feng Chia University",SITE))
  {
    SITE = "{Ҥj News Server";
  }
  else if (SITE && !strcasecmp("National Chung Cheng Univ.,Min-Shung,Chiayi,Taiwan,R.O.C",SITE))
  {
    SITE = "j News Server";
  }
/*
  else if (SITE && !strcasecmp("",SITE))
  {
    SITE = "";
  }
*/
  else if (SITE == NULL || *SITE == '\0')
  {
    if (nameptrleft != NULL && nameptrright != NULL)
    {
      char savech = *nameptrright;
      *nameptrright = '\0';
      strncpy(sitebuf, nameptrleft, sizeof sitebuf);
      *nameptrright = savech;
      SITE = sitebuf;
    }
    else
      /* SITE = "(Unknown)"; */
      SITE = "";
  }

  if (strlen(MYBBSID) > 70)
  {
    bbslog(" :Err: your bbsid %s too long\n", MYBBSID);
    return 0;
  }

  sprintf(xpath, "%s!%.*s", MYBBSID, sizeof(xpath) - strlen(MYBBSID) - 2, PATH);
  PATH = xpath;
  for (pathptr = PATH; pathptr != NULL && (pathptr = strstr(pathptr, ".edu.tw")) != NULL;)
  {
    if (pathptr != NULL)
    {
      strcpy(pathptr, pathptr + 7);
    }
  }
  xpath[71] = '\0';

#ifndef MapleBBS
  echomaillog();
#endif

  *hispaths = '\0';
  splitptr = (char **) BNGsplit(GROUPS);
  firstpath[0] = '\0';
  firstpathbase = firstpath;
  /*
   * try to split newsgroups into separate group and check if any duplicated
   */

  /* try to use hardlink */
  /*
   * for ( ngptr = GROUPS, nngptr = (char*) strchr(ngptr,','); ngptr != NULL
   * && *ngptr != '\0'; nngptr = (char*)strchr(ngptr,',')) {
   */
  for (ngptr = *splitptr; ngptr != NULL; ngptr = *(++splitptr))
  {
    char *boardptr, *nboardptr;

    /*
     * if (nngptr != NULL) { nngptr = '\0'; }
     */
    if (*ngptr == '\0')
      continue;
    nf = (newsfeeds_t *) search_group(ngptr);
    /* printf("board %s\n",nf->board); */
    if (nf == NULL)
    {
      bbslog("unwanted \'%s\'\n", ngptr);
      /*
       * if( strstr( ngptr, "tw.bbs" ) != NULL ) { }
       */
      continue;
    }
    if (nf->board == NULL || !*nf->board)
      continue;
    if (nf->path == NULL || !*nf->path)
      continue;
    for (boardptr = nf->board, nboardptr = (char *) strchr(boardptr, ','); boardptr != NULL && *boardptr != '\0'; nboardptr = (char *) strchr(boardptr, ','))
    {
      if (nboardptr != NULL)
      {
        *nboardptr = '\0';
      }
      if (*boardptr == '\t')
      {
        goto boardcont;
      }
      boardhome = (char *) fileglue("%s/boards/%s", BBSHOME, boardptr);
      if (!isdir(boardhome))
      {
        bbslog(":Err: unable to write %s\n", boardhome);
      }
      else
      {
        char *fname;
        /*
         * if ( !isdir( boardhome )) { bbslog( ":Err: unable to write
         * %s\n",boardhome); testandmkdir(boardhome); }
         */
        fname = (char *) post_article(boardhome, userid, boardptr, bbspost_write_post, NULL, firstpath);
        if (fname != NULL)
        {
          fname = (char *) fileglue("%s/%s", boardptr, fname);
          if (firstpath[0] == '\0')
          {
            sprintf(firstpath, "%s/boards/%s", BBSHOME, fname);
            firstpathbase = firstpath + strlen(BBSHOME) + strlen("/boards/");
          }
          if (strlen(fname) + strlen(hispaths) + 1 < sizeof(hispaths))
          {
            strcat(hispaths, fname);
            strcat(hispaths, " ");
          }
        }
        else
        {
          bbslog("r_a: fname is null %s\n", boardhome);
        return 0;
        }
      }

  boardcont:
      if (nboardptr != NULL)
      {
        *nboardptr = ',';
        boardptr = nboardptr + 1;
      }
      else
        break;

    }                           /* for board1,board2,... */
    /*
     * if (nngptr != NULL) ngptr = nngptr + 1; else break;
     */
    if (*firstpathbase)
      feedfplog(nf, firstpathbase, 'P');
  }
  if (*hispaths)
    bbsfeedslog(hispaths, 'P');

  if (Junkhistory || *hispaths)
  {
    if (storeDB(HEADER[MID_H], hispaths) < 0)
    {
      bbslog("store DB fail\n");
      /* I suspect here will introduce duplicated articles */
      /* return -1; */
    }
  }
  return 0;
}

receive_control()
{
  char *boardhome, *fname;
  char firstpath[MAXPATHLEN], *firstpathbase;
  char **splitptr, *ngptr;
  newsfeeds_t *nf;

  bbslog("control post %s\n", HEADER[CONTROL_H]);
  boardhome = (char *) fileglue("%s/boards/control", BBSHOME);
  testandmkdir(boardhome);
  *firstpath = '\0';
  if (isdir(boardhome))
  {
    fname = (char *) post_article(boardhome, FROM, "control", bbspost_write_control, NULL, firstpath);
    if (fname != NULL)
    {
      if (firstpath[0] == '\0')
        sprintf(firstpath, "%s/boards/control/%s", BBSHOME, fname);
      if (storeDB(HEADER[MID_H], (char *) fileglue("control/%s", fname)) < 0)
      {
      }
      bbsfeedslog(fileglue("control/%s", fname), 'C');
      firstpathbase = firstpath + strlen(BBSHOME) + strlen("/boards/");
      splitptr = (char **) BNGsplit(GROUPS);
      for (ngptr = *splitptr; ngptr != NULL; ngptr = *(++splitptr))
      {
        if (*ngptr == '\0')
          continue;
        nf = (newsfeeds_t *) search_group(ngptr);
        if (nf == NULL)
          continue;
        if (nf->board == NULL)
          continue;
        if (nf->path == NULL)
          continue;
        feedfplog(nf, firstpathbase, 'C');
      }
    }
  }
  return 0;
}

cancel_article_front(msgid)
  char *msgid;
{
  char *ptr = (char *) DBfetch(msgid);
  char *filelist, filename[2048];
  char histent[4096];
  char firstpath[MAXPATHLEN], *firstpathbase;
  if (ptr == NULL)
  {
    bbslog("cancel failed(DBfetch): %s\n", msgid);
    return 0;
  }
  strncpy(histent, ptr, sizeof histent);
  ptr = histent;

#ifdef DEBUG
  printf("**** try to cancel %s *****\n", ptr);
#endif

  filelist = strchr(ptr, '\t');
  if (filelist != NULL)
  {
    filelist++;
  }
  *firstpath = '\0';
  for (ptr = filelist; ptr && *ptr;)
  {
    char *file;
    for (; *ptr && isspace(*ptr); ptr++);
    if (*ptr == '\0')
      break;
    file = ptr;
    for (ptr++; *ptr && !isspace(*ptr); ptr++);
    if (*ptr != '\0')
    {
      *ptr++ = '\0';
    }
    sprintf(filename, "%s/boards/%s", BBSHOME, file);
    bbslog("cancel post %s\n", filename);
    if (isfile(filename))
    {
      FILE *fp = fopen(filename, "r");
      char buffer[1024];
      char xfrom0[100], xfrom[100], xpath[1024], *boardhome;

      if (fp == NULL)
        continue;
      strncpy(xfrom0, HEADER[FROM_H], 99);
      xfrom0[99] = 0;
      strtok(xfrom0, ", ");
      while (fgets(buffer, sizeof buffer, fp) != NULL)
      {
        char *hptr;
        if (buffer[0] == '\n')
          break;
        hptr = strchr(buffer, '\n');
        if (hptr != NULL)
          *hptr = '\0';
        if (strncmp(buffer, "oHH: ", 8) == 0)
        {
          strncpy(xfrom, buffer + 8, 99);
          xfrom[99] = 0;
          strtok(xfrom, ", ");
        }
        else if (strncmp(buffer, "H: ", 8) == 0)
        {
          strcpy(xpath, buffer + 8);
        }
      }
      fclose(fp);
      if (strcmp(xfrom0, xfrom) && !search_issuer(FROM))
      {
        bbslog("Invalid cancel %s, path: %s!%s, [`%s` != `%s`]\n",
           FROM, MYBBSID, PATH, xfrom0, xfrom);
        return 0;
      }

#ifdef  KEEP_NETWORK_CANCEL
      bbslog("cancel post %s\n", filename);
      boardhome = (char *) fileglue("%s/boards/deleted", BBSHOME);
      testandmkdir(boardhome);
      if (isdir(boardhome))
      {
        char subject[1024];
        char *fname;
        if (POSTHOST)
        {
          sprintf(subject, "cancel by: %.1000s", POSTHOST);
        }
        else
        {
          char *body, *body2;
          body = strchr(BODY, '\r');
          if (body != NULL)
            *body = '\0';
          body2 = strchr(BODY, '\n');
          if (body2 != NULL)
            *body = '\0';
          sprintf(subject, "%.1000s", BODY);
          if (body != NULL)
            *body = '\r';
          if (body2 != NULL)
            *body = '\n';
        }
        if (*subject)
          SUBJECT = subject;
        fname = (char *) post_article(boardhome, FROM, "deleted", bbspost_write_cancel, filename, firstpath);
        if (fname != NULL)
        {
          if (firstpath[0] == '\0')
          {
            sprintf(firstpath, "%s/boards/deleted/%s", BBSHOME, fname);
            firstpathbase = firstpath + strlen(BBSHOME) + strlen("/boards/");
          }
          if (storeDB(HEADER[MID_H], (char *) fileglue("deleted/%s", fname)) < 0)
          {
            /* should do something */
            bbslog("store DB fail\n");
            /* return -1; */
          }
          bbsfeedslog(fileglue("deleted/%s", fname), 'D');

#ifdef OLDDISPATCH
          {
            char board[256];
            newsfeeds_t *nf;
            char *filebase = filename + strlen(BBSHOME) + strlen("/boards/");
            char *filetail = strrchr(filename, '/');
            if (filetail != NULL)
            {
              strncpy(board, filebase, filetail - filebase);
              nf = (newsfeeds_t *) search_board(board);
              if (nf != NULL && nf->board && nf->path)
              {
                feedfplog(nf, firstpathbase, 'D');
              }
            }
          }
#endif
        }
        else
        {
          bbslog("c_a_f: fname is null %s %s\n", boardhome, filename);
          return -1;
        }
      }
#else
      /* bbslog("**** %s should be removed\n", filename); */
/*
      unlink(filename);
*/
#endif

      {
        char *fp = strrchr(file, '/');
        if (fp != NULL)
        {
          *fp = '\0';
          cancel_article(BBSHOME, file, fp + 1);
          *fp = '/';
        }
      }
    }
  }
  if (*firstpath)
  {
    char **splitptr, *ngptr;
    newsfeeds_t *nf;
    splitptr = (char **) BNGsplit(GROUPS);
    for (ngptr = *splitptr; ngptr != NULL; ngptr = *(++splitptr))
    {
      if (*ngptr == '\0')
        continue;
      nf = (newsfeeds_t *) search_group(ngptr);
      if (nf == NULL)
        continue;
      if (nf->board == NULL)
        continue;
      if (nf->path == NULL)
        continue;
      feedfplog(nf, firstpathbase, 'D');
    }
  }
  return 0;
}


#if defined(PhoenixBBS) || defined(SecretBBS) || defined(PivotBBS) || defined(MapleBBS)
/* for PhoenixBBS's post article and cancel article */
#include "bbs.h"


char *
post_article(homepath, userid, board, writebody, pathname, firstpath)
  char *homepath;
  char *userid, *board;
  int (*writebody) ();
char *pathname, *firstpath;
{
  struct userec record;
  struct fileheader header;
  char *subject = SUBJECT;
  char index[MAXPATHLEN];
  static char name[MAXPATHLEN];
  char article[MAXPATHLEN];
  char buf[MAXPATHLEN], *ptr;
  FILE *fidx;
  int fh;
  time_t now;
  int linkflag;

#ifdef  DECODE
  str_decode(subject, subject);
#endif

#ifdef  CHECK_BAD_POST
 //if(dbt_board(board)){
  if(bad_post(FROM)){
        bbslog("bad_post: %s, FROM: %s\n", board, FROM);
        return NULL;}
  if(bad_post(NNTPHOST)){
        bbslog("bad_post: %s, NNTPHOST: %s\n", board, NNTPHOST);
        return NULL;}
  if(bad_post(PATH)){
        bbslog("bad_post: %s, PATH: %s\n", board, PATH);
        return NULL;}
  if(bad_post(subject)){
        bbslog("bad_post: %s, SUBJECT: %s\n", board, subject);
        return NULL;}
// }
  /***** add by tjm for feeling ***/
  if (dbt_board(board))
  {
	if ((strstr(SITE,"DCI HiNet")!=NULL)||
	    (strstr(SITE,"SEEDNet")!=NULL)||(strstr(SITE,"ETHOME")!=NULL)
	    ||(strstr(SITE,"ISnews")!=NULL)||(strstr(SITE,"Ht.net news")!=NULL))
	{
		bbslog("bad_post: %s, SITE: %s %s\n", board, SITE,subject);
		return NULL;
	}
	//else
	//	bbslog("ok_post: %s, NNTPHOST: %s\n", board, NNTPHOST);
  }
#endif

#ifdef  STRIP_ANSI
  strip_ansi(buf, subject);
  strcpy(subject, buf);
#endif

  sprintf(index, "%s/.DIR", homepath);
  if ((fidx = fopen(index, "r")) == NULL)
  {
    if ((fidx = fopen(index, "w")) == NULL)
    {
      bbslog(":Err: Unable to post in %s.\n", homepath);
      return NULL;
    }
  }
  fclose(fidx);

  now = time(NULL);
  while (1)
  {
    sprintf(name, "M.%d.A", ++now);
    sprintf(article, "%s/%s", homepath, name);
    fh = open(article, O_CREAT | O_EXCL | O_WRONLY, 0644);
    if (fh >= 0)
      break;
    if (errno != EEXIST)
    {
      bbslog(" Err: can't writable or other errors\n");
      return NULL;
    }
  }

#ifdef DEBUG
  printf("post to %s\n", article);
#endif

  linkflag = 1;
  if (firstpath && *firstpath)
  {
    close(fh);
    unlink(article);

#ifdef DEBUGLINK
    bbslog("try to link %s to %s", firstpath, article);
#endif

    linkflag = link(firstpath, article);
    if (linkflag)
    {
      fh = open(article, O_CREAT | O_EXCL | O_WRONLY, 0644);
    }
  }
  if (linkflag)
  {
    if (writebody)
    {
      if ((*writebody) (fh, board, pathname) < 0)
        return NULL;
    }
    else
    {
      if (bbspost_write_post(fh, board, pathname) < 0)
        return NULL;
    }
    close(fh);
  }

  bzero((void *) &header, sizeof(header));

#ifndef MapleBBS
  strcpy(header.filename, name);
  strncpy(header.owner, userid, IDLEN);
  strncpy(header.title, subject, STRLEN);
  header.filename[STRLEN - 1] = 'M';
#else

  strcpy(header.filename, name);
  if (userid[IDLEN])
    strcpy(&userid[IDLEN], ".");
  strcpy(header.owner, userid);
  strncpy(header.title, subject, TTLEN);
  header.savemode = 'M';
  {
    struct tm *ptime;
    ptime = localtime(&datevalue);
    sprintf(header.date, "%2d/%02d", ptime->tm_mon + 1, ptime->tm_mday);
  }
#endif

  append_record(index, &header, sizeof(header));
  return name;
}

/*
woju
Cross-fs rename()
*/

Rename(char* src, char* dst)
{
   char cmd[200];

   bbslog("Rename: %s -> %s\n", src, dst);
   if (rename(src, dst) == 0)
      return 0;

   sprintf(cmd, "/bin/mv %s %s", src, dst);
   return system(cmd);
}


cancelpost(fileheader *fhdr, char* boardname)
{
  int fd;
  char fpath[MAXPATHLEN];

  sprintf(fpath, BBSHOME "/boards/%s/%s", boardname, fhdr->filename);
  if ((fd = open(fpath, O_RDONLY)) >= 0) {
    fileheader postfile;
    char fn2[MAXPATHLEN] = BBSHOME "/boards/deleted", *junkdir;

    stampfile(fn2, &postfile);
    memcpy(postfile.owner, fhdr->owner, IDLEN + TTLEN + 10);
    postfile.savemode = 'D';
    close(fd);
    Rename(fpath, fn2);
    strcpy(strrchr(fn2, '/') + 1, ".DIR");
    append_record(fn2, &postfile, sizeof(postfile));
  }
  else
     bbslog("cancelpost: %s opened error\n", fpath);
}


/* ---------------------------- */
/* new/old/lock file processing */
/* ---------------------------- */

typedef struct
{
  char newfn[MAXPATHLEN];
  char oldfn[MAXPATHLEN];
  char lockfn[MAXPATHLEN];
}      nol;


static void
nolfilename(n, fpath)
  nol *n;
  char *fpath;
{
  sprintf(n->newfn, "%s.new", fpath);
  sprintf(n->oldfn, "%s.old", fpath);
  sprintf(n->lockfn, "%s.lock", fpath);
}



int
delete_record(char *fpath, int size, int id)
{
  nol my;
  char abuf[BUFSIZE];
  int fdr, fdw, fd;
  int count;
  fileheader fhdr;

  nolfilename(&my, fpath);

  if ((fd = open(my.lockfn, O_RDWR | O_CREAT | O_APPEND, 0644)) == -1)
    return -1;
  flock(fd, LOCK_EX);

  if ((fdr = open(fpath, O_RDONLY, 0)) == -1)
  {

#ifdef  HAVE_REPORT
    report("delete_record failed!!! (open)");
#endif

    flock(fd, LOCK_UN);
    close(fd);
    return -1;
  }
  if ((fdw = open(my.newfn, O_WRONLY | O_CREAT | O_EXCL, 0644)) == -1)
  {
    flock(fd, LOCK_UN);

#ifdef  HAVE_REPORT
    report("delete_record failed!!! (open tmpfile)");
#endif

    close(fd);
    close(fdr);
    return -1;
  }
  count = 1;
  while (read(fdr, abuf, size) == size)
  {
    if (id == count) {
       memcpy(&fhdr, abuf, sizeof(fhdr));
       bbslog("delete_record: %d, %s, %s\n",  count, fhdr.owner, fhdr.title);
    }
    if (id != count++ && (safewrite(fdw, abuf, size) == -1))
    {

      bbslog("delete_record: %s failed!!! (safewrite)\n", fpath);
#ifdef  HAVE_REPORT
      report("delete_record failed!!! (safewrite)");
#endif

      unlink(my.newfn);
      close(fdr);
      close(fdw);
      flock(fd, LOCK_UN);
      close(fd);
      return -1;
    }
  }
  close(fdr);
  close(fdw);
  if (Rename(fpath, my.oldfn) == -1 || Rename(my.newfn, fpath) == -1)
  {

#ifdef  HAVE_REPORT
    report("delete_record failed!!! (Rename)");
#endif

    flock(fd, LOCK_UN);
    close(fd);
    return -1;
  }
  flock(fd, LOCK_UN);
  close(fd);
  return 0;
}

cancel_article(homepath, board, file)
  char *homepath;
  char *board, *file;
{
  struct fileheader header;
  struct stat state;
  char dirname[MAXPATHLEN];
  char buf[MAXPATHLEN];
  long numents, size, time, now;
  int fd, lower, ent;


  if (file == NULL || file[0] != 'M' || file[1] != '.' ||
    (time = atoi(file + 2)) <= 0) {
    bbslog("cancel_article: invalid filename `%s`\n", file);
    return 0;
  }
  size = sizeof(header);
  sprintf(dirname, "%s/boards/%s/.DIR", homepath, board);
  if ((fd = open(dirname, O_RDONLY)) == -1) {
    bbslog("cancel_article: open `%s` error\n", dirname);
    return 0;
  }
  fstat(fd, &state);
  ent = ((long) state.st_size) / size;
  lower = 0;
  while (1)
  {
    ent -= 8;
    if (ent <= 0 || lower >= 2)
      break;
    lseek(fd, size * ent, SEEK_SET);
    if (read(fd, &header, size) != size)
    {
      ent = 0;
      break;
    }
    now = atoi(header.filename + 2);
    lower = (now < time) ? lower + 1 : 0;
  }
  if (ent < 0)
    ent = 0;
  while (read(fd, &header, size) == size)
  {
    if (strcmp(file, header.filename) == 0)
    {
       if ((header.filemode & FILE_MARKED)
           || (header.filemode & FILE_DIGEST) || (header.owner[0] == '-'))
          break;
       delete_record(dirname, sizeof(fileheader), lseek(fd, 0, SEEK_CUR) / size);
       cancelpost(&header, board);
       break;
    }
    now = atoi(header.filename + 2);
    if (now > time)
      break;
  }
  close(fd);
  return 0;
}

#elif defined(PalmBBS)
# undef PATH XPATH
# undef HEADER XHEADER
#include "server.h"

char *
post_article(homepath, userid, board, writebody, pathname, firstpath)
  char *homepath;
  char *userid, *board;
  int (*writebody) ();
char *pathname, *firstpath;
{
  PATH msgdir, msgfile;
  static PATH name;

  READINFO readinfo;
  SHORT fileid;
  char buf[MAXPATHLEN];
  struct stat stbuf;
  int fh;

  strcpy(msgdir, homepath);
  if (stat(msgdir, &stbuf) == -1 || !S_ISDIR(stbuf.st_mode))
  {
    /* A directory is missing! */
    bbslog(":Err: Unable to post in %s.\n", msgdir);
    return NULL;
  }
  get_filelist_ids(msgdir, &readinfo);

  for (fileid = 1; fileid <= BBS_MAX_FILES; fileid++)
  {
    int oumask;
    if (test_readbit(&readinfo, fileid))
      continue;
    fileid_to_fname(msgdir, fileid, msgfile);
    sprintf(name, "%04x", fileid);

#ifdef DEBUG
    printf("post to %s\n", msgfile);
#endif

    if (firstpath && *firstpath)
    {

#ifdef DEBUGLINK
      bbslog("try to link %s to %s", firstpath, msgfile);
#endif

      if (link(firstpath, msgfile) == 0)
        break;
    }
    oumask = umask(0);
    fh = open(msgfile, O_CREAT | O_EXCL | O_WRONLY, 0664);
    umask(oumask);
    if (writebody)
    {
      if ((*writebody) (fh, board, pathname) < 0)
        return NULL;
    }
    else
    {
      if (bbspost_write_post(fh, board, pathname) < 0)
        return NULL;
    }
    close(fh);
    break;
  }

#ifdef CACHED_OPENBOARD
  {
    char *bname;
    bname = strrchr(msgdir, '/');
    if (bname)
      notify_new_post(++bname, 1, fileid, stbuf.st_mtime);
  }
#endif

  return name;
}

cancel_article(homepath, board, file)
  char *homepath;
  char *board, *file;
{
  PATH fname;

#ifdef  CACHED_OPENBOARD
  PATH bdir;
  struct stat stbuf;

  sprintf(bdir, "%s/boards/%s", homepath, board);
  stat(bdir, &stbuf);
#endif

  sprintf(fname, "%s/boards/%s/%s", homepath, board, file);
  unlink(fname);
  /* kill it now! the function is far small then original..  :) */
  /* because it won't make system load heavy like before */

#ifdef CACHED_OPENBOARD
  notify_new_post(board, -1, hex2SHORT(file), stbuf.st_mtime);
#endif
}

#else
error("You should choose one of the systems: PhoenixBBS, PowerBBS, or PalmBBS")
#endif

#else

receive_article()
{
}

cancel_article_front(msgid)
  char *msgid;
{
}
#endif
