/*-------------------------------------------------------*/
/* announce.c	( NTHU CS MapleBBS Ver 2.36 )		 */
/*-------------------------------------------------------*/
/* target : ذϾ\ŪBs				 */
/* create : 95/03/29				 	 */
/* update : 95/12/15				 	 */
/*-------------------------------------------------------*/
/*
 * $Log: announce.c,v $
 * Revision 1.3  1996/08/27 15:30:39  bbsroot
 * Bug fixed: BM was not recognised in previous version. Hence BM cannot
 * maintain the Announce file directories. Now BM can (only) maintain them
 * by entering the Announce function through their own boards.
 *
 * Revision 1.2  1996/08/26 15:40:06  bbsroot
 * Working version with access control.
 *
 * Revision 1.1  1996/08/24 07:33:03  bbsroot
 * Initial revision
 *
 */


#include "bbs.h"
#include <time.h>

#define MAXITEMS	1024	/* @hؿ̦hXH */
#define PATHLEN		128

#define ADDITEM		0
#define	ADDGROUP	1


enum
{
  NOBODY, MANAGER, SYSOP
};


typedef struct
{
  char title[63];
  char fdate[11];		/* [mm/dd/yyyy] */
  char fname[32];
  char access[2];
}      ITEM;


typedef struct
{
  ITEM *item[MAXITEMS];
  char mtitle[STRLEN];
  char *path;
  int num, page, now, level;
}      MENU;


static int a_fmode = 0;
static ITEM copybuf;
static char copyfile[PATHLEN];
static char *mytitle = BOARDNAME "Gi";
static char *err_dup_fn = "tΤwPWɮצsbFI";
static int a_user_access_level = 1;


static void
a_timestamp(buf, time)
  char *buf;
  time_t *time;
{
  struct tm *pt = localtime(time);
  sprintf(buf, "%02d/%02d/%04d", pt->tm_mon + 1, pt->tm_mday, 1900+pt->tm_year);
  //sprintf(buf, "%02d/%02d/%04d", pt->tm_mon + 1, pt->tm_mday, 1900+pt->tm_year);
}


static void
a_additem(pm, myitem)
  MENU *pm;
  ITEM *myitem;
{
  if (pm->num < MAXITEMS)
  {
    ITEM *newitem = (ITEM *) malloc(sizeof(ITEM));
    memcpy(newitem, myitem, sizeof(ITEM));
    pm->item[(pm->num)++] = newitem;
  }
}


static void
a_savenames(pm)
  MENU *pm;
{
  FILE *fn;
  ITEM *item;
  char fpath[PATHLEN];
  int n;

  sprintf(fpath, "%s%s", pm->path, fn_mandex);
  if (fn = fopen(fpath, "w"))
  {
    fprintf(fn, "# Title=%s\n\n", pm->mtitle);
    n = 0;
    while (n < pm->num)
    {
      item = pm->item[n++];
      fprintf(fn, "Name=%s\nDate=%s\nAccess=%s\nPath=%s\n\n",
	item->title, item->fdate, item->access, item->fname);
    }
    fclose(fn);
    chmod(fpath, 0644);
  }
}


static void
a_loadnames(pm)
  MENU *pm;
{
  FILE *fn;
  char buf[256], *ptr;
  ITEM item;
  int dirty;
  int access;

  pm->num = access = 0;
  /* access YSwqAOĤ@ŨϥΪ */
  sprintf(buf, "%s%s", pm->path, fn_mandex);
  if (fn = fopen(buf, "r"))
  {
    dirty = item.fdate[0] = 0;

    while (fgets(buf, 255, fn))
    {
      if (ptr = strchr(buf, '\n'))
	*ptr = '\0';
      ptr = buf + 5;
      if (!strncmp(buf, "Name=", 5))
      {
	strcpy(item.title, ptr);
      }
      else if (!strncmp(buf, "Date=", 5))
      {
	strcpy(item.fdate, ptr);
      }
      /*** GHU if statement btíwih -- oO۰ʥh "~/" */
      else if (!strncmp(buf, "Path=~/", 7))
      {
	dirty = 2;		/* TO|s .Names ɮ */
	strcpy(item.fname, buf + 7);
	if (item.fdate[0] == '\0')
	{
	  struct stat st;

	  sprintf(buf, "%s/%s", pm->path, item.fname);
	  if (stat(buf, &st) == 0)
	  {
	    a_timestamp(item.fdate, &st.st_mtime);
	    dirty = 2;
	  }
	}
	if (!access) {
	  sprintf(item.access, "1");
	  access = 1;
	  dirty = 2;
	}
	if (a_user_access_level >= access) {
	    a_additem(pm, &item);
	    access = 1;
	}
	item.fdate[0] = '\0';
      }
      /*** Go ******************************************************/
      else if (!strncmp(buf, "Path=", 5))
      {
	strcpy(item.fname, ptr);
	if (item.fdate[0] == '\0')
	{
	  struct stat st;

	  sprintf(buf, "%s/%s", pm->path, item.fname);
	  if (stat(buf, &st) == 0)
	  {
	    a_timestamp(item.fdate, &st.st_mtime);
	    dirty = 2;
	  }
	}
	/*** GHU if statement btíwih */
	if (!access) {		/* Swq Access= */
	  sprintf(item.access, "1");
	  access = 1;
	  dirty = 2;		/* TO|sɮ   */
	}
	/*  user ϥεŵP\Ūv */
	if (a_user_access_level >= access) {
	    a_additem(pm, &item);
	    access = 1;
	}
	item.fdate[0] = '\0';
      }
      else if (!strncmp(buf, "Access=", 7))
      {
	strcpy(item.access, buf + 7);
	item.access[1] = 0;
	access = atoi(item.access);

	/*** GHU if statement btíwih ***/
	if (!access) {		/* X{Ū Access= */
	  access = 1;		/* ]q Access=1  */
	  sprintf(item.access, "1");
	  dirty = 2;		/* TO|sɮ   */
	}
      }
      else if (!strncmp(buf, "# Title=", 8))
      {
	strcpy(pm->mtitle, buf + 8);
	dirty++;
      }
    }
    fclose(fn);

    if (pm->mtitle[0] == '\0')
      strcpy(pm->mtitle, mytitle);
    if (dirty >= 2)
      a_savenames(pm);
  }
}


static void
a_showmenu(pm)
  MENU *pm;
{
  static char *mytype[] = {"    ", "ɮצW"};
  char *title;
  int n, max;
  ITEM *item;

  showtitle("ؤ峹", pm->mtitle);
  prints("  [1;36ms          D%56s[0m", mytype[a_fmode]);

  if (pm->num)
  {
    n = pm->page;
    max = n + p_lines;
    if (max > pm->num)
      max = pm->num;
    while (n < max)
    {
      item = pm->item[n++];
      title = item->title;
      if (a_fmode)
      {
	prints("\n%5d. %-52.51s%s", n, title, item->fname);
	if (title[1] == (char) 0xbb)
	  outc('/');
      }
      else
      {

#ifdef	INFO_COLOR
	if (title[1] == (char) 0xbb)	/* JhLin: directory */
	  prints("\n%5d. [1;33m%s[0m", n, title);
	else
#endif
	  prints("\n%5d. %-60s[%s]", n, title, item->fdate);
      }
    }
  }
  else
  {
    //outs("\n  mذϡn|blѦaؤ... :)");
      outs("\n  mذϡnbVOإߤ............. :)");
  }

  move(b_lines, 1);
  outs(pm->level ?
    "[34;46m iO  Dj [31;47m  (h)[30m  [31m(q/)[30m}  [31m(a)[30msW峹  [31m(g)[30msWؿ  [31m(e)[30msɮ  [0m" :
    "[34;46m i\\j [31;47m  (h)[30m  [31m(q/)[30m}  [31m(kj)[30mʴ  [31m(enter/)[30mŪ  [0m");
}


static void
a_showhelp(level)
  int level;
{
  clear();
  outs("[36mi " BOARDNAME "Gϥλ j[m\n\n\
[][q]         }W@hؿ\n\
[][k]         W@ӿﶵ\n\
[][j]         U@ӿﶵ\n\
[][r][enter]  iJؿŪ峹\n\
[^B][PgUp]      W\n\
[^F][PgDn][Spc] U\n\
[##]            ӿﶵ\n\n\
[F]             N峹H^ Internet lc\n\
[U]             N峹 uuencode H^lc\n");

  if (level >= MANAGER)
  {
    outs("\n[36mi ODM j[m\n\
[a/g]           ؤ峹/}Pؿ\n\
[m/d]           /R峹\n\
[t/e]           ק峹D/e\n\
[f/n]           d/ɦW\n\
[c/p]           /߶K峹\n");
  }

  if (level >= SYSOP)
  {
    outs("\n[36mi M j[m\n\
[v]             s .Names\n");
  }
  pressanykey();
}


static void
a_newitem(pm, mode)
  MENU *pm;
{
  static char *mesg[2] = {
    "[sW峹] пJɮצW١G",	/* ADDITEM */
  "[sWؿ] пJؿW١G"};	/* ADDGROUP */

  char fpath[PATHLEN];
  ITEM item;
  time_t dtime;

  pm->page = 9999;
  if (!getdata(t_lines - 2, 1, mesg[mode], item.fname, 32, DOECHO))
    return;
  if (invalid_fname(item.fname))
  {
    outs(err_filename);
    igetch();
  }
  else
  {
    sprintf(fpath, "%s/%s", pm->path, item.fname);
    if (dashf(fpath) || dashd(fpath))
    {
      outs(err_dup_fn);
      igetch();
    }
    else
    {
      strcpy(item.title, " ");/* A1BA/BB  */
      if (!getdata(b_lines - 1, 1, "пJDG", &item.title[3], 60, DOECHO))
	return;
    /************  remove by tjm to reduce trouble ******
      if (pm->level == SYSOP) {
        if (!getdata(b_lines - 1, 1, "пJi\\Ū̧̳CżơG",
		item.access, 2, DOECHO))
	  return;
      } 
      else 
    *********************************************************/
      {
	sprintf(item.access, "%s", "1");	/* OD}]ɮ׬Ĥ@ťiŪ */
      }
      if (mode)
      {				/* ADDGROUP */
	mkdir(fpath, 0755);
	item.title[1] = 0xbb;
      }
      else
      {				/* ADDITEM */
	vedit(fpath, 0);
	chmod(fpath, 0644);
      }
      time(&dtime);
      a_timestamp(item.fdate, &dtime);
      a_additem(pm, &item);
      a_savenames(pm);
    }
  }
}


static void
a_moveitem(pm)
  MENU *pm;
{
  ITEM *tmp;
  char newnum[4];
  int num, n;
  char genbuf[200];

  sprintf(genbuf, "пJ %d ﶵsǡG", pm->now + 1);
  if (!getdata(b_lines - 1, 1, genbuf, newnum, 4, DOECHO))
    return;
  num = (newnum[0] == '$') ? 9999 : atoi(newnum) - 1;
  if (num >= pm->num)
    num = pm->num - 1;
  else if (num < 0)
    num = 0;
  tmp = pm->item[pm->now];
  if (num > pm->now)
  {
    for (n = pm->now; n < num; n++)
      pm->item[n] = pm->item[n + 1];
  }
  else
  {
    for (n = pm->now; n > num; n--)
      pm->item[n] = pm->item[n - 1];
  }
  pm->item[num] = tmp;
  pm->now = num;
  a_savenames(pm);
}


static void
a_delete(pm)
  MENU *pm;
{
  ITEM *item;
  char fpath[PATHLEN];
  char ans[4];
  char genbuf[200];
  int n;

  item = pm->item[pm->now];
  sprintf(fpath, "%s/%s", pm->path, item->fname);

  if (dashf(fpath))
  {
    getdata(b_lines - 1, 1, "zTwnRɮ׶(Y/N)H[N] ", ans, 3, LCECHO);
    if (ans[0] != 'y')
      return;
    /*unlink(fpath); modify by tjm */
    sprintf(genbuf,BBSHOME "/tmp/%s",item->fname);
    rename(fpath,genbuf);
  }
  else if (dashd(fpath))
  {
    getdata(b_lines - 1, 1, "zTwnRӥؿ(Y/N)H[N] ", ans, 3, LCECHO);
    if (ans[0] != 'y')
      return;
    /*  sprintf(genbuf, "/bin/rm -rf %s", fpath);
    system(genbuf); modified by tjm */
    sprintf(genbuf,BBSHOME "/tmp/%s",item->fname);
    rename(fpath,genbuf);
  }

  free(item);
  (pm->num)--;
  for (n = pm->now; n < pm->num; n++)
    pm->item[n] = pm->item[n + 1];
  a_savenames(pm);
}


static void
a_newname(pm)
  MENU *pm;
{
  ITEM *item;
  char fname[32];
  char fpath[PATHLEN];
  char *mesg;
  char genbuf[200];

  item = pm->item[pm->now];
  if (!getdata(b_lines - 1, 1, "sɦWG", fname, 32, DOECHO))
    return;
  if (invalid_fname(fname))
  {
    mesg = err_filename;
  }
  else
  {
    sprintf(fpath, "%s/%s", pm->path, fname);
    if (dashf(fname) || dashd(fname))
    {
      mesg = err_dup_fn;
    }
    else
    {
      sprintf(genbuf, "%s/%s", pm->path, item->fname);
      if (!Rename(genbuf, fpath))
      {
	strcpy(item->fname, fname);
	a_savenames(pm);
	return;
      }
      mesg = "ɦW異ѡI";
    }
  }
  outs(mesg);
  igetch();
}


static void
a_copyitem(pm)
  MENU *pm;
{
  ITEM *item;

  item = pm->item[pm->now];
  memcpy(&copybuf, item, sizeof(ITEM));
  sprintf(copyfile, "%s/%s", pm->path, copybuf.fname);
  outmsg("ɮ׼аOC[`N] ~R!");
  igetch();
}


static void
a_pasteitem(pm)
  MENU *pm;
{
  char newpath[PATHLEN];
  char ans[2];
  char genbuf[200];

  move(b_lines - 1, 1);
  if (copyfile[0])
  {
    sprintf(newpath, "%s/%s", pm->path, copybuf.fname);
    if (dashf(newpath) || dashd(newpath))
    {
      prints("ɮ/ؿpPG%s", copybuf.fname);
    }
    else if (strstr(newpath, copyfile))
    {
      outs("NؿiۤvlؿA|yLajI");
    }
    else
    {
      sprintf(genbuf, "Twn[%s](Y/N)H[N] ", copybuf.title);
      getdata(b_lines - 1, 1, genbuf, ans, 3, LCECHO);
      if (ans[0] == 'y')
      {
	if (copybuf.title[1] == (char) 0xbb)
	{
	  sprintf(genbuf, "/bin/cp -r %s %s", copyfile, newpath);
	  system(genbuf);
	}
	else
	  Link(copyfile, newpath);
	a_additem(pm, &copybuf);
	a_savenames(pm);
      }
      return;
    }
  }
  else
  {
    outs("Х copy ROA paste");
  }
  igetch();
}


static void
a_forward(path, pitem, mode)
  char *path;
  ITEM *pitem;
  int mode;
{
  fileheader fhdr;

  strcpy(fhdr.filename, pitem->fname);
  strcpy(fhdr.title, pitem->title);
  switch (doforward(path, &fhdr, mode))
  {
  case 0:
    outmsg(msg_fwd_ok);
    break;
  case -1:
    outmsg(msg_fwd_err1);
    break;
  case -2:
    outmsg(msg_fwd_err2);
    break;
  }
}


/*
woju
*/
search_title(MENU me, int rev_flag)
{
   int i;
   char buf[100];
   static char search_str[40];
   int pos;

   sprintf(buf, "%c[%s] ", rev_flag ? '?' : '/', search_str);
   getdata(b_lines - 1, 0, buf, buf, 40, DOECHO);

   if (*buf)
      strcpy(search_str, buf);

   if (!*search_str)
      return me.now;

   str_lower(buf, search_str);

   for (i = 1; i <= me.num; i++)
      if (strstr_lower(me.item[pos = (me.now + (rev_flag ? me.num - i : i)) % me.num]->title, buf))
         return pos;

   return me.now;
}



void
a_menu(maintitle, path, lastlevel)
  char *maintitle;
  char *path;
  int lastlevel;
{
  MENU me;
  char fname[PATHLEN];
  char genbuf[200];
  int ch;

  /* ----------------------------------------------------- */
  /* dߨϥΪ̪ż                                    */
  /* ----------------------------------------------------- */
  if (HAS_PERM(PERM_LEVEL3)) a_user_access_level = 3;		/* ĤT */
  else if (HAS_PERM(PERM_LEVEL2)) a_user_access_level = 2;	/* ĤG */
  else a_user_access_level = 1;					/* Ĥ@ */

  setutmpmode(ANNOUNCE);

  me.path = path;
  strcpy(me.mtitle, maintitle);
  a_loadnames(&me);

  /* ذ-tree cݩ cuser ==> BM */

  if (!(me.level = lastlevel))
  {
    char *ptr;

    a_fmode = 0;

    /***     q currBM AݨϥΪ̬O_OOD    ***/
    /* G]Lkq̤Wh .Names {ODAu  */
    /*     ѪO Z iJذϤ~{XODC */
    /*     аѾ\ Announce() function C     */
    if (ptr = strstr(currBM, "G"))
      me.level = is_BM(ptr + 2);
  }

  me.page = 9999;
  me.now = 0;
  for (;;)
  {
    if (me.now >= me.num && me.num > 0)
      me.now = me.num - 1;
    else if (me.now < 0)
      me.now = 0;

    if (me.now < me.page || me.now >= me.page + p_lines)
    {
      me.page = me.now - (me.now % p_lines);
      a_showmenu(&me);
    }

    ch = cursor_key(2 + me.now - me.page, 0);

    if (ch == 'q' || ch == 'Q' || ch == KEY_LEFT)
      break;

    if (ch >= '1' && ch <= '9')
    {
      if ((ch = search_num(ch, me.num)) != -1)
	me.now = ch;
      me.page = 9999;
      continue;
    }

    switch (ch)
    {
    case KEY_UP:
    case 'k':
      if (--me.now < 0)
	me.now = me.num - 1;
      break;

    case KEY_DOWN:
    case 'j':
      if (++me.now >= me.num)
	me.now = 0;
      break;

    case KEY_PGUP:
    case Ctrl('B'):
      if (me.now >= p_lines)
	me.now -= p_lines;
      else if (me.now > 0)
	me.now = 0;
      else
	me.now = me.num - 1;
      break;

    case ' ':
    case KEY_PGDN:
    case Ctrl('F'):
      if (me.now < me.num - p_lines)
	me.now += p_lines;
      else if (me.now < me.num - 1)
	me.now = me.num - 1;
      else
	me.now = 0;
      break;

    case '0':
       me.now = 0;
       break;
    case '?':
    case '/':
       me.now = search_title(me, ch == '?');
       me.page = 9999;
       break;
    case '$':
       me.now = me.num -1;
       break;
    case 'h':
      a_showhelp(me.level);
      me.page = 9999;
      break;
/*
woju
*/
    case Ctrl('R'): if (currutmp->msgs[0].last_pid) {
	 show_last_call_in();
	 //my_write(currutmp->msgs[0].last_pid, "Te^hG");
	 me.page = 9999;
      }
      break;

    case Ctrl('U'):
      t_users();
      me.page = 9999;
      break;
       
    case Ctrl('I'):
      t_idle();
      me.page = 9999;
      break;

    case 's':
       ReadSelect();
       me.page = 9999;
       break;

    case '\n':
    case '\r':
    case KEY_RIGHT:
    case 'r':
      if (me.now < me.num)
      {
	sprintf(fname, "%s/%s", path, me.item[me.now]->fname);
	if (dashf(fname)) {
/*
woju
*/
	  int more_result;

	  while (more_result = more(fname, YEA)) {
	     if (more_result == 1) {
                if (--me.now < 0) {
	           me.now = 0;
		   break;
		}
	     }
	     else if (more_result == 3) {
                if (++me.now >= me.num) {
	           me.now = me.num - 1;
		   break;
		}
	     }
	     else
		break;
	     sprintf(fname, "%s/%s", path, me.item[me.now]->fname);
	     if (!dashf(fname))
		break;
	  }
        }
	else if (dashd(fname))
	  a_menu(me.item[me.now]->title, fname, me.level);
	me.page = 9999;
      }
      break;

    case 'F':
    case 'U':
    case 'Z':
      sprintf(fname, "%s/%s", path, me.item[me.now]->fname);
      if (me.now < me.num && HAS_PERM(PERM_BASIC) && dashf(fname))
      {
	if (ch == 'Z')
	  z_download(fname);
	else
	  a_forward(path, me.item[me.now], ch == 'U');
      }
      else
	outmsg("LkH");
      
      me.page = 9999;
      refresh();
      sleep(1);
    }

    if (me.level >= MANAGER)
    {
      switch (ch)
      {
      case 'a':
	a_newitem(&me, ADDITEM);
	break;
      case 'g':
	a_newitem(&me, ADDGROUP);
	break;
      case 'p':
	a_pasteitem(&me);
	me.page = 9999;
      }

      if (me.num)
	switch (ch)
	{
	case 'm':
	  a_moveitem(&me);
	  me.page = 9999;
	  break;

	case 'D':
	  me.page = -1;
	case 'd':
	  a_delete(&me);
	  me.page = 9999;
	  break;

	case 't':
	  if (getdata(b_lines - 1, 1, "sDG", genbuf, 60, DOECHO))
	  {
	    ITEM *item = me.item[me.now];
	    char *p = item->title;
	
/* modify by Timothy	
	    strcpy(p + 3, genbuf);
*/
	    if (!strncmp(" ", p, 3) || !strncmp(" ", p, 3))
	    {
	    	strcpy(p+3, genbuf);
	    } else {
	    	strcpy(p, genbuf);
	    }
	    a_savenames(&me);
	    if (p[1] == (char) 0xbb)
	    {
	      FILE *fn;

	      sprintf(fname, "%s/%s%s", path, item->fname, fn_mandex);
	      if (fn = fopen(fname, "a+"))
	      {
		fprintf(fn, "\n# Title=%s\n", p);
		fclose(fn);
	      }
	    }
	  }
	  me.page = 9999;
	  break;

	case 'e':
	case 'E':
	  sprintf(fname, "%s/%s", path, me.item[me.now]->fname);
	  if (dashf(fname))
	  {
	    vedit(fname, 0);
	    me.page = 9999;
	  }
	  break;

	case 'f':
	  a_fmode ^= 1;
	  me.page = 9999;
	  break;

	case 'n':
	  a_newname(&me);
	  me.page = 9999;
	  break;

	case 'c':
	  a_copyitem(&me);
	  me.page = 9999;
	  break;
	}
    }

    if ((me.level == SYSOP) && (ch == 'v'))
    {
      sprintf(fname, "%s%s", path, fn_mandex);
      vedit(fname, 0);
      me.page = 9999;
    }
  }
  for (ch = 0; ch < me.num; ch++)
    free(me.item[ch]);
}


int
Announce()
{
  a_fmode = 0;
  currBM[0] = '\0';	/* ŪLۤvOAQ{OODAYAѥ~ Announce  */
			/* \iJذϮɡA|ܦO̤WhذϪODCo */
			/* NODC currBM = "ODGXXXX/XXXX... " MC */
  a_menu(mytitle, "man", (HAS_PERM(PERM_SYSOP) ? SYSOP : NOBODY));
  return 0;
}
