/*Ou-----------------------------------------------------*/
/* bbs.c        ( NTHU CS MapleBBS Ver 2.36 )            */
/*-------------------------------------------------------*/
/* target : bulletin boards' routines                    */
/* create : 95/03/29                                     */
/* update : 95/12/15                                     */
/*-------------------------------------------------------*/
/*
 * $Log: bbs.c,v $
 * Revision 1.2  1996/08/26 15:38:45  bbsroot
 * Bug fixed: when entering the Announce function from Board, the access
 * was not controlled in previous version.
 *
 * Revision 1.1  1996/08/26 13:54:51  bbsroot
 * Initial revision
 *
 */

#include "bbs.h"

extern int mail_reply();
extern char currdirect[64];

time_t board_note_time;
time_t board_visit_time;

static char *brd_title;
static int continue_flag;
int local_article, comfortable = 0;

#define UPDATE_USEREC   (currmode |= MODE_DIRTY)
/* substitute_record(fn_passwd, &cuser, sizeof(userec), usernum) */


static int
g_board_names(fhdr)
  boardheader *fhdr;
{
  AddNameList(fhdr->brdname);
  return 0;
}


void
make_blist()
{
  CreateNameList();
  apply_boards(g_board_names);
}


void
set_board()
{
  boardheader *bp;
  boardheader *getbcache();

  bp = getbcache(currboard);
  board_note_time = bp->bupdate;
  brd_title = bp->BM;
  if (brd_title[0] <= ' ')
    brd_title = "xD";
  sprintf(currBM, "ODG%s", brd_title);
  brd_title = (bp->bvote == 1 ? "ݪOi벼" : bp->title + 7);

  currmode = (currmode & MODE_DIRTY) | MODE_STARTED;
  if (HAS_PERM(PERM_ALLBOARD) ||
    (HAS_PERM(PERM_BM) && is_BM(currBM + 6)))
  {
    currmode |= (MODE_BOARD | MODE_POST);
  }
  else if (haspostperm(currboard) /* Ben_Perm(bp)*/)
    currmode |= MODE_POST;
}


static void
readtitle()
{
  showtitle(currBM, brd_title);
  outs("\
[]} []\\Ū [^P]o峹 [b]Ƨѿ [d]R [z]ذ [TAB]K [h]DU\n\
[7m  s      @               D                                   [0m");
}


static void
readdoent(num, ent)
  int num;
  fileheader *ent;
{
  int type;
  char *mark, *title, color;

  type = brc_unread(ent->filename) ? '+' : ' ';

  if ((currmode & MODE_BOARD) && (ent->filemode & FILE_DIGEST))
    type = (type == ' ') ? '*' : '#';
  else if (ent->filemode & FILE_MARKED)
    type = (type == ' ') ? 'm' : 'M';

  title = subject(mark = ent->title);
  if (title == mark)
  {
    color = '1';
    mark = "";
  }
  else
  {
    color = '3';
    mark = "R:";
  }

  if (title[47])
    strcpy(title + 44, " K");  /* hl string 屼 */

  if (strncmp(currtitle, title, 40))
    prints("%6d %c %-7s%-13.12s%s %s\n", num, type,
      ent->date,(!strcmp(currboard, "comfortable")) ? "         ":ent->owner, mark, title);
/*    prints("%6d %c %-7s%-13.12s%s %s\n", num, type,
      ent->date, ent->owner, mark, title);*/
  else
    prints("%6d %c %-7s%-13.12s[1;3%cm%s %s[0m\n", num, type,
      ent->date,(!strcmp(currboard, "comfortable")) ? "         ": ent->owner, color, mark, title);
/*    prints("%6d %c %-7s%-13.12s[1;3%cm%s %s[0m\n", num, type,
      ent->date, ent->owner, color, mark, title);*/
}


int
cmpbnames(bname, brec)
  char *bname;
  boardheader *brec;
{
  return (!ci_strncmp(bname, brec->brdname, sizeof(brec->brdname)));
}


int
cmpfilename(fhdr)
  fileheader *fhdr;
{
  return (!strcmp(fhdr->filename, currfile));
}


/*
woju
*/
int
cmpfmode(fhdr)
  fileheader *fhdr;
{
  return (fhdr->filemode & currfmode);
}


int
cmpfowner(fhdr)
  fileheader *fhdr;
{
  return !strcasecmp(fhdr->owner, currowner);
}



int
do_select(ent, fhdr, direct)
  int ent;
  fileheader *fhdr;
  char *direct;
{
  char bname[20];
  char bpath[60];
  struct stat st;

  move(0, 0);
  clrtoeol();
  make_blist();
  namecomplete(MSG_SELECT_BOARD, bname);

  setbpath(bpath, bname);
  if ((*bname == '\0') || (stat(bpath, &st) == -1))
  {
    move(2, 0);
    clrtoeol();
    outs(err_bid);
/*
woju
    pressanykey();
*/
    return FULLUPDATE;
  }

  board_visit_time = 0x7fffffff;
  brc_initial(bname);
  set_board();
  setbdir(direct, currboard);
  move(1, 0);
  clrtoeol();
  return NEWDIRECT;
}


/* ----------------------------------------------------- */
/* } innbbsd XHBsuHBz{             */
/* ----------------------------------------------------- */


static void
outgo_post(fh, board)
  fileheader *fh;
  char *board;
{
  FILE *foo;

  if (foo = fopen("innd/out.bntp", "a"))
  {
    fprintf(foo, "%s\t%s\t%s\t%s\t%s\n", board,
      fh->filename, cuser.userid, cuser.username, fh->title);
    fclose(foo);
  }
}

void
cancelpost(fhdr, by_BM)
  fileheader *fhdr;
  int by_BM;
{
  int fd;
  char fpath[STRLEN];

  setbfile(fpath, currboard, fhdr->filename);
  if ((fd = open(fpath, O_RDONLY)) >= 0) {
#define NICK_LEN        80
    char *ptr, *left, *right, nick[NICK_LEN + 1];
    FILE *fout;
    int ch;
    fileheader postfile;
    char fn2[STRLEN], *brd, genbuf[200];

    brd = by_BM ? "deleted" : "junk";
    setbpath(fn2, brd);
    stampfile(fn2, &postfile);
    memcpy(postfile.owner, fhdr->owner, IDLEN + TTLEN + 10);
    postfile.savemode = 'D';

    if ((fhdr->savemode == 'S') &&/* ~H */
        (atoi(fhdr->filename + 2) > login_start_time - 7 * 86400)) {  /* 7 Ѥ */
      ptr = nick;
      ch = read(fd, ptr, NICK_LEN);
      ptr[ch] = '\0';
      if (!strncmp(ptr, str_author1, LEN_AUTHOR1) ||
        !strncmp(ptr, str_author2, LEN_AUTHOR2))
      {
        if (left = (char *) strchr(ptr, '('))
        {
          right = NULL;
          for (ptr = ++left; ch = *ptr; ptr++)
          {
            if (ch == ')')
              right = ptr;
            else if (ch == '\n')
              break;
          }

          if (right != NULL)
          {
            *right = '\0';

            if (fout = fopen("innd/cancel.bntp", "a"))
            {
              fprintf(fout, "%s\t%s\t%s\t%s\t%s\n",
                currboard, fhdr->filename, /*fhdr->owner*/  cuser.userid
                ,left, fhdr->title);
              fclose(fout);
            }
          }
        }
      }
    }
    close(fd);
    Rename(fpath, fn2);
    setbdir(genbuf, brd);
    append_record(genbuf, &postfile, sizeof(postfile));
#undef  NICK_LEN
  }
}

/* ----------------------------------------------------- */
/* oB^BsB峹                            */
/* ----------------------------------------------------- */


void
do_reply_title(row, title)
  int row;
  char *title;
{
  char genbuf[200];
  char genbuf2[4];

  if (ci_strncmp(title, str_reply, 4))
    sprintf(save_title, "Re: %s", title);
  else
    strcpy(save_title, title);
  save_title[TTLEN - 1] = '\0';
  sprintf(genbuf, "ĥέDm%.60sn?[Y] ", save_title);
  getdata(row, 0, genbuf, genbuf2, 4, LCECHO);
  if (*genbuf2 == 'n')
    getdata(++row, 0, "DG", save_title, TTLEN, DOECHO);
}


static void
do_reply(fhdr)
  fileheader *fhdr;
{
  char genbuf[200];

  getdata(b_lines - 1, 0, " ^ (F)ݪO (M)@̫Hc (B)G̬ҬO (Q)H[F] ", genbuf, 3, LCECHO);
  comfortable = 0;
  switch (genbuf[0])
  {
  case 'm':
    comfortable = 1;
    mail_reply(0, fhdr, 0);
  case 'q':
    break;

  case 'b':
    curredit = EDIT_BOTH;
  default:
    strcpy(currtitle, fhdr->title);
    strcpy(quote_user, fhdr->owner);
    quote_file[79] = fhdr->savemode;
    do_post();
  }
}


/*
woju
*/
brdperm(char* brdname, char* userid)
{
   boardheader *bp;
   boardheader *getbcache();
   int uid = searchuser(userid);

   bp = getbcache(currboard);
   if (uid && bp) {
      int level = bp->level;
      char* ptr = bp->BM;
      char buf[64], manager[IDLEN + 1];
      userec xuser;

      get_record(fn_passwd, &xuser, sizeof(xuser), uid);
      if ((level & PERM_POSTMASK) || ((level)?xuser.userlevel&(level):1))
         return 1;

      if (ptr[0] <= ' ')
         return 0;

      if (userid_is_BM(userid, ptr))
         return 1;

      //if ((level & 0xffff) != PERM_CHATROOM)
      if ((level & PERM_CHATROOM)==0)
         return 0;

      strncpy(manager, ptr, IDLEN + 1);
      if (ptr = strchr(manager, '/'))
         *ptr = 0;
      sethomefile(buf, manager, fn_overrides);
      return (belong(buf, userid));
   }
   return 0;
}

do_postnotify(char* fpath)
{
   fileheader mhdr;
   char title[128], buf1[80], buf[80];
   FILE* fp;
   char genbuf[200];

   setuserfile(genbuf, "postnotify");
   if (fp = fopen(genbuf, "r")) {
      char last_fname[80];
      boardheader *bp;
      boardheader *getbcache();

      strcpy(last_fname, fpath);
      bp = getbcache(currboard);
      while (fgets(buf, 80, fp))
#ifdef HAVE_ANONYMOUS
         if ((brdperm(currboard, buf)) && strcmp(currboard, "Anonymity") && strcmp(currboard, "comfortable")) {
#else
         if (brdperm(currboard, buf)) {
#endif
            sethomepath(buf1, buf);
            stampfile(buf1, &mhdr);
            strcpy(mhdr.owner, cuser.userid);
            strcpy(mhdr.title, "[s]");
            strncat(mhdr.title, save_title, TTLEN - 4);
            mhdr.savemode = 0;
            mhdr.filemode = 0;
            sethomedir(title, buf);
            append_record(title, &mhdr, sizeof(mhdr));
            unlink(buf1);
            Link(last_fname, buf1);
            strcpy(last_fname, buf1);
         }
      fclose(fp);
   }
}

int
do_post()
{
  fileheader postfile;
  char fpath[80], buf[80];
  int aborted;
  char genbuf[200];
  char bdn[80];

  clear();
  if (!(currmode & MODE_POST))
  {
    move(5, 10);
    outs("藍_AzثeLkbo峹I");
    pressanykey();
    return FULLUPDATE;
  }

  more("etc/post.note", NA);
  prints("o峹i %s jݪO\n\n", currboard);

  if (quote_file[0])
    do_reply_title(20, currtitle);
  else
    getdata(21, 0, "DG", save_title, TTLEN, DOECHO);

  if (save_title[0] == '\0')
    return FULLUPDATE;

  curredit &= ~EDIT_MAIL;
  setutmpmode(POSTING);

  /*  Internet v̡Aubo峹 */

  if (HAS_PERM(PERM_INTERNET))
    local_article = 0;
  else
    local_article = 1;

  buf[0] = 0;

  aborted = vedit(buf, YEA);
  if (aborted == -1)
  {
    unlink(buf);
    pressanykey();
    return FULLUPDATE;
  }

  /* build filename */

  setbpath(fpath, currboard);
  stampfile(fpath, &postfile);
  Rename(buf, fpath);
  strcpy(postfile.owner, cuser.userid);

  /* set owner to anonymous , for anonymous board */

#ifdef HAVE_ANONYMOUS
  if (!strcmp("Anonymity", currboard))
    strcpy(postfile.owner, "         ");
#endif

  /*****   mail list  ******/
  /*if (!strcmp("Maillist", currboard))
    {//strcpy(genbuf, "mail test@Stalin.AD.nthu.edu.tw < ");
     //strcpy(genbuf, "mail tjm@royals.ee.nctu.edu.tw < ");
     //strcat(genbuf, fpath);
     //system(genbuf);
     bbs_sendmail(fpath, save_title,"test@Stalin.AD.nthu.edu.tw");
     //bbs_sendmail(fpath, save_title,"tjm@royals.ee.nctu.edu.tw");
    }*/

  strcpy(postfile.title, save_title);
  if (aborted == 1)             /* local save */
  {
    postfile.savemode = 'L';
    postfile.filemode = FILE_LOCAL;
  }
  else
    postfile.savemode = 'S';

  setbdir(buf, currboard);
  if (append_record(buf, &postfile, sizeof(postfile)) != -1)
  {
    if (aborted != 1)
      outgo_post(&postfile, currboard);

    brc_addlist(postfile.filename);
    outs("QKXGiA");
    /**** add account post*****/
     setbfile(bdn,currboard,"postnum");
     logcnt(bdn);
    if (strcmp(currboard, "Test"))
    {
      prints("oOz %d g峹C", ++cuser.numposts);
      UPDATE_USEREC;
    }
    else
      outs("իH󤣦CJAqХ][C");

    /* ^@̫Hc */

    if (curredit & EDIT_BOTH)
    {
      char *str, *msg = "^ܧ@̫Hc";

      if (str = strchr(quote_user, '.'))
      {
        if (bbs_sendmail(fpath, save_title, str + 1) < 0)
          msg = "@̵LkH";
      }
      else
      {
        sethomepath(genbuf, quote_user);
        stampfile(genbuf, &postfile);
        unlink(genbuf);
        Link(fpath, genbuf);

        strcpy(postfile.owner, cuser.userid);
        strcpy(postfile.title, save_title);
        postfile.savemode = 'B';/* both-reply flag */
        sethomedir(genbuf, quote_user);
        if (append_record(genbuf, &postfile, sizeof(postfile)) == -1)
          msg = err_uid;
      }
      outs(msg);
      curredit ^= EDIT_BOTH;
    }
    do_postnotify(fpath);
  }
  pressanykey();
  return FULLUPDATE;
}


static int
reply_post(ent, fhdr, direct)
  int ent;
  fileheader *fhdr;
  char *direct;
{
  if (!(currmode & MODE_POST))
    return DONOTHING;

  setdirpath(quote_file, direct, fhdr->filename);
  do_reply(fhdr);
  return FULLUPDATE;
}


static int
edit_post(ent, fhdr, direct)
  int ent;
  fileheader *fhdr;
  char *direct;
{
   char fpath[80], fpath0[80];
   extern bad_user(char* name);
   char genbuf[200];
   fileheader postfile;
/*
woju
  if (!HAS_PERM(PERM_SYSOP) && strcmp(fhdr->owner, cuser.userid))
*/
  if (!HAS_PERM(PERM_SYSOP) && strcmp(fhdr->owner, cuser.userid) || !strcmp(cuser.userid, "guest") || bad_user(cuser.userid))
    return DONOTHING;

  setdirpath(genbuf, direct, fhdr->filename);
  local_article = fhdr->filemode & FILE_LOCAL;

  strcpy(save_title, fhdr->title);
  if (vedit(genbuf, NA) != -1) {
     setbpath(fpath, currboard);
     stampfile(fpath, &postfile);
     setbfile(fpath0, currboard, fhdr->filename);
     Rename(fpath0, fpath);
     strcpy(fhdr->filename, postfile.filename);
     strcpy(fhdr->title, save_title);
     brc_addlist(postfile.filename);
     substitute_record(direct, fhdr, sizeof(*fhdr), ent);
     do_postnotify(fpath);
  }
  return FULLUPDATE;
}


static int
cross_post(ent, fhdr, direct)
  int ent;
  fileheader *fhdr;
  char *direct;
{
  char xboard[20], fname[80], xfpath[80], xtitle[80], inputbuf[10];
  fileheader xfile;
  FILE *xptr;
  int author = 0;
  char genbuf[200];
  char genbuf2[4];

  make_blist();
  move(2, 0);
  clrtoeol();
  move(3, 0);
  clrtoeol();
  move(1, 0);
  namecomplete("峹ݪOG", xboard);
  if (*xboard == '\0' || !haspostperm(xboard))
    return FULLUPDATE;

#ifdef HAVE_ANONYMOUS
    if ((!strcmp(xboard, "Anonymity")) || (!strcmp(xboard, "comfortable"))){
      move(2, 0);
      outs("ΦWOII");
      igetch();
      return FULLUPDATE;
    }
#endif

  ent = 1;
  if (HAS_PERM(PERM_SYSOP) || !strcmp(fhdr->owner, cuser.userid))
  {
    getdata(2, 0, "(1) (2)榡H[1] ",
      genbuf, 3, DOECHO);
    if (genbuf[0] != '2')
    {
      ent = 0;
      getdata(2, 0, "Od@̦Wٶ?[Y] ", inputbuf, 3, DOECHO);
      if (inputbuf[0] != 'n' && inputbuf[0] != 'N' && strcmp(currboard, "comfortable")) author = 1;
    }
  }

  if (ent)
    sprintf(xtitle, "[]%.66s", fhdr->title);
  else
    strcpy(xtitle, fhdr->title);

  sprintf(genbuf, "ĥέDm%.60sn?[Y] ", xtitle);
  getdata(2, 0, genbuf, genbuf2, 4, LCECHO);
  if (*genbuf2 == 'n')
  {
    if (getdata(2, 0, "DG", genbuf, TTLEN, DOECHO))
      strcpy(xtitle, genbuf);
  }

  getdata(2, 0, "(S)s (L) (Q)H[Q] ", genbuf, 3, LCECHO);
  if (genbuf[0] == 'l' || genbuf[0] == 's')
  {
    setbpath(xfpath, xboard);
    stampfile(xfpath, &xfile);
    if (author)
      strcpy(xfile.owner, fhdr->owner);
    else
      strcpy(xfile.owner, cuser.userid);
    strcpy(xfile.title, xtitle);
    if (genbuf[0] == 'l')
    {
      xfile.savemode = 'L';
      xfile.filemode = FILE_LOCAL;
    }
    else
      xfile.savemode = 'S';

    setbfile(fname, currboard, fhdr->filename);
    if (ent)
    {
      xptr = fopen(xfpath, "w");

      strcpy(save_title, xfile.title);
      strcpy(xfpath, currboard);
      strcpy(currboard, xboard);
      write_header(xptr);
      strcpy(currboard, xfpath);

      fprintf(xptr, " [ %s ݪO]\n\n", currboard);

      b_suckinfile(xptr, fname);
      addsignature(xptr);
      fclose(xptr);
    }
    else
    {
      unlink(xfpath);
      Link(fname, xfpath);
    }

    setbdir(fname, xboard);
    append_record(fname, (char *) &xfile, sizeof(xfile));
    if (!xfile.filemode)
      outgo_post(&xfile, xboard);
    cuser.numposts++;
    UPDATE_USEREC;
    outs("峹");
    pressanykey();
  }
  return FULLUPDATE;
}


static int
read_post(ent, fhdr, direct)
  int ent;
  fileheader *fhdr;
  char *direct;
{
  char genbuf[200];
  int more_result;
  char bdn[80],*bdpt;

  if (fhdr->owner[0] == '-')
    return DONOTHING;

  setdirpath(genbuf, direct, fhdr->filename);

  if ((more_result = more(genbuf, YEA)) == -1)
    return DONOTHING;

  /**** add account read****/
     strcpy(bdn,direct);
     bdpt = strrchr(bdn, '/');
     strcpy(bdpt+1,"/readnum");
     logcnt(bdn);
  brc_addlist(fhdr->filename);
  strncpy(currtitle, subject(fhdr->title), 40);
  strncpy(currowner, subject(fhdr->owner), IDLEN + 2);

/*
woju
*/
  switch (more_result) {
  case 1:
     return READ_PREV;
  case 2:
     return RELATE_PREV;
  case 3:
     return READ_NEXT;
  case 4:
     return RELATE_NEXT;
  case 5:
     return RELATE_FIRST;
  case 6:
     return FULLUPDATE;
  case 7:
  case 8:
    if (currmode & MODE_POST)
    {
      strcpy(quote_file, genbuf);
      do_reply(fhdr);
      *quote_file = 0;
    }
    return FULLUPDATE;
  case 9:
     return 'A';
  case 10:
     return 'a';
  case 11:
     return '/';
  case 12:
     return '?';
  }


  outmsg("[34;46m  \\Ū峹  [31;47m  (R/Y)[30m^H [31m"
    "(=[]<>)[30mDD [31m()[30mWU [31m()[30m}  [0m");

  switch (egetch())
  {
  case 'q':
  case 'Q':
  case KEY_LEFT:
    break;

  case ' ':
  case KEY_RIGHT:
  case KEY_DOWN:
  case KEY_PGDN:
  case 'n':
  case Ctrl('N'):
    return READ_NEXT;

  case KEY_UP:
  case 'p':
  case Ctrl('P'):
  case KEY_PGUP:
    return READ_PREV;

  case '=':
    return RELATE_FIRST;

  case ']':
  case 't':
    return RELATE_NEXT;

  case '[':
    return RELATE_PREV;

  case '.':
  case '>':
    return THREAD_NEXT;

  case ',':
  case '<':
    return THREAD_PREV;

/*
woju
*/
      case Ctrl('R'): if (currutmp->msgs[0].last_pid) {
         show_last_call_in();
         //my_write(currutmp->msgs[0].last_pid, "Te^hG");
         return FULLUPDATE;
      }
      return DONOTHING;
  case Ctrl('U'):
    t_users();
    return FULLUPDATE;
  case Ctrl('I'):
    t_idle();
    return FULLUPDATE;
  case 'y':
  case 'r':
  case 'R':
  case 'Y':
    if (currmode & MODE_POST)
    {
      strcpy(quote_file, genbuf);
      do_reply(fhdr);
      *quote_file = 0;
    }
  }
  return FULLUPDATE;
}


/* ----------------------------------------------------- */
/* Ķذ                                            */
/* ----------------------------------------------------- */


static int
cite_post(ent, fhdr, direct)
  int ent;
  fileheader *fhdr;
  char *direct;
{
  char genbuf[200];

  if (currmode & MODE_BOARD)
  {
    char *fname, fpath[60], ans[4], buf[256], title[80] = " ";
    FILE *fp, *fin;
    int existed;

    /* fpath iH]tؿ| */

    if (!getdata(b_lines - 1, 0, "пJɦWG", fpath, 60, DOECHO))
      return FULLUPDATE;

    if (fname = strrchr(fpath, '/'))
      fname++;
    else
      fname = fpath;
    fname[30] = '\0';
    sprintf(genbuf, "man/%s/%s", currboard, fpath);
    if (invalid_fname(fpath) || dashd(genbuf))
    {
      outmsg(err_filename);
      igetch();
      return FULLUPDATE;
    }

    if (existed = dashf(genbuf))
    {
      getdata(b_lines - 1, 0, "ۦPɦWwgsbAO_[ih(Y/N)H[Y] ",
        ans, 3, LCECHO);
      if (ans[0] == 'n')
        return FULLUPDATE;
    }
    else
    {
      /* ۰ʳ] title */
      if (!getdata(b_lines - 1, 0, "пJDG", title + 3, 60, DOECHO))
        strcpy(title + 3, fhdr->title);
    }

    if ((fp = fopen(genbuf, "a+")) == NULL)
      return FULLUPDATE;

    setbfile(buf, currboard, fhdr->filename);
    if (fin = fopen(buf, "r"))
    {
      if (existed)
      {
        memset(buf, '-', 74);
        buf[74] = '\0';
        fprintf(fp, "\n> %s <\n\n", buf);
      }

      ent = 1;
      getdata(b_lines - 1, 0, "O_ñWɳ(Y/N)H[N] ", ans, 3, LCECHO);
      if (ans[0] == 'y')
        ent = 0;

      while (fgets(buf, sizeof(buf), fin))
      {
        if (ent)
        {
          if (!strcmp(buf, "--\n"))
            break;
        }
        fputs(buf, fp);
      }
      fclose(fin);
    }

    fclose(fp);

    if (!existed)
    {
      direct = strrchr(genbuf, '/');
      strcpy(direct, fn_mandex);
      if (fp = fopen(genbuf, "a+"))
      {
        fprintf(fp, "Name=%s\nPath=%s\n", title, fname);
        fclose(fp);
      }
    }
    return FULLUPDATE;
  }
  return DONOTHING;
}


static int
edit_title(ent, fhdr, direct)
  int ent;
  fileheader *fhdr;
  char *direct;
{
  char genbuf[200];

  if (HAS_PERM(PERM_SYSOP) /* || !strcmp(fhdr->owner, cuser.userid) */ )
  {
    fileheader tmpfhdr = *fhdr;
    int dirty = 0;

    if (getdata(b_lines - 1, 0, "DG", genbuf, TTLEN, DOECHO))
    {
      strcpy(tmpfhdr.title, genbuf);
      dirty++;
    }

    if (getdata(b_lines - 1, 0, "@̡G", genbuf, IDLEN + 2, DOECHO))
    {
      strcpy(tmpfhdr.owner, genbuf);
      dirty++;
    }

    if (getdata(b_lines - 1, 0, "G", genbuf, 6, DOECHO))
    {
      sprintf(tmpfhdr.date, "%+5s", genbuf);
      dirty++;
    }

/*
woju
*/
    if (getdata(b_lines - 1, 0, "Tw(Y/N)?[n] ", genbuf, 3, DOECHO) &&
        *genbuf == 'y' && dirty) {
       *fhdr = tmpfhdr;
       substitute_record(direct, fhdr, sizeof(*fhdr), ent);
    }
    return FULLUPDATE;
  }
  return DONOTHING;
}


static int
mark_post(ent, fhdr, direct)
  int ent;
  fileheader *fhdr;
  char *direct;
{
  if (currmode & MODE_BOARD)
  {
    fhdr->filemode ^= FILE_MARKED;
    substitute_record(direct, fhdr, sizeof(*fhdr), ent);
    return PART_REDRAW;
  }
  return DONOTHING;
}


int
del_range(ent, fhdr, direct)
  int ent;
  fileheader *fhdr;
  char *direct;
{
  char num1[8], num2[8];
  int inum1, inum2;

  if ((currstat != READING) || (currmode & MODE_BOARD))
  {
    getdata(1, 0, "[]wRd] _IG", num1, 5, DOECHO);
    inum1 = atoi(num1);
    if (inum1 <= 0)
    {
      outmsg("_I~");
      refresh();
      sleep(1);
      return FULLUPDATE;
    }
    getdata(1, 28, "IG", num2, 5, DOECHO);
    inum2 = atoi(num2);
    if (inum2 < inum1)
    {
      outmsg("I~");
      refresh();
      sleep(1);
      return FULLUPDATE;
    }
    getdata(1, 48, msg_sure_ny, num1, 3, LCECHO);
    if (*num1 == 'y')
    {
      delete_range(direct, inum1, inum2, NULL);
      fixkeep(direct, inum1);
      return DIRCHANGED;
    }
    return FULLUPDATE;
  }
  return DONOTHING;
}


static void
lazy_delete(fhdr)
  fileheader *fhdr;
{
  char buf[20];

  sprintf(buf, "-%s", fhdr->owner);
  strncpy(fhdr->owner, buf, IDLEN + 1);
  sprintf(fhdr->title, "<< article deleted by %s >>",cuser.userid);
  fhdr->savemode = 'L';
}


int
del_one(ent, fhdr, direct)
  int ent;
  fileheader *fhdr;
  char *direct;
{
  if ((currstat != READING) || (currmode & MODE_BOARD))
  {
    strcpy(currfile, fhdr->filename);

    if (!update_file(direct, sizeof(fileheader), ent, cmpfilename, lazy_delete))
    {
      cancelpost(fhdr, YEA);
      lazy_delete(fhdr);
      return PART_REDRAW;
    }
  }
  return DONOTHING;
}


static int
del_post(ent, fhdr, direct)
  int ent;
  fileheader *fhdr;
  char *direct;
{
  char buf[80];
  char *t;
  int not_owned;
  char genbuf[4];

  if ((fhdr->filemode & FILE_MARKED) || (fhdr->owner[0] == '-'))
    return DONOTHING;

  not_owned = strcmp(fhdr->owner, cuser.userid);
/*
woju
  if (!(currmode & MODE_BOARD) && not_owned)
*/
  if (!(currmode & MODE_BOARD) && not_owned 
      || !strcmp(cuser.userid, "guest")
      || !strcmp(cuser.userid, "poorboy")
      || !strcmp(cuser.userid, "poorgirl"))
    return DONOTHING;

  getdata(1, 0, msg_del_ny, genbuf, 3, LCECHO);
  if (genbuf[0] == 'y')
  {
    strcpy(currfile, fhdr->filename);

    if (!update_file(direct, sizeof(fileheader), ent, cmpfilename, lazy_delete))
    {
      cancelpost(fhdr, not_owned);
      if (!not_owned && strcmp(currboard, "Test"))
      {
        if (cuser.numposts)
          cuser.numposts--;
        UPDATE_USEREC;
        move(b_lines - 1, 0);
        clrtoeol();
        prints("%sAz峹 %d g", msg_del_ok, cuser.numposts);
        refresh();
        sleep(1);
      }
      lazy_delete(fhdr);
      return FULLUPDATE;
    }
  }
  return FULLUPDATE;
}


/* ----------------------------------------------------- */
/* ̧Ūs峹                                          */
/* ----------------------------------------------------- */

static int sequent_ent;


static int
sequent_messages(fptr)
  fileheader *fptr;
{
  static int idc;
  char ans[6];
  char genbuf[200];

  if (fptr == NULL)
    return (idc = 0);

  if (++idc < sequent_ent)
    return 0;

  if (!brc_unread(fptr->filename))
    return 0;

  if (continue_flag)
  {
    genbuf[0] = 'y';
  }
  else
  {
    prints("Ū峹G[%s] @̡G[%s]\nDG[%s]",
      currboard, fptr->owner, fptr->title);
    getdata(3, 0, "(Y/N/Quit) [Y]: ", genbuf, 3, LCECHO);
  }

  if (genbuf[0] != 'y' && genbuf[0])
  {
    clear();
    return (genbuf[0] == 'q' ? QUIT : 0);
  }

  setbfile(genbuf, currboard, fptr->filename);
  brc_addlist(fptr->filename);

  if (more(genbuf, YEA) == 0)
     outmsg("[31;47m  [31m(R)[30m^H  [31m(,n)[30mU@  [31m(,q)[30m}  [0m");
  continue_flag = 0;

  switch (egetch())
  {
  case KEY_LEFT:
  case 'e':
  case 'q':
  case 'Q':
    break;

  case 'y':
  case 'r':
  case 'Y':
  case 'R':
    if (currmode & MODE_POST)
    {
      strcpy(quote_file, genbuf);
      do_reply(fptr);
      *quote_file = 0;
    }
    break;

  case ' ':
  case KEY_DOWN:
  case '\n':
  case 'n':
    continue_flag = 1;
  }

  clear();
  return 0;
}


static int
sequential_read(ent, fhdr, direct)
  int ent;
  fileheader *fhdr;
  char *direct;
{
  char buf[40];

  clear();
  sequent_messages((fileheader *) NULL);
  sequent_ent = ent;
  continue_flag = 0;
  setbdir(buf, currboard);
  apply_record(buf, sequent_messages, sizeof(fileheader));
  return FULLUPDATE;
}


/* ----------------------------------------------------- */
/* ݪOƧѿBKBذ                              */
/* ----------------------------------------------------- */


static int
b_notes_edit()
{
  if (currmode & MODE_BOARD)
  {
    struct stat st;
    char buf[64];
    int aborted;

    setbfile(buf, currboard, fn_notes);
    aborted = vedit(buf, NA);
    if (aborted)
    {
      clear();
      outs(msg_cancel);
      pressanykey();
    }
    else
    {
      boardheader fh;
      int pos;

      getdata(3, 0, "г]wĴ(0 - 9999)ѡH", buf, 5, DOECHO);
      aborted = atol(buf);
      pos = search_record(fn_board, &fh, sizeof(fh), cmpbnames, currboard);
      fh.bupdate = aborted ? time(0) + aborted * 86400 : 0;
      substitute_record(fn_board, &fh, sizeof(fh), pos);
      touch_boards();
    }
    return FULLUPDATE;
  }
  return 0;
}


static int
b_notes()
{
  char buf[64];

  setbfile(buf, currboard, fn_notes);
  if (more(buf, NA) == -1)
  {
    clear();
    move(4, 20);
    outs("ݪO|LuƧѿvC");
  }
  pressanykey();
  return FULLUPDATE;
}


enum
{
  NOBODY, MANAGER, SYSOP
};

static int
b_man()
{
  char buf[64];

  setapath(buf, currboard);
  a_menu(currboard, buf, (HAS_PERM(PERM_SYSOP) ? SYSOP : NOBODY));
  return FULLUPDATE;
}


int
board_digest()
{
  currmode ^= MODE_DIGEST;
  if (currmode & MODE_DIGEST)
    currmode &= ~MODE_POST;
  else if (haspostperm(currboard))
    currmode |= MODE_POST;

  setbdir(currdirect, currboard);
  return NEWDIRECT;
}


int
board_etc()
{
  if (!HAS_PERM(PERM_SYSOP))
     return DONOTHING;
  currmode ^= MODE_ETC;
  if (currmode & MODE_ETC)
    currmode &= ~MODE_POST;
  else if (haspostperm(currboard))
    currmode |= MODE_POST;

  setbdir(currdirect, currboard);
  return NEWDIRECT;
}


static int
good_post(ent, fhdr, direct)
  int ent;
  fileheader *fhdr;
  char *direct;
{
  char genbuf[200];
  char genbuf2[200];

  if ((currmode & MODE_DIGEST) || !(currmode & MODE_BOARD))
    return DONOTHING;

  if (fhdr->filemode & FILE_DIGEST)
  {
    fhdr->filemode = (fhdr->filemode & ~FILE_DIGEST);
  }
  else
  {
    fileheader digest;
    char *ptr, buf[64];

    memcpy(&digest, fhdr, sizeof(digest));
    digest.filename[0] = 'G';
    strcpy(buf, direct);
    ptr = strrchr(buf, '/') + 1;
    ptr[0] = '\0';
    sprintf(genbuf, "%s%s", buf, digest.filename);
    if (dashf(genbuf))
      return DONOTHING;
    digest.savemode = digest.filemode = 0;
    sprintf(genbuf2, "%s%s", buf, fhdr->filename);
    Link(genbuf2, genbuf);
    strcpy(ptr, fn_mandex);
    append_record(buf, &digest, sizeof(digest));

    fhdr->filemode = (fhdr->filemode & ~FILE_MARKED) | FILE_DIGEST;
  }
  substitute_record(direct, fhdr, sizeof(*fhdr), ent);
  return PART_REDRAW;
}


/* help for board reading */

static char *board_help[] =
{
  "\0\\ݪOާ@",
  "\01򥻩RO",
  "(p)()   W@g峹          (^P)     o峹",
  "(n)()   U@g峹          (d)      R峹",
  "(P)(PgUp) W@              (S)      `Ǿ\\Ūs峹",
  "(N)(PgDn) U@              (##)      ## 峹",
  "(r)()   \\Ūg峹          ($)      ̫@g峹",
  "\01iRO",
  "(tab)/z   KҦ/ذ       (a)(A)   M@",
  "(b)       iŪƧѿ            (?)(/)   MD",
  "(V,R)     벼/dߧ벼G     (=)      Mg峹",
  "(x)       峹LݪO    ([]<>-+) DD\\Ū",

#ifdef INTERNET_EMAIL
  "(F)       N峹H^ Internet lc",
  "(U)       N峹 uuencode H^lc",
#endif
  "(Z)       Z-modem           (E)      s峹",

  "\01ODRO",
  "(m)       Odg峹          (W)     sƧѿ",
  "(M)       |벼              (c/g)   /K",
  "(D)       R@qd򪺤峹    (T)     s峹D",

  NULL
};


static int
b_help()
{
  show_help(board_help);
  return FULLUPDATE;
}


/* ----------------------------------------------------- */
/* ݪO\                                            */
/* ----------------------------------------------------- */


extern int b_vote();
extern int b_results();
extern int b_vote_maintain();
extern int x_upgrade();

struct one_key read_comms[] = {
  KEY_TAB, board_digest,
  'C', board_etc,
  'b', b_notes,
  'c', cite_post,
  'r', read_post,
  'z', b_man,
  'D', del_range,
/*
woju
  Ctrl('D'), del_one,
*/
  'S', sequential_read,
  'E', edit_post,
  'T', edit_title,
  's', do_select,
  'R', b_results,
  'V', b_vote,
  'M', b_vote_maintain,
  'W', b_notes_edit,
  'h', b_help,
  'g', good_post,
  'x', cross_post,
  'y', reply_post,
  'd', del_post,
  'm', mark_post,
  Ctrl('P'), do_post,
  'u',        x_upgrade,

  '\0', NULL
};

ReadSelect()
{
   int mode0 = currutmp->mode;
   int stat0 = currstat;
   char genbuf[200];

   currstat = XMODE;
   if (do_select(0, 0, genbuf) == NEWDIRECT)
      Read();
   currutmp->mode = mode0;
   currstat = stat0;
}


int
Read()
{
  char buf[40];
  char bdn[80];

  set_board();
  if (board_visit_time < board_note_time)
  {
    setbfile(buf, currboard, fn_notes);
    more(buf, NA);
    pressanykey();
  }

  setbdir(buf, currboard);
  curredit &= ~EDIT_MAIL;
  /****** add account enter *****/
  setbfile(bdn,currboard,"enternum");
  logcnt(bdn);
  i_read(READING, buf, readtitle, readdoent, read_comms);
  brc_update();
  return 0;
}


int
Select()
{
  char genbuf[200];

  setutmpmode(SELECT);
  do_select(0, NULL, genbuf);
  return 0;
}


int
Post()
{
  do_post();
  return 0;
}

int
logcnt(char *filename)
{
 int i,fd,encnt;
  fd = open(filename, O_RDWR|O_CREAT,0600);
    flock(fd, LOCK_EX);
    if (i=read(fd, (char*)(&encnt), 4)>0)
    {
       if ((encnt>0)&&(encnt<100000))
           encnt=encnt+1;
       else
           encnt=1;
    }
    else encnt=1;
       lseek(fd,0,SEEK_SET);
       write(fd,(char*)(&encnt),4);
    flock(fd, LOCK_UN);
    close(fd);
}
