/*-------------------------------------------------------*/
/* modes.h      ( NTHU CS MapleBBS Ver 2.36 )            */
/*-------------------------------------------------------*/
/* target : user operating mode & status                 */
/* create : 95/03/29                                     */
/* update : 95/12/15                                     */
/*-------------------------------------------------------*/


#ifndef _MODES_H_
#define _MODES_H_


/* ----------------------------------------------------- */
/* user ާ@APҦ                                   */
/* ----------------------------------------------------- */

#define IDLE            0
#define MMENU           1       /* menu mode */
#define ADMIN           2
#define MAIL            3
#define TMENU           4
#define UMENU           5
#define XMENU           6
#define CLASS           7

#define LOGIN           8       /* main menu */

#define ANNOUNCE        9       /* announce */

#define POSTING         10      /* boards & class */
#define READBRD         11
#define READING         12
#define READNEW         13
#define SELECT          14

#define RMAIL           15      /* mail menu */
#define SMAIL           16

#define CHATING         17      /* talk menu */
#define XMODE           18
#define FRIEND          19
#define LAUSERS         20
#define LUSERS          21
#define MONITOR         22
#define PAGE            23
#define QUERY           24
#define TALK            25

#define EDITPLAN        26      /* user menu */
#define EDITSIG         27
#define VOTING          28
#define XINFO           29

#define MSYSOP          30
#define WWW             31
#define ON_LINE         32

#define REPLY           33
#define HIT             34
#define DBACK           35

#define EDITING         36
#define RBIBLE          37
#define BOOK            38

#define BBSNET          0

static char *IdleTypeTable[] =
{
  "bb",
  "Hӹq",
  "V",
  "P",
  "A",
  "ڦb"
};

#ifdef  _MODES_C_
static char *ModeTypeTable[] =
{
  "ob",                       /* IDLE */
  "D",                     /* MMENU */
  "tκ@",                   /* ADMIN */
  "l",                   /* MAIL */
  "Ϳ",                   /* TMENU */
  "ϥΪ̿",                 /* UMENU */
  "XYZ ",                   /* XMENU */
  "ݪO",                   /* CLASS */
  "W~",                   /* LOGIN */
  "G",                     /* ANNOUNCE */
  "o峹",                   /* POSTING */
  "ݪOC",                   /* READBRD */
  "\\Ū峹",                  /* READING */
  "s峹C",                 /* READNEW */
  "ܬݪO",                   /* SELECT */
  "ŪH",                       /* RMAIL */
  "gH",                       /* SMAIL */
  "ѫ",                     /* CHATING */
  "L",                       /* XMODE */
  "Mn",                   /* FRIEND */
  "WuϥΪ",                 /* LAUSERS */
  "ϥΪ̦W",                 /* LUSERS */
  "lܯ",                   /* MONITOR */
  "Is",                       /* PAGE */
  "d",                       /* QUERY */
  "",                       /* TALK  */
  "sW",                   /* EDITPLAN */
  "sñW",                   /* EDITSIG */
  "벼",                     /* VOTING */
  "]w",                   /* XINFO */
  "H",                   /* MSYSOP */
  "LLL",                     /* WWW */
  "ON-LINE BI",                 /* ON_LINE */
  "^",                       /* REPLY */
  "QT",                 /* HIT */
  "TǳƤ",                 /* DBACK */
  "s峹",                    /* EDITING */
  "tgtŪ",                    /** RBIBLE */
  "ϮѸ"                    /** RBIBLE */
};

#endif                          /* _MODES_C_ */


/* ----------------------------------------------------- */
/* menu.c Ҧ                                       */
/* ----------------------------------------------------- */


#define QUIT    0x666           /* Return value to abort recursive functions */
#define XEASY   0x333           /* Return value to un-redraw screen */


/* ----------------------------------------------------- */
/* read.c Ҧ                                       */
/* ----------------------------------------------------- */


#define RS_FORWARD      0x01    /* backward */
#define RS_TITLE        0x02    /* author/title */
#define RS_RELATED      0x04
#define RS_FIRST        0x08    /* find first article */
#define RS_CURRENT      0x10    /* match current read article */
#define RS_THREAD       0x20    /* search the first article */

#define CURSOR_FIRST    (RS_RELATED | RS_TITLE | RS_FIRST)
#define CURSOR_NEXT     (RS_RELATED | RS_TITLE | RS_FORWARD)
#define CURSOR_PREV     (RS_RELATED | RS_TITLE)
#define RELATE_FIRST    (RS_RELATED | RS_TITLE | RS_FIRST | RS_CURRENT)
#define RELATE_NEXT     (RS_RELATED | RS_TITLE | RS_FORWARD | RS_CURRENT)
#define RELATE_PREV     (RS_RELATED | RS_TITLE | RS_CURRENT)
#define THREAD_NEXT     (RS_THREAD | RS_FORWARD)
#define THREAD_PREV     (RS_THREAD)


#define DONOTHING       0       /* Read menu command return states */
#define FULLUPDATE      1       /* Entire screen was destroyed in this oper */
#define PARTUPDATE      2       /* Only the top three lines were destroyed */
#define DOQUIT          3       /* Exit read menu was executed */
#define NEWDIRECT       4       /* Directory has changed, re-read files */
#define READ_NEXT       5       /* Direct read next file */
#define READ_PREV       6       /* Direct read prev file */
#define DIRCHANGED      8       /* Index file was changed */
#define READ_REDRAW     9
#define PART_REDRAW     10
/*
woju
*/
#define POS_NEXT        101     /* cursor_pos(locmem, locmem->crs_ln + 1, 1);*/


/* for currmode */

#define MODE_STARTED    1       /* O_wgiJt */
#define MODE_POST       2       /* O_iHb currboard o峹 */
#define MODE_BOARD      4       /* O_iHb currboard RBmark峹 */
#define MODE_DIGEST     0x10    /* O_ digest mode */
#define MODE_ETC        0x20    /* O_ etc mode */
#define MODE_DIRTY      0x80    /* O_ʹL userflag */


/* for curredit */

#define EDIT_MAIL       1       /* ثeO mail/board ? */
#define EDIT_LIST       2       /* O_ mail list ? */
#define EDIT_BOTH       4       /* both reply to author/board ? */
#endif                          /* _MODES_H_ */
