#undef VACATION
/*-------------------------------------------------------*/
/* register.c   ( NTHU CS MapleBBS Ver 2.36 )            */
/*-------------------------------------------------------*/
/* target : user register routines                       */
/* create : 95/03/29                                     */
/* update : 95/12/15                                     */
/*-------------------------------------------------------*/


#include "bbs.h"


/* ------------------- */
/* password encryption */
/* ------------------- */

char *crypt();
static char pwbuf[14];


char *
genpasswd(pw)
  char *pw;
{
  if (pw[0])
  {
    char saltc[2], c;
    int i;

    i = 9 * getpid();
    saltc[0] = i & 077;
    saltc[1] = (i >> 6) & 077;

    for (i = 0; i < 2; i++)
    {
      c = saltc[i] + '.';
      if (c > '9')
        c += 7;
      if (c > 'Z')
        c += 6;
      saltc[i] = c;
    }
    strcpy(pwbuf, pw);
    return crypt(pwbuf, saltc);
  }
  return "";
}


int
checkpasswd(passwd, test)
  char *passwd, *test;
{
  char *pw;

  strncpy(pwbuf, test, 14);
  pw = crypt(pwbuf, passwd);
  return (!strncmp(pw, passwd, 14));
}


/* ------------------ */
/* ˬd user Up */
/* ------------------ */


static int
bad_user_id(userid)
  char *userid;
{
  register char ch;

  if (strlen(userid) < 2)
    return 1;

  if (not_alpha(*userid))
    return 1;

  if (!ci_strcmp(userid, str_new))
    return 1;

  while (ch = *(++userid))
  {
    if (not_alnum(ch))
      return 1;
  }
  return 0;
}


/* -------------------------------- */
/* New policy for allocate new user */
/* (a) is the worst user currently  */
/* (b) is the object to be compared */
/* -------------------------------- */


static int
compute_user_value(urec, clock)
  userec *urec;
  time_t clock;
{
  int value;

  /* if (urec) has XEMPT permission, sysop and BM don't kick it */
  if ((urec->userid[0] == '\0') || (urec->userlevel & PERM_XEMPT)|| (urec->userlevel & PERM_SYSOP)|| (urec->userlevel & PERM_BM)||( urec->userlevel == 0))
    return 9999;

  /***** don't delete guest ***/
  if (strcmp(urec->userid, STR_GUEST) == 0)
    return 9999;
   

  value = (clock - urec->lastlogin) / 60;       /* minutes */

  /* new user should register in 30 mins */
  if (strcmp(urec->userid, str_new) == 0)
    return (30 - value);

#ifdef  VACATION
  return 120 * 24 * 60 - value; /* HOsb 120  */
#else
  if (urec->userlevel & PERM_MAILLIMIT) /* ĤT */
  {
    if (urec->numlogins <= 3)     /* #login ֩T̡AOd 160  */
      return 160 * 24 * 60 - value;
    if (urec->numlogins <= 15)     /* #login ֩15̡AOd 190  */
      return 190 * 24 * 60 - value;
    if (urec->numlogins <= 75)     /* #login ֩75̡AOd 250  */
      return 250 * 24 * 60 - value;
    if (urec->numlogins <= 750)     /* #login ֩750̡AOd 340   */
      return 340 * 24 * 60 - value;
    else                           /* #j750̡AOd 400   */
      return 400 * 24 * 60 - value;
  }
  if (urec->userlevel & PERM_LOGINOK) /*  2  */
  {
    if (urec->numlogins <= 3)     /* #login ֩T̡AOd 130  */
      return 130 * 24 * 60 - value;
    if (urec->numlogins <= 15)     /* #login ֩15̡AOd 145  */
      return 145 * 24 * 60 - value;
    if (urec->numlogins <= 75)     /* #login ֩75̡AOd 175  */
      return 175 * 24 * 60 - value;
    if (urec->numlogins <= 750)     /* #login ֩750̡AOd 220   */
      return 220 * 24 * 60 - value;
    else                           /* #j750̡AOd 250   */
      return 250 * 24 * 60 - value;
  }
  /**************** other 0,1 degree ***************************/
  if (!urec->numlogins)         /*  login \̡AOd */
    return -1;
  if (urec->numlogins <= 7)     /* #login ֩T̡AOd 10  */
    return 10 * 24 * 60 - value;
  if (urec->numlogins <=35)     /* #login ֩35̡AOd 50  */
    return 50 * 24 * 60 - value;
  else
    return 90 * 24 * 60 - value; /* #j35̡AOd 90   */

#endif
}


static int
getnewuserid()
{
  static char *fn_fresh = ".fresh";
  extern struct UCACHE *uidshm;
  userec utmp, zerorec;
  time_t clock;
  struct stat st;
  int fd, val, i;
  char genbuf[200];
  char genbuf2[200];

  memset(&zerorec, 0, sizeof(zerorec));
  clock = time(NULL);

  /* -------------------------------------- */
  /* Lazy method : MwgMLb */
  /* -------------------------------------- */

  if ((i = searchnewuser(0)) == 0)
  {

    /* ------------------------------- */
    /* C 1 ӤpɡAMz user b@ */
    /* ------------------------------- */

    if ((stat(fn_fresh, &st) == -1) || (st.st_mtime < clock - 3600))
    {
      if ((fd = open(fn_fresh, O_RDWR | O_CREAT, 0600)) == -1)
        return -1;
      write(fd, ctime(&clock), 25);
      close(fd);
      log_usies("CLEAN", "dated users");

      printf("Msb, еyݤ...\n\r");
      if ((fd = open(fn_passwd, O_RDWR | O_CREAT, 0600)) == -1)
        return -1;
      i = 0;
      while (i < MAXUSERS)
      {
        i++;
        if (read(fd, &utmp, sizeof(userec)) != sizeof(userec))
          break;
/*
woju
*/
        if ((val = compute_user_value(&utmp, clock)) < 0) {
           sprintf(genbuf, "#%d %-12s %15.15s %d %d %d",
             i, utmp.userid, ctime(&(utmp.lastlogin)) + 4,
             utmp.numlogins, utmp.numposts, val);
           if (val > -1 * 60 * 24 * 365) /** LNFI****/
           {
             log_usies("CLEAN", genbuf);
             sprintf(genbuf, "home/%s", utmp.userid);
             sprintf(genbuf2, "tmp/%s", utmp.userid);
             if (Rename(genbuf, genbuf2))
             {
               sprintf(genbuf, "/bin/rm -fr home/%s", utmp.userid);
               system(genbuf);
             }
             lseek(fd, (i - 1) * sizeof(userec), SEEK_SET);
             write(fd, &zerorec, sizeof(utmp));
           }
           else
              log_usies("DATED", genbuf);
        }
      }
      close(fd);
      time(&(uidshm->touchtime));
    }
  }
  if ((fd = open(fn_passwd, O_RDWR | O_CREAT, 0600)) == -1)
    return -1;
  flock(fd, LOCK_EX);

  i = searchnewuser(1);
  if ((i <= 0) || (i > MAXUSERS))
  {
    flock(fd, LOCK_UN);
    close(fd);
    if (more("etc/user_full", NA) == -1)
      printf("pAϥΪ̱bwgFALkUsb\n\r");
    val = (st.st_mtime - clock + 3660) / 60;
    printf("е %d Aդ@AAnB\n\r", val);
    sleep(2);
    exit(1);
  }

  sprintf(genbuf, "uid %d", i);
  log_usies("APPLY", genbuf);

  strcpy(zerorec.userid, str_new);
  zerorec.lastlogin = clock;
  if (lseek(fd, sizeof(zerorec) * (i - 1), SEEK_SET) == -1)
  {
    flock(fd, LOCK_UN);
    close(fd);
    return -1;
  }
  write(fd, &zerorec, sizeof(zerorec));
  setuserid(i, zerorec.userid);
  flock(fd, LOCK_UN);
  close(fd);
  return i;
}



void
new_register()
{
  userec newuser;
  char passbuf[STRLEN];
  int allocid, try;
  char genbuf[200];

#if 0
  time_t now;

  /* ------------------ */
  /* wPXU */
  /* ------------------ */

  now = time(0);
  sprintf(genbuf, "etc/no_register_%3.3s", ctime(&now));
  if (more(genbuf, NA) != -1)
  {
    pressanykey();
    exit(1);
  }
#endif

  memset(&newuser, 0, sizeof(newuser));
  allocid = getnewuserid();
  if (allocid > MAXUSERS || allocid <= 0)
  {
    fprintf(stderr, "HfwFMI\n");
    exit(1);
  }

  more("etc/register", NA);
  try = 0;
  while (1)
  {
    if (++try >= 6)
    {
      outs("\nzտ~JӦhAФUAӧa\n");
      refresh();

      pressanykey();
      oflush();
      exit(1);

      /*
      return;
      */
/*longjmp(byebye, -1);*/
    }
    getdata(0, 0, msg_uid, newuser.userid, IDLEN + 1, DOECHO);

    if (bad_user_id(newuser.userid))
      outs("LkoӥNAШϥέ^rAåBn]tŮ\n");
    else if (searchuser(newuser.userid))
      outs("NwgHϥ\n");
/*
    else if (strcmp(newuser.userid, "Raw") == 0) {
      outs("\nCJɮ\n");
      logfile("Raw", getenv("RFC931"),"logins.Raw");
      refresh();
      pressanykey();
      oflush();
      exit(1);
    }
*/
    else
      break;
  }

    try = 0;
  while (1)
  {
    if (++try >= 6)
    {
      outs("\nzտ~JӦhAФUAӧa\n");
      refresh();

      pressanykey();
      oflush();
      exit(1);

      /*
      return;
      */
/*longjmp(byebye, -1);*/
    }
    if ((getdata(0, 0, "г]wKXG", passbuf, PASSLEN, NOECHO) < 3) ||
      !strcmp(passbuf, newuser.userid))
    {
      outs("KX²ADJIAܤ֭n 4 ӦrAЭsJ\n");
      continue;
    }
    strncpy(newuser.passwd, passbuf, PASSLEN);
    getdata(0, 0, "ˬdKXG", passbuf, PASSLEN, NOECHO);
    if (strncmp(passbuf, newuser.passwd, PASSLEN))
    {
      outs("KXJ~, ЭsJKX.\n");
      continue;
    }
    passbuf[8] = '\0';
    strncpy(newuser.passwd, genpasswd(passbuf), PASSLEN);
    break;
  }
/*
  getdata(0, 0, "׺ݾκA [vt100]G", newuser.termtype, 8, ECHO);
  if (newuser.termtype[0] == '\0')
  strcpy(newuser.termtype, "vt100");
*/
  newuser.userlevel = PERM_DEFAULT;
  newuser.uflag = COLOR_FLAG | BRDSORT_FLAG | MOVIE_FLAG;
  newuser.firstlogin = newuser.lastlogin = time(NULL);
  newuser.year = newuser.month = newuser.day = NULL;
  newuser.sex = 8;

  if (substitute_record(fn_passwd, &newuser, sizeof(newuser), allocid) == -1)
  {
    fprintf(stderr, "ȺFAAI\n");
    exit(1);
  }
  setuserid(allocid, newuser.userid);
  if (!dosearchuser(newuser.userid))
  {
    fprintf(stderr, "Lkإ߱b\n");
    exit(1);
  }
  
  more("etc/newuser", YEA);
}


void
check_register()
{
  char *ptr;
  char genbuf[200];

  stand_title("иԲӶgӤH");

  while (strlen(cuser.username) < 2)
    getdata(2, 0, "︹ʺ١G", cuser.username, 24, DOECHO);

  for (ptr = cuser.username; *ptr; ptr++)
  {
    if (*ptr == 9)              /* TAB convert */
      *ptr == ' ';
  }

  while (strlen(cuser.realname) < 4)
    getdata(4, 0, "umWG", cuser.realname, 20, DOECHO);

  while (strlen(cuser.address) < 8)
    getdata(6, 0, "a}+(q)G", cuser.address, 50, DOECHO);

  if (!strchr(cuser.email, '@'))
  {
    bell();
    move(t_lines - 4, 0);
    prints("\
 FzvqAжguꪺ E-mail addressA HT{դUA\n\
   榡 [44muser@domain_name[0m  [44muser@\\[ip_number\\][0mC\n\n\
 pGzuS E-mailAЪ [return] YiC");

    do
    {
      getdata(8, 0, "qlHcG", cuser.email, 50, DOECHO);
      if (!cuser.email[0])
        sprintf(cuser.email, "%s%s", cuser.userid, str_mail_address);
    } while (!strchr(cuser.email, '@'));

#ifdef  EMAIL_JUSTIFY
    mail_justify();
#endif
  }
  clear();
  while (cuser.month > 12 || cuser.month < 1 ||
        cuser.day > 31 || cuser.day < 1 || cuser.year > 2000 || cuser.year < 1920)
    {
      int len;
      sprintf(genbuf, "%02i/%02i/%04i",
        cuser.month, cuser.day, cuser.year);
      len = getdata(10, 0, "ͤ //褸(ҡG03/15/1986)G", genbuf, 11, DOECHO, 0);
      if (len && len != 10)
        continue;
      if (!len)
        continue;
      else if (len == 10)
      {
        cuser.month = (genbuf[0] - '0') * 10 + (genbuf[1] - '0');
        cuser.day   = (genbuf[3] - '0') * 10 + (genbuf[4] - '0');
	cuser.year  = (genbuf[6] - '0') * 1000 + (genbuf[7] - '0') * 100
                     + (genbuf[8] - '0') * 10 +  (genbuf[9] - '0') ;
      }
      else
        continue;
    }

  while (cuser.sex >= 8){
    strcpy(genbuf,
      "ʧO (1) (2)j (3)} (4) (5) (6) (7)Ӫ (8)q "
      "[?]G");
    getdata(12, 0, genbuf, genbuf, 3, DOECHO, 0);
    if (genbuf[0] >= '1' && genbuf[0] <= '8')
      cuser.sex = genbuf[0] - '1';
  }

  cuser.userlevel |= PERM_DEFAULT;
  if (!HAS_PERM(PERM_SYSOP) && !(cuser.userlevel & PERM_LOGINOK))
  {
    /* ^йL{ҫHAδg E-mail post L */

    setuserfile(genbuf, "email");
    if (dashf(genbuf))
    {
      cuser.userlevel |= PERM_LOGINOK;
      unlink(genbuf);
    }

#ifdef  STRICT
    else
    {
      cuser.userlevel &= ~PERM_POST;
      more("etc/justify", YEA);
    }
#endif
  }

#ifdef  NEWUSER_LIMIT
  /*if (cuser.lastlogin - cuser.firstlogin < 3 * 86400 && ...)*/
  if (!(cuser.userlevel & PERM_LOGINOK) && !HAS_PERM(PERM_SYSOP))
  {
    if (cuser.lastlogin - cuser.firstlogin < 3 * 86400)
      cuser.userlevel &= ~PERM_POST;
    more("etc/newuser", YEA);
  }
#endif

  if (HAS_PERM(PERM_DENYPOST) && !HAS_PERM(PERM_SYSOP))
    cuser.userlevel &= ~PERM_POST;
}
