/*-------------------------------------------------------*/
/* user.c	( NTHU CS MapleBBS Ver 2.36 )		 */
/*-------------------------------------------------------*/
/* author : opus.bbs@bbs.cs.nthu.edu.tw		 	 */
/* target : user configurable setting routines	 	 */
/* create : 95/03/29				 	 */
/* update : 95/12/15				 	 */
/*-------------------------------------------------------*/


#include "bbs.h"

extern int numboards;
extern boardheader *bcache;
extern void resolve_boards();

char *sex[8] = { MSG_BIG_BOY, MSG_BIG_GIRL, MSG_LITTLE_BOY, MSG_LITTLE_GIRL,
		 MSG_MAN, MSG_WOMAN, MSG_PLANT, MSG_MIME };

void
user_display(u, real)
  userec *u;
{
  int diff;
  char genbuf[200];

  clrtobot();
  if (real!=2)
  {
    prints("\n"
    "N        G%s\n"
    "ʺ        G%s\n"
    "umW    G%s\n"
    "}(q)  G%s\n"
    "qllHcG%s\n"
    "ʧO        G%s\n"
    "ͤ        G%02i/%02i/%02i\n",
    u->userid,
    u->username,
    u->realname,
    u->address,
    u->email,
    sex[u->sex],
    u->month, u->day, u->year);
  }
  else //tjm add exit mode
  {
    real=0;
    prints("\n"
    "N        G%s\n"
    "ʺ        G%s\n"
    ,u->userid,
    u->username
    );
  }
  prints(/*"׺ݾκA  G%s\n"*/
    "U    G%s",
    /*u->termtype,*/
    ctime(&u->firstlogin));

  prints("̪{G%s", ctime(&u->lastlogin));

  if (real)
    prints("̪{G%s\n", u->lasthost);

  prints("W    G%d \n", u->numlogins);

  prints("峹ƥ    G%d g\n", u->numposts);

  sethomedir(genbuf, u->userid);
  prints("pHHc    G%d \n", get_num_records(genbuf, sizeof(fileheader)));

  if (real)
  {
    strcpy(genbuf, "bTCPRp#@XWBA#VS");
    for (diff = 0; diff < 15; diff++)
      if (!(u->userlevel & (1 << diff)))
	genbuf[diff] = '-';
    prints("{Ҹ    G%s\nϥΪv  G%s\n", u->justify, genbuf);
  }
  else
  {
    diff = (time(0) - login_start_time) / 60;
    prints("d    G%d p %2d \n", diff / 60, diff % 60);
  }

  /* Thor: Qݬݳo user OǪD */

  if (u->userlevel >= PERM_BM)
  {
    int i, len, ch;
    boardheader *bhdr;
    char *list;

    resolve_boards();

    len = strlen(u->userid);

    outs("OD    G");

    for (i = 0, bhdr = bcache; i < numboards; i++, bhdr++)
    {
      list = bhdr->BM;
      ch = list[0];
      if ((ch > ' ') && (ch < 128))
      {
        do
        {
          if (!ci_strncmp(list, u->userid, len))
          {
            ch = list[len];
            if ((ch == 0) || (ch == '/'))
            {
              outs(bhdr->brdname);
	      outc(' ');
              break;
	    }
	  }
	  while (ch = *list++)
	    if (ch == '/')
              break;
	} while (ch);
      }
    }
    outc('\n');
  }

  outs((u->userlevel & PERM_LOGINOK) ?
    "\nzU{ǤwgAw[J" :
    "\npGn@vAаѦҥGzU");

#ifdef	NEWUSER_LIMIT
  if ((u->lastlogin - u->firstlogin < 3 * 86400) && !HAS_PERM(PERM_POST))
    outs("\nsWATѫ}v");
#endif
}


void
uinfo_query(u, real, unum)
  userec *u;
{
  userec x;
  register int i, fail, mail_changed;
  char ans[4], buf[STRLEN];
  char genbuf[200];

  char *genpasswd();


  fail = mail_changed = 0;

  memcpy(&x, u, sizeof(userec));
  getdata(b_lines - 1, 0, real ?
    "(1)ק (2)]wKX (3)]wv (4)Mb (5)ID [0] " :
    "п (1)ק (2)]wKX ==> [0] ",
    ans, 3, DOECHO);

  if (ans[0] > '2' && !real)
  {
    ans[0] = '0';
  }

  if (ans[0] == '1' || ans[0] == '3')
  {
    clear();
    i = 2;
    move(i++, 0);
    outs(msg_uid);
    outs(x.userid);
  }

  switch (ans[0])
  {
  case '1':
    move(0, 0);
    outs("гvק, <ENTER> Nϥ [] ơC");

    sprintf(genbuf, "ʺ [%s]G", u->username);
    if (getdata(i++, 0, genbuf, buf, 24, DOECHO))
      strcpy(x.username, buf);

    sprintf(genbuf, "umW [%s]G", u->realname);
    if (getdata(i++, 0, genbuf, buf, 20, DOECHO))
      strcpy(x.realname, buf);

    sprintf(genbuf, "a}+(q) [%s]G", u->address);
    if (getdata(i++, 0, genbuf, buf, 50, DOECHO))
      strcpy(x.address, buf);

    sprintf(genbuf, "qlHc [%s]G", u->email);
    getdata(i++, 0, genbuf, buf, 50, DOECHO);
    if (strchr(buf, '@'))
    {
      strcpy(x.email, buf);
      mail_changed = 1 - real;
    }
    
    sprintf(genbuf, 
      "ʧO (1) (2)j (3)} (4) (5) (6) (7)Ӫ (8)q "
      "[%i]G", u->sex + 1);
    getdata(i++, 0, genbuf, buf, 3, DOECHO);
    if (buf[0] >= '1' && buf[0] <= '8')
      x.sex = buf[0] - '1';
    else
      x.sex = u->sex;
    
    while (1)
    {
      int len;

      sprintf(genbuf, "ͤ //褸 [%02i/%02i/%04i]G", 
	u->month, u->day, u->year);
      len = getdata(i, 0, genbuf, buf, 11, DOECHO);
      if (len && len != 10)
	continue;
      if (!len)
      {
	x.month = u->month;
	x.day   = u->day;
	x.year  = u->year;
      }
      else if (len == 10)
      {
        x.month = (buf[0] - '0') * 10 + (buf[1] - '0');
        x.day   = (buf[3] - '0') * 10 + (buf[4] - '0');
        x.year  = (buf[6] - '0') * 1000 + (buf[7] - '0') * 100
		 +(buf[8] - '0') * 10 + (buf[9] - '0');
      }
      else
        continue;
      if (!real && (x.month > 12 || x.month < 1 || 
	x.day > 31 || x.day < 1 || x.year > 2000 || x.year < 1920))
	continue;
      i++;
      break;
    }
/*
    sprintf(genbuf, "׺ݾκA [%s]G", u->termtype);
    if (getdata(i++, 0, genbuf, buf, 8, DOECHO))
      strcpy(x.termtype, buf);
*/
    if (real)
    {
      sprintf(genbuf, "{Ҹ[%s]G", u->justify);
      if (getdata(i++, 0, genbuf, buf, 44, DOECHO))
	strcpy(x.justify, buf);

      sprintf(genbuf, "̪{[%s]G", u->lasthost);
      if (getdata(i++, 0, genbuf, buf, 16, DOECHO))
	strcpy(x.lasthost, buf);
     
      sprintf(genbuf, "Wu [%d]G", u->numlogins);
      if (getdata(i++, 0, genbuf, buf, 10, DOECHO))
	if ((fail = atoi(buf)) >= 0)
	  x.numlogins = fail;

      sprintf(genbuf, "峹ƥ [%d]G", u->numposts);
      if (getdata(i++, 0, genbuf, buf, 10, DOECHO))
	if ((fail = atoi(buf)) >= 0)
	  x.numposts = fail;

      fail = 0;
    }
    break;

  case '2':
    i = 19;
    if (!real)
    {
      if (!getdata(i++, 0, "пJKXG", buf, PASSLEN, NOECHO) ||
	!checkpasswd(u->passwd, buf))
      {
	outs("\n\nzJKXT\n");
	fail++;
	break;
      }
    }

    if (!getdata(i++, 0, "г]wsKXG", buf, PASSLEN, NOECHO))
    {
      outs("\n\nKX]w, ~ϥ±KX\n");
      fail++;
      break;
    }
    strncpy(genbuf, buf, PASSLEN);

    getdata(i++, 0, "ˬdsKXG", buf, PASSLEN, NOECHO);
    if (strncmp(buf, genbuf, PASSLEN))
    {
      outs("\n\nsKXT{, Lk]wsKX\n");
      fail++;
      break;
    }
    buf[8] = '\0';
    strncpy(x.passwd, genpasswd(buf), PASSLEN);
    break;

  case '3':
    i = setperms(x.userlevel);
    if (i == x.userlevel)
      fail++;
    else
      x.userlevel = i;
    break;

  case '4':
    i = QUIT;
    break;

  case '5':
    if (getdata(b_lines - 3, 0, "sϥΪ̥NG", genbuf, IDLEN + 1, DOECHO))
    {
      if (searchuser(genbuf))
      {
	outs("~! wgP ID ϥΪ");
	fail++;
      }
      else
      {
	strcpy(x.userid, genbuf);
      }
    }
    break;

  default:
    return;
  }

  if (fail)
  {
    pressanykey();
    return;
  }

  getdata(b_lines - 1, 0, msg_sure_ny, ans, 3, LCECHO);
  if (*ans == 'y')
  {
    if (strcmp(u->userid, x.userid))
    {
      char src[STRLEN], dst[STRLEN];

      sethomepath(src, u->userid);
      sethomepath(dst, x.userid);
      Rename(src, dst);
      setuserid(unum, x.userid);
    }
    memcpy(u, &x, sizeof(x));
    if (mail_changed)
    {

#ifdef	EMAIL_JUSTIFY
      x.userlevel &= ~PERM_LOGINOK;
      mail_justify();
#endif
    }

    if (i == QUIT)
    {
      char src[STRLEN], dst[STRLEN];

      sprintf(src, "home/%s", x.userid);
      sprintf(dst, "tmp/%s", x.userid);
      if (Rename(src, dst))
      {
	sprintf(genbuf, "/bin/rm -fr %s", src);
	system(genbuf);
      }
/*
woju
*/
      log_usies("KILL", x.userid);
      x.userid[0] = '\0';
      setuserid(unum, x.userid);
    }
    else
       log_usies("SetUser", x.userid);
    substitute_record(fn_passwd, &x, sizeof(x), unum);
  }
}


int
u_info()
{
  FILE *fp;
  char fpath[256]; 
 
  move(2, 0);
  user_display(&cuser, 0);
  uinfo_query(&cuser, 0, usernum);

  // chk forward email address file forward.on
  sprintf(fpath, "home/%s/forward.on", cuser.userid);
  if (fp = fopen(fpath, "r")) {
     fclose(fp);

     fp = fopen(fpath, "w");
     fprintf(fp, "%s", cuser.email);
     fclose(fp);
  }

  strcpy(currutmp->realname, cuser.realname);
  strcpy(currutmp->username, cuser.username);
  return 0;
}


int
u_ansi()
{
  showansi ^= 1;
  cuser.uflag ^= COLOR_FLAG;
  outs(reset_color);
  return 0;
}


int
u_cloak()
{
  outs((currutmp->invisible ^= 1) ? MSG_CLOAKED : MSG_UNCLOAK);
  return XEASY;
}


int
u_lock()
{
  char genbuf[PASSLEN]; 

  log_usies("LOCK ", "screen");

  do
  {
    getdata(b_lines - 1, 0, " пJKXAHѰùwG",
      genbuf, PASSLEN, NOECHO);
  } while (!checkpasswd(cuser.passwd, genbuf));

  return FULLUPDATE;
}


#ifdef	HAVE_SUICIDE
int
u_kill()
{
  char genbuf[200];

  getdata(b_lines - 1, 0, " pGTwnMzbAпJKXG",
    genbuf, PASSLEN, NOECHO);

  if (*genbuf == '\0' || !checkpasswd(cuser.passwd, genbuf))
  {
    outmsg("zJKXTAbMC");
    igetch();
    return FULLUPDATE;
  }

#ifdef	HAVE_REPORT
  report("suicide");
#endif

  sprintf(genbuf, "#%d %s:%s %d %d",
    usernum, cuser.realname, cuser.username, cuser.numlogins, cuser.numposts);
  log_usies("SUCI ", genbuf);

  sprintf(genbuf, "%s %s", fromhost, Cdate(&(cuser.firstlogin)));
  log_usies("SUCI ", genbuf);

  sethomepath(genbuf, cuser.userid);
  if (Rename(genbuf, "tmp"))
  {
/*
woju
*/
    sprintf(genbuf, "(cd home; tar cvf SUCI_%s.tar %s); /bin/rm -fr home/%s",
	    cuser.userid, cuser.userid, cuser.userid);
    system(genbuf);
  }
  cuser.userid[0] = '\0';
  substitute_record(fn_passwd, &cuser, sizeof(cuser), usernum);
  setuserid(usernum, cuser.userid);
  purge_utmp(currutmp);

  clear();
  outs("˷RB͡ACsbAyA̫|aI");
  pressanykey();
  //sleep(1);
  reset_tty();
  exit(0);
}
#endif


void
showplans(uid)
  char *uid;
{
  FILE *planfile;
  int i;
  char genbuf[200];

  sethomefile(genbuf, uid, fn_plans);
  if (planfile = fopen(genbuf, "r"))
  {
    prints("%s W:\n", uid);
    i = 0;
    while (i++ < MAXQUERYLINES && fgets(genbuf, 256, planfile))
    {
      outs(kaede_prints(genbuf));
    }
    fclose(planfile);
  }
  else
    prints("%s ثeSW", uid);
}


int
showsignature(fname)
  char *fname;
{
  FILE *fp;
  char buf[256];
  int i, j;
  char ch;

  clear();
  move(2, 0);
  setuserfile(fname, "sig.0");
  j = strlen(fname) - 1;

  for (ch = '1'; ch <= '9'; ch++)
  {
    fname[j] = ch;
    if (fp = fopen(fname, "r"))
    {
      prints("[36mi ñW.%c j[m\n", ch);
      for (i = 0; i++ < MAXSIGLINES && fgets(buf, 256, fp); outs(buf));
      fclose(fp);
    }
  }
  return j;
}


int
u_editsig()
{
  int aborted;
  char ans[4];
  int j;
  char genbuf[200];

  j = showsignature(genbuf);

  getdata(0, 0, "ñW (E)s (D)R (Q)H[Q] ", ans, 4, LCECHO);

  aborted = 0;
  if (ans[0] == 'd')
    aborted = 1;
  if (ans[0] == 'e')
    aborted = 2;

  if (aborted)
  {
    if (!getdata(1, 0, "пñW(1-9)H[1] ", ans, 4, DOECHO))
      ans[0] = '1';
    if (ans[0] >= '1' && ans[0] <= '9')
    {
      genbuf[j] = ans[0];
      if (aborted == 1)
      {
	unlink(genbuf);
	outs(msg_del_ok);
      }
      else
      {
	setutmpmode(EDITSIG);
	aborted = vedit(genbuf, NA);
	if (!aborted)
	  outs("ñWɧs");
      }
    }
    pressanykey();
  }
  return 0;
}


int
u_editplan()
{
  char genbuf[200];

  getdata(b_lines - 1, 0, "W (D)R (E)s [Q]H[Q] ", genbuf, 3, LCECHO);

  if (genbuf[0] == 'e')
  {
    int aborted;

    setutmpmode(EDITPLAN);
    setuserfile(genbuf, fn_plans);
    aborted = vedit(genbuf, NA);
    if (!aborted)
      outs("Ws");
    pressanykey();
    return 0;
  }
  else if (genbuf[0] == 'd')
  {
    setuserfile(genbuf, fn_plans);
    unlink(genbuf);
    outmsg("WR");
  }
  return 0;
}


/* --------------------------------------------- */
/* ϥΪ̶gU				 */
/* --------------------------------------------- */

static void
getfield(line, info, desc, buf, len)
  int line, len;
  char *info, *desc, *buf;
{
  char prompt[STRLEN];
  char genbuf[200];

  sprintf(genbuf, "]wG%-46.46s (%s)", buf, info);
  move(line, 2);
  outs(genbuf);
  sprintf(prompt, "%sG", desc);
  if (getdata(line + 1, 2, prompt, genbuf, len, DOECHO))
    strcpy(buf, genbuf);
  move(line, 2);
  prints("%sG%s", desc, buf);
  clrtoeol();
}


int
u_register()
{
  char rname[20], addr[50];
  char phone[20], career[40];
  char ans[3], *ptr;
  FILE *fn;
  time_t now;
  char genbuf[200];
/*
  if (cuser.userlevel & PERM_LOGINOK)
  {
    outs("zT{wgAݶgӽЪ");
    return XEASY;
  }
*/
  if (fn = fopen(fn_register, "r"))
  {
    while (fgets(genbuf, STRLEN, fn))
    {
      if (ptr = strchr(genbuf, '\n'))
	*ptr = '\0';
      if (strncmp(genbuf, "uid: ", 5) == 0 &&
	strcmp(genbuf + 5, cuser.userid) == 0)
      {
	fclose(fn);
	outs("zUӽг|bBzAЭ@ߵ");
	return XEASY;
      }
    }
    fclose(fn);
  }

  getdata(b_lines - 1, 0, "zTwngU(Y/N)H[N] ", ans, 3, LCECHO);
  if (ans[0] != 'y')
    return XEASY;

  move(2, 0);
  clrtobot();
  strcpy(rname, cuser.realname);
  strcpy(addr, cuser.address);
  career[0] = phone[0] = '\0';
  while (1)
  {
    clear();
    move(3, 0);
    prints("%s(%s) znAоڹgHU:",
      cuser.userid, cuser.username);
    getfield(6, "ХΤ", "umW", rname, 20);
    getfield(8, "Ǯըtũγ¾", "Aȳ", career, 40);
    getfield(10, "]AǩΪPX", "ثe}", addr, 50);
    getfield(12, "]A~ϰX", "sq", phone, 20);
    getdata(b_lines - 1, 0, "HWƬO_T(Y/N)H(Q)U [N] ", ans, 3, LCECHO);
    if (ans[0] == 'q')
      return 0;
    if (ans[0] == 'y')
      break;
  }
  strcpy(cuser.realname, rname);
  strcpy(cuser.address, addr);
  if (fn = fopen(fn_register, "a"))
  {
    now = time(NULL);
    trim(career);
    trim(addr);
    trim(phone);
    fprintf(fn, "num: %d, %s", usernum, ctime(&now));
    fprintf(fn, "uid: %s\n", cuser.userid);
    fprintf(fn, "name: %s\n", rname);
    fprintf(fn, "career: %s\n", career);
    fprintf(fn, "addr: %s\n", addr);
    fprintf(fn, "phone: %s\n", phone);
    fprintf(fn, "----\n");
    fclose(fn);
  }
  return 0;
}


/* --------------------------------------------- */
/* CXҦUϥΪ				 */
/* --------------------------------------------- */


extern struct UCACHE *uidshm;
int usercounter, totalusers, showrealname;
ushort u_list_special;


static int
u_list_CB(uentp)
  userec *uentp;
{
  static int i;
  char permstr[8], *ptr;
  register int level;

  if (uentp == NULL)
  {
    move(2, 0);
    clrtoeol();
    prints("[7m  ϥΪ̥N   %-25s   W  峹  %s  ̪{     [0m\n",

    showrealname ?
/*#if defined(REALINFO) && defined(ACTS_REALNAMES)*/
      "umW" :
/*#else*/
      "︹ʺ"
/*#endif*/

      ,HAS_PERM(PERM_SEEULEVELS) ? "" : "");
    i = 3;
    return 0;
  }
  if (uentp->userid[0] == '\0')
    return 0;
  if (uentp->userlevel < u_list_special)
    return 0;

  if (i == b_lines)
  {
    prints("[34;46m  w %d/%d H(%d%%)  [31;47m  (Space)[30m ݤU@  [31m(Q)[30m }  [0m",
      usercounter, totalusers, usercounter * 100 / totalusers);
    i = igetch();
    if (i == 'q' || i == 'Q')
      return QUIT;
    i = 3;
  }
  if (i == 3)
  {
    move(3, 0);
    clrtobot();
  }

  level = uentp->userlevel;
  strcpy(permstr, "----");
  if (level & PERM_SYSOP)
    permstr[0] = 'S';
  else if (level & PERM_ACCOUNTS)
    permstr[0] = 'A';
  else if (level & PERM_DENYPOST)
    permstr[0] = 'p';

  if (level & (PERM_BOARD))
    permstr[1] = 'B';
  else if (level & (PERM_BM))
    permstr[1] = 'b';

  if (level & (PERM_XEMPT))
    permstr[2] = 'X';
  else if (level & (PERM_LOGINOK))
    permstr[2] = 'R';

  if (level & (PERM_CLOAK | PERM_SEECLOAK))
    permstr[3] = 'C';

  ptr = (char *) Cdate(&uentp->lastlogin);
  ptr[18] = '\0';
  prints("%-14s %-27.27s%5d %5d  %s  %s\n",
    uentp->userid,

    showrealname ?
/*#if defined(REALINFO) && defined(ACTS_REALNAMES)*/
    uentp->realname :
/*#else*/
    uentp->username
/*#endif*/

    ,uentp->numlogins, uentp->numposts,
    HAS_PERM(PERM_SEEULEVELS) ? permstr : "", ptr);
  usercounter++;
  i++;
  return 0;
}


int
u_list()
{
  char genbuf[3];

  setutmpmode(LAUSERS);
  showrealname = u_list_special = usercounter = 0;
  totalusers = uidshm->number;
  if (HAS_PERM(PERM_SEEULEVELS))
  {
    getdata(b_lines - 1, 0, "[ [1]S (2)H", genbuf, 3, DOECHO);
    if (genbuf[0] != '2')
      u_list_special = 32;
  }  
  if (HAS_PERM(PERM_CHATROOM) || HAS_PERM(PERM_SYSOP))
  {
    getdata(b_lines - 1, 0, " [1]umW (2)ʺ١H", genbuf, 3, DOECHO);
    if (genbuf[0] != '2')
      showrealname = 1;
  }
  u_list_CB(NULL);
  if (apply_record(fn_passwd, u_list_CB, sizeof(userec)) == -1)
  {
    outs(msg_nobody);
    return XEASY;
  }
  move(b_lines, 0);
  clrtoeol();
  prints("[34;46m  w %d/%d ϥΪ(tήeqLW)  [31;47m  (ЫN~)  [0m",
    usercounter, totalusers);
  egetch();
  return 0;
}
