/*-------------------------------------------------------*/
/* vote.c	( NTHU CS MapleBBS Ver 2.36 )		 */
/*-------------------------------------------------------*/
/* target : boards' vote routines		 	 */
/* create : 95/03/29				 	 */
/* update : 95/12/15				 	 */
/*-------------------------------------------------------*/

#include "bbs.h"
#include <time.h>

long atol();
extern cmpbnames();
extern int numboards;


static char STR_bv_control[] = "control";
static char STR_bv_desc[] = "desc";
static char STR_bv_ballots[] = "ballots";
static char STR_bv_results[] = "results";
static char STR_bv_flags[] = "flags";
static char STR_bv_tickets[] = "tickets";


void
b_suckinfile(fp, fname)
  FILE *fp;
  char *fname;
{
  FILE *sfp;

  if (sfp = fopen(fname, "r"))
  {
    char inbuf[256];

    while (fgets(inbuf, sizeof(inbuf), sfp))
      fputs(inbuf, fp);
    fclose(sfp);
  }
}



int
b_closepolls()
{
  static char *fn_vote_polling = ".voting";
  boardheader fh;
  struct stat st;
  FILE *cfp;
  char buf[80];
  time_t now;
  int fd, dirty;

  now = time(NULL);

  if (stat(fn_vote_polling, &st) == -1 || st.st_mtime > now - 3600)
    return 0;

  if ((cfp = fopen(fn_vote_polling, "w")) == NULL)
    return 0;
  fprintf(cfp, ctime(&now));
  fclose(cfp);

  resolve_boards();
  if ((fd = open(fn_board, O_RDWR)) == -1)
  {
    outs(ERR_BOARD_OPEN);
    return -1;
  }

  flock(fd, LOCK_EX);
  dirty = 0;
  while (read(fd, &fh, sizeof(fh)) == sizeof(fh))
  {
    if (fh.bvote && b_close(&fh))
    {
      lseek(fd, (off_t) sizeof(fh) * (getbnum(fh.brdname) - 1), SEEK_SET);
      /* lseek(fd, (off_t) -sizeof(boardheader), SEEK_CUR);  Kaede: Т */
      if (write(fd, &fh, sizeof(fh)) != sizeof(fh))
      {
	sprintf(currmsg, "[1;5;37;41mWarning![m");
        kill(currpid, SIGUSR2);
	igetch();
	break;
      }
      dirty = 1;
    }
  }
  if (dirty) /* vote flag changed */
    touch_boards();
  
  flock(fd, LOCK_UN);
  close(fd);
  return 0;
}


int
b_close(fh)
  boardheader *fh;
{
  FILE *cfp, *tfp;
  char *bname = fh->brdname;
  char buf[STRLEN];
  char inchar, inbuf[80];
  int counts[31], fd;
  int total, num ,bid;
  char b_control[64];
  char b_newresults[64];
  time_t now;
  struct stat st;

  now = time(NULL);

  if (fh->bvote == 2)
  {
    if (fh->vtime < now - 7 * 86400)
    {
      fh->bvote = 0;
      return 1;
    }
    else
      return 0;
  }

  if (fh->vtime > now)
    return 0;

  fh->bvote = 2;
  setbfile(b_control, bname, STR_bv_control);
  if (stat(b_control, &st) == -1)
  {
    fh->bvote = 0;
    return 1;
  }

  memset(counts, 0, sizeof(counts));
  setbfile(buf, bname, STR_bv_flags);
  unlink(buf);
  setbfile(buf, bname, STR_bv_tickets);
  unlink(buf);
  setbfile(buf, bname, STR_bv_ballots);
  if ((fd = open(buf, O_RDONLY)) != -1)
  {
    while (read(fd, &inchar, 1) == 1)
      counts[(int) (inchar - 'A')]++;
    close(fd);
  }
  unlink(buf);

  setbfile(b_newresults, bname, "newresults");
  if ((tfp = fopen(b_newresults, "w")) == NULL)
    return 1;

  fprintf(tfp, "%s\n 벼: %s\n Dشyz:\n\n",
    msg_seperator, ctime(&fh->vtime));

  setbfile(buf, bname, STR_bv_desc);
  b_suckinfile(tfp, buf);
  unlink(buf);

  fprintf(tfp, " 벼G:\n\n");
  total = 0;
  if (cfp = fopen(b_control, "r"))
  {
    fgets(inbuf, sizeof(inbuf), cfp);
    while (fgets(inbuf, sizeof(inbuf), cfp))
    {
      inbuf[(strlen(inbuf) - 1)] = '\0';
      inbuf[43] = '\0';		/* truncate */
      num = counts[inbuf[0] - 'A'];
      fprintf(tfp, "    %-42s%3d \n", inbuf + 3, num);
      total += num;
    }
    fclose(cfp);
  }
  unlink(b_control);

  fprintf(tfp, "\n ` = %d \n\n", total);
  setbfile(buf, bname, STR_bv_results);
  b_suckinfile(tfp, buf);
  fclose(tfp);
  Rename(b_newresults, buf);
  return 1;
}


int
vote_maintain(bname)
  char *bname;
{
  FILE *fp, *tick;
  char inbuf[STRLEN], buf[STRLEN];
  int num = 0, aborted, tickets;
  time_t closetime;
  int pos;
  boardheader fh;
  char genbuf[4];

  if (!(currmode & MODE_BOARD))
    return 0;

  stand_title("|벼");

  setbfile(buf, bname, STR_bv_control);
  if ((fp = fopen(buf, "r")))
  {
    int counts[31], fd, total, count = 0;
    char inchar;

    fgets(inbuf, sizeof(inbuf), fp);
    closetime = (time_t) atol(inbuf);
    prints("PɶLk|ӥHW벼C\n벼wp: %s",
      ctime(&closetime));

    memset(counts, 0, sizeof(counts));
    setbfile(buf, bname, STR_bv_ballots);
    if ((fd = open(buf, O_RDONLY)) != -1)
    {
      while (read(fd, &inchar, 1) == 1)
	counts[(int) (inchar - 'A')]++;
      close(fd);
    }

    outs("\n w벼:\n\n");
    total = 0;
    while (fgets(inbuf, sizeof(inbuf), fp))
    {
      inbuf[(strlen(inbuf) - 1)] = '\0';
      inbuf[43] = '\0';		/* truncate */
      num = counts[inbuf[0] - 'A'];
      count++;
      move(((count-1)%15)+4,((count-1)/15)*40);
      prints("   %-31s%3d ", inbuf, num);
      total += num;
    }
    fclose(fp);

    move(b_lines-2, 0);

    prints("\n ثe` = %d ", total);

    getdata(b_lines - 1, 0, "(A)벼 (B)} (C)~H[C] ", genbuf, 4, LCECHO);
    if (genbuf[0] == 'a')
    {
      setbfile(buf, bname, STR_bv_tickets);
      unlink(buf);
      setbfile(buf, bname, STR_bv_control);
      unlink(buf);
      setbfile(buf, bname, STR_bv_flags);
      unlink(buf);
      setbfile(buf, bname, STR_bv_ballots);
      unlink(buf);
      setbfile(buf, bname, STR_bv_desc);
      unlink(buf);

      pos = search_record(fn_board, &fh, sizeof(fh), cmpbnames, (int) bname);
      fh.bvote = 0;
      if (substitute_record(fn_board, &fh, sizeof(fh), pos) == -1)
	outs(err_board_update);
      touch_boards();		/* vote flag changed */
      resolve_boards();
    }
    else if (genbuf[0] == 'b')
    {
      char b_newresults[80];
      FILE *tfp;

      setbfile(b_newresults, bname, "newresults");
      tfp = fopen(b_newresults, "w");

      fprintf(tfp, "%s\n 벼: %s\n Dشyz:\n\n",
	msg_seperator, ctime(&closetime));

      setbfile(buf, bname, STR_bv_tickets);
      unlink(buf);
      setbfile(buf, bname, STR_bv_flags);
      unlink(buf);
      setbfile(buf, bname, STR_bv_ballots);
      unlink(buf);
      setbfile(buf, bname, STR_bv_desc);
      b_suckinfile(tfp, buf);
      unlink(buf);

      fprintf(tfp, " 벼G:\n\n");
      total = 0;
      setbfile(buf, bname, STR_bv_control);
      if (fp = fopen(buf, "r"))
      {
	fgets(inbuf, sizeof(inbuf), fp);
	while (fgets(inbuf, sizeof(inbuf), fp))
	{
	  inbuf[(strlen(inbuf) - 1)] = '\0';
	  inbuf[43] = '\0';	/* truncate */
	  num = counts[inbuf[0] - 'A'];
	  fprintf(tfp, "    %-42s%3d \n", inbuf + 3, num);
	  total += num;
	}
	fclose(fp);
      }
      unlink(buf);

      fprintf(tfp, "\n ` = %d \n\n", total);
      setbfile(buf, bname, STR_bv_results);
      b_suckinfile(tfp, buf);
      fclose(tfp);
      Rename(b_newresults, buf);

      pos = search_record(fn_board, &fh, sizeof(fh), cmpbnames, (int) bname);
      fh.bvote = 2;
      if (substitute_record(fn_board, &fh, sizeof(fh), pos) == -1)
	outs(err_board_update);
      touch_boards();		/* vote flag changed */
      resolve_boards();
    }
    return FULLUPDATE;
  }

  outs("}ls覹 [벼v]:");
  igetch();
  setbfile(buf, bname, STR_bv_desc);
  aborted = vedit(buf, NA);
  if (aborted)
  {
    clear();
    outs("벼");
    pressanykey();
    return FULLUPDATE;
  }
  setbfile(buf, bname, STR_bv_flags);
  unlink(buf);

  clear();
  getdata(0, 0, "벼iX (ܤ֢)H", inbuf, 4, DOECHO);

  if (*inbuf == '\n' || !strcmp(inbuf, "0") || *inbuf == '\0')
    strcpy(inbuf, "1");

  time(&closetime);
  closetime += atol(inbuf) * 86400;
  setbfile(buf, bname, STR_bv_control);
  fp = fopen(buf, "w");
  fprintf(fp, "%lu\n", closetime);
  fflush(fp);

  outs("\nШ̧ǿJﶵ,  ENTER ]w");
  num = 0;
  while (!aborted)
  {
    sprintf(buf, "%c) ", num + 'A');
    getdata( (num%15) + 2,(num/15)*40, buf, inbuf, 36, DOECHO);
    if (*inbuf)
    {
      fprintf(fp, "%1c) %s\n", (num+'A'), inbuf);
      num++;
    }
    if (*inbuf == '\0' || num == 30)
      aborted = 1;
  }
  fclose(fp);

  if(num==0)
  {
    clear();
    setbfile(buf, bname, STR_bv_control);
    unlink(buf);
    prints( "벼\n" );
    pressanykey();
    return FULLUPDATE;
  }
  else
  {

    pos = search_record(fn_board, &fh, sizeof(fh), cmpbnames, (int) bname);
    fh.bvote = 1;
    fh.vtime = closetime;
    if (substitute_record(fn_board, &fh, sizeof(fh), pos) == -1)
      outs(err_board_update);
    touch_boards();		/* vote flag changed */

#ifdef	HAVE_REPORT
    b_report("OPEN");
#endif

    while(1)
    {
      move( t_lines - 3, 0);
      sprintf(buf,"аݥiHX (1~%1d): ",num);
      getdata( t_lines-3, 0, buf , inbuf, 3, DOECHO, NULL,YEA);
      if(atoi(inbuf)<=0 ||atoi(inbuf)>num)
        continue;
      else
      {
        setbfile( buf, bname, "tickets" );
        if((tick= fopen(buf, "w")) == NULL)
          break;
        fprintf(tick,"%s\n",inbuf);
        fclose(tick);
        break;
      }
    }
    move( t_lines - 2, 0);
    outs("}l벼FI");
  }
  pressanykey();
  return FULLUPDATE;
}


int
vote_flag(bname, val)
  char *bname, val;
{
  char buf[256], flag;
  int fd, num, size;

  num = usernum - 1;
  setbfile(buf, bname, STR_bv_flags);
  if ((fd = open(buf, O_RDWR | O_CREAT, 0600)) == -1)
  {
    return -1;
  }
  size = lseek(fd, 0, SEEK_END);
  memset(buf, 0, sizeof(buf));
  while (size <= num)
  {
    write(fd, buf, sizeof(buf));
    size += sizeof(buf);
  }
  lseek(fd, num, SEEK_SET);
  read(fd, &flag, 1);
  if (flag == 0 && val != 0)
  {
    lseek(fd, num, SEEK_SET);
    write(fd, &val, 1);
  }
  close(fd);
  return flag;
}


int
same(compare, list, num)
  char compare;
  char list[];
  int num;
{
  int n;
  int rep = 0;

  for(n = 0; n < num; n++)
  {
    if(compare == list[n])
      rep = 1;
    if(rep == 1)
      list[n] = list[n+1];
  }
  return rep;
}


int
user_vote(bname)
  char *bname;
{
  FILE *cfp;
  char buf[STRLEN];
  char inbuf[80], choices[31], vote[2], bufvote[31];
  int i = 0, tickets;
  int fd, count = 0;
  time_t closetime;

  setbfile( buf, bname, STR_bv_tickets);
  if((cfp= fopen(buf, "r")) == NULL)
    tickets=1;
  else
  {
    fgets( inbuf, sizeof(inbuf), cfp );
    tickets = atoi(inbuf);
    fclose(cfp);
  }


  setbfile(buf, bname, STR_bv_control);
  move(3, 0);
  clrtobot();
  if ((cfp = fopen(buf, "r")) == NULL)
  {
/*
woju

    boardheader bh;
    int bid = getbnum(bname);
    if (get_record(fn_board, &bh, sizeof(bh), bid) != -1 && bh.bvote == 1) {
       bh.bvote = 2;
       substitute_record(fn_board, &bh, sizeof(bh), bid);
       touch_boards();
       resolve_boards();
    }
*/  
    outs("\nثeèS벼|C");
    pressanykey();
    return FULLUPDATE;
  }

  if (!HAS_PERM(PERM_BASIC))
  {
    outs("\n藍_! zGQ, ٨S벼v!");
    fclose(cfp);
    pressanykey();
    return FULLUPDATE;
  }

  setutmpmode(VOTING);
  setbfile(buf, bname, STR_bv_desc);
  more(buf, YEA);

  stand_title("벼c");
  fgets(inbuf, sizeof(inbuf), cfp);
  closetime = (time_t) atol(inbuf);

  prints("벼覡GTwnzܫAJƦrNXYiC\n"
    "벼AiH %1d C"
    "[1;30;41m  0  [m [1;37;42m  1 벼 [m\n"
    "벼NG%s \n",
    tickets, ctime(&closetime));
  move(5, 0);
  memset(choices, 0, sizeof(choices));
  while (fgets(inbuf, sizeof(inbuf), cfp))
  {
    choices[count++] = inbuf[0];
    move(((count-1)%15)+5,((count-1)/15)*40);
    prints( " %s", strtok(inbuf,"\n\0"));
  }
  fclose(cfp);

  if (vote_flag(bname, '\0'))
  {
    move(21, 0);
    outs("벼AAwLFI@H@AjaC");
    pressanykey();
    return FULLUPDATE;
  }

  while(1)
  {
    vote[0] = vote[1] = '\0';
    move(t_lines-2, 0);
    prints("A٥iH %2d ", tickets-i);
    getdata(t_lines-4, 0, "Jz: ", vote, 3, DOECHO);
    move(t_lines - 2, 0);
    *vote = toupper(*vote);
    if (vote[0] == '0' || (!vote[0] && !i))
    {
      clrtoeol();
      prints("[5mOAӧ!!      [m");
      refresh();
      break;
    }
    else if (vote[0] == '1' && i)
       ;
    else if (!vote[0])
       continue;
    else if (index(choices, vote[0]) == NULL) /* L */
      continue;
    else if (same(vote[0], bufvote, i))
    {
      move(((vote[0]-'A')%15)+5, (((vote[0]-'A'))/15)*40);
      prints(" ");
      i--;
      continue;
    }
    else
    {
      if (i == tickets)
	 continue;
      bufvote[i] = vote[0];
      move(((vote[0]-'A')%15)+5, (((vote[0]-'A'))/15)*40);
      prints("*");
      i++;
      continue;
    }

    if (vote_flag(bname, vote[0]) != 0)
      prints("Ч벼! pC");
    else
    {
      setbfile(buf, bname, STR_bv_ballots);
      if ((fd = open(buf, O_WRONLY | O_CREAT | O_APPEND, 0600)) == 0)
        outs("LkJo\n");
      else
      {
        struct stat statb;

        flock(fd, LOCK_EX);
        write(fd, bufvote, i);
        flock(fd, LOCK_UN);
        fstat(fd, &statb);
        close(fd);
	move(t_lines-2,0);
        prints("w벼I(ثew벼: %d)\n", statb.st_size);
      }
    }
    break;
  }
  pressanykey();
  return FULLUPDATE;
}


int
vote_results(bname)
  char *bname;
{
  char buf[STRLEN];

  setbfile(buf, bname, STR_bv_results);
  if (more(buf, YEA) == -1)
  {
/*
woju

    boardheader bh;
    int bid = getbnum(bname);

    if (get_record(fn_board, &bh, sizeof(bh), bid) != -1 
	&& bh.bvote == 2) {
       bh.bvote = 0;
       substitute_record(fn_board, &bh, sizeof(bh), bid);
       touch_boards();
       resolve_boards();
    }
*/
    move(3, 0);
    clrtobot();
    outs("\nثeS벼GC");
    pressanykey();
  }
/*
woju

  else {
    boardheader bh;
    int bid = getbnum(bname);
    if (get_record(fn_board, &bh, sizeof(bh), bid) != -1 
	&& bh.vtime < time(NULL) - 7 * 86400
	&& bh.bvote == 2) {
       bh.bvote = 0;
       substitute_record(fn_board, &bh, sizeof(bh), bid);
       touch_boards();
       resolve_boards();
    }
  }
*/     
  return FULLUPDATE;
}


int
b_vote_maintain()
{
  return vote_maintain(currboard);
}


int
b_vote()
{
  return user_vote(currboard);
}


int
b_results()
{
  return vote_results(currboard);
}


#ifdef	SYS_VOTE
int
m_vote()
{
  return vote_maintain(DEFAULT_BOARD);
}


int
x_vote()
{
  return user_vote(DEFAULT_BOARD);
}


int
x_results()
{
  return vote_results(DEFAULT_BOARD);
}
#endif				/* SYS_VOTE */



#ifdef	HAVE_REPORT
b_report(s)
  char *s;
{
  static int disable = NA;
  int fd;

  if (disable)
    return;
  if ((fd = open("trace.bvote", O_WRONLY, 0644)) != -1)
  {
    char buf[512];
    char timestr[18], *thetime;
    time_t dtime;

    time(&dtime);
    thetime = ctime(&dtime);
    strncpy(timestr, &(thetime[4]), 15);
    timestr[15] = '\0';
    flock(fd, LOCK_EX);
    lseek(fd, 0, L_XTND);
    sprintf(buf, "%s %-12s %-20s %s\n", timestr, cuser.userid, currboard, s);
    write(fd, buf, strlen(buf));
    flock(fd, LOCK_UN);
    close(fd);
    return;
  }
  disable = YEA;
  return;
}
#endif				/* HAVE_REPORT */
