/*-------------------------------------------------------*/
/* xyz.c        ( NTHU CS MapleBBS Ver 2.36 )            */
/*-------------------------------------------------------*/
/* target : system toolbox routines                      */
/* create : 95/03/29                                     */
/* update : 95/12/15                                     */
/*-------------------------------------------------------*/


#include "bbs.h"


/* ----------------------------------------------------- */
/* UزέpάTC                                */
/* ----------------------------------------------------- */


int
x_user()
{
  more("etc/topusr", YEA);
  return 0;
}


int
x_note()
{
  more(fn_note_ans, YEA);
  return 0;
}


int
x_issue()
{
  more("etc/day", YEA);
  return 0;
}


int
x_week()
{
  more("etc/week", YEA);
  return 0;
}


int
x_today()
{
  more("etc/today", YEA);
  more("etc/wtoday", YEA);
}


int
x_yesterday()
{
  more("etc/yesterday", YEA);
  more("etc/wyesterday", YEA);
}


#ifdef HAVE_INFO
x_program()
{
  more("etc/version", YEA);
  return 0;
}
#endif


#ifdef HAVE_License
x_gpl()
{
  more("etc/GPL", YEA);
  return 0;
}
#endif


int
Welcome()
{
  more("etc/welcome", YEA);
  return 0;
}


/* ----------------------------------------------------- */
/* } BBS                                            */
/* ----------------------------------------------------- */


static void
note()
{
  static char *fn_note_tmp = "note.tmp";
  static char *fn_note_dat = "note.dat";
  int total, i, collect, len;
  struct stat st;
  char buf[256], buf2[80], *p;
  int fd, fx;
  FILE *fp, *foo;

  struct notedata
  {
    time_t date;
    char userid[IDLEN + 1];
    char username[19];
    char buf[3][80];
  };
  struct notedata myitem;

  do
  {
    myitem.buf[0][0] = myitem.buf[1][0] = myitem.buf[2][0] = '\0';
    move(12, 0);
    clrtobot();
    outs("\nЯd (ܦhT)A[Enter]");
    for (i = 0; (i < 3) &&
      getdata(16 + i, 0, "G", myitem.buf[i], 78, DOECHO); i++);
    getdata(b_lines - 1, 0, "(S)xs (E)sӹL (Q)H[S] ", buf, 3, LCECHO);
/*
woju
*/
    if (buf[0] == 'q' || i == 0 && *buf != 'e')
      return;
  } while (buf[0] == 'e');

  strcpy(myitem.userid, cuser.userid);
  strncpy(myitem.username, cuser.username, 18);
  myitem.username[18] = '\0';
  time(&(myitem.date));

  /* begin load file */

  if ((foo = fopen(".note", "a")) == NULL)
    return;

  if ((fp = fopen(fn_note_ans, "w")) == NULL)
    return;

  if ((fx = open(fn_note_tmp, O_WRONLY | O_CREAT, 0644)) <= 0)
    return;

  if ((fd = open(fn_note_dat, O_RDONLY)) == -1)
  {
    total = 1;
  }
  else if (fstat(fd, &st) != -1)
  {
    total = st.st_size / sizeof(struct notedata) + 1;
    if (total > MAX_NOTE)
      total = MAX_NOTE;
  }

  fputs("\t\t\t[37;45m  H  R  d  ï  \n\n", fp);
  collect = 1;

  while (total)
  {
    sprintf(buf, "[1;37;46mW[47;34m %s [33m(%s)",
      myitem.userid, myitem.username);
    len = strlen(buf);
    strcat(buf, " [30;46m" + (len & 1));

    for (i = len >> 1; i < 40; i++)
      strcat(buf, "e");
    sprintf(buf2, "[47;34m %.16s [37;46mW[0m\n",
      Cdate(&(myitem.date)));
    strcat(buf, buf2);
    fputs(buf, fp);

    if (collect)
      fputs(buf, foo);

    sprintf(buf, "%s\n%s\n%s\n", myitem.buf[0], myitem.buf[1], myitem.buf[2]);
    fputs(buf, fp);

    if (collect)
    {
      fputs(buf, foo);
      fclose(foo);
      collect = 0;
    }

    write(fx, &myitem, sizeof(myitem));

    if (--total)
      read(fd, (char *) &myitem, sizeof(myitem));
  }
  fclose(fp);
  close(fd);
  close(fx);
  Rename(fn_note_tmp, fn_note_dat);
  more(fn_note_ans, YEA);
}


static void
mail_sysop()
{
  FILE *fp;
  char genbuf[200];

  if (fp = fopen("etc/sysop", "r"))
  {
    int i, j;
    char *ptr;

    struct SYSOPLIST
    {
      char userid[IDLEN + 1];
      char duty[40];
    }         sysoplist[9];

    j = 0;
    while (fgets(genbuf, 128, fp))
    {
      if (ptr = strchr(genbuf, '\n'))
      {
        *ptr = '\0';
        if (ptr = strchr(genbuf, ':'))
        {
          *ptr = '\0';
          do
          {
            i = *++ptr;
          } while (i == ' ' || i == '\t');
          if (i)
          {
            strcpy(sysoplist[j].userid, genbuf);
            strcpy(sysoplist[j++].duty, ptr);
          }
        }
      }
    }

    move(12, 0);
    clrtobot();
    prints("%16s   %-18svd\n\n", "s", " ID"/*, msg_seperator*/);

    for (i = 0; i < j; i++)
    {
      prints("%15d.   [1;%dm%-16s%s[0m\n",
        i + 1, 31 + i % 7, sysoplist[i].userid, sysoplist[i].duty);
    }
    prints("%-14s0.   [1;%dm}[0m", "", 31 + j % 7);
    getdata(b_lines - 1, 0, "                   пJNX[0]G", genbuf, 4, DOECHO);
    i = genbuf[0] - '0' - 1;
    if (i >= 0 && i < j)
    {
      clear();
      do_send(sysoplist[i].userid, NULL);
    }
  }
}


int
m_sysop()
{
  setutmpmode(MSYSOP);
  mail_sysop();
  return 0;
}


int
Goodbye()
{
  extern void movie();
  char genbuf[200];
  FILE *fp;
  struct stat st;
/*
woju
*/
  char ans[4];

  setuserfile(genbuf, fn_writelog);
  stat(genbuf,&st);
  if ((st.st_size>=2)&&(more(genbuf, NA) != -1)) {
     getdata(b_lines - 1, 0, "M(C) ܳƧѿ(M) Od(R) (C/M/R)?[R]",
        ans, 3, LCECHO);
     if (*ans == 'm') {
        fileheader mymail;
        char title[128], buf[80];

        sethomepath(buf, cuser.userid);
        stampfile(buf, &mymail);

        mymail.savemode = 'H';        /* hold-mail flag */
        mymail.filemode = FILE_READ;
        strcpy(mymail.owner, "[..]");
        strcpy(mymail.owner, cuser.userid);
        strcpy(mymail.title, "uO");
        sethomedir(title, cuser.userid);
        append_record(title, &mymail, sizeof(mymail));
        Rename(genbuf, buf);
        /*****bɮY[@ťյPOP3 ********/
        if (fp = fopen(genbuf, "a")) {
        fprintf(fp, "\n");
        fclose(fp);
        }
      }
     else if (*ans == 'c') {
        char buf[80];

        setuserfile(buf, fn_writelog);
        unlink(buf);
        /*****bɮY[@ťյPOP3 ********/
        if (fp = fopen(buf, "a")) {
        fprintf(fp, "\n");
        fclose(fp);
        }
     }

      clear();
      move(0, 0);
      prints("[1;44;33m                                   HR                                   [m");
      movie(0);
  }

  getdata(b_lines - 1, 0, "zTwn}i " BOARDNAME " j(Y/N)H[N] ",
    genbuf, 3, LCECHO);

  if (*genbuf != 'y')
    return 0;

  movie(999);
  if (cuser.userlevel)
  {
    getdata(b_lines - 1, 0, "(G)@ (M)i (N)dXyܦbdïH[G] ",
      genbuf, 3, LCECHO);
    if (genbuf[0] == 'm')
      mail_sysop();
    else if (genbuf[0] == 'n')
      note();
  }

  clear();
  prints("[1;36m˷R [33m%s(%s)[36mAOѤFAץ{[45;33m"
    " %s [40;36mI\nHUOzbU:[0m\n",
    cuser.userid, cuser.username, BoardName);
  user_display(&cuser, 2); // tjm change from 0 to 2 to secret userdata

  if (currmode)
    u_exit("EXIT ");

  pressanykey();
  //sleep(1);
  reset_tty();
  exit(0);
}


/* ----------------------------------------------------- */
/* 䴩~{ : tinBgopherBwwwBbbsnetBgameBcsh    */
/* ----------------------------------------------------- */


#ifdef HAVE_EXTERNAL
#define LOOKFIRST       (0)
#define LOOKLAST        (1)
#define QUOTEMODE       (2)
#define MAXCOMSZ        (1024)
#define MAXARGS         (40)
#define MAXENVS         (20)
#define BINDIR          "/bin/"

char *bbsenv[MAXENVS];
int numbbsenvs = 0;


int
bbssetenv(env, val)
  char *env, *val;
{
  register int i, len;
  extern char *malloc();

  if (numbbsenvs == 0)
    bbsenv[0] = NULL;
  len = strlen(env);
  for (i = 0; bbsenv[i]; i++)
    if (!ci_strncmp(env, bbsenv[i], len))
      break;
  if (i >= MAXENVS)
    return -1;
  if (bbsenv[i])
    free(bbsenv[i]);
  else
    bbsenv[++numbbsenvs] = NULL;
  bbsenv[i] = malloc(strlen(env) + strlen(val) + 2);
  strcpy(bbsenv[i], env);
  strcat(bbsenv[i], "=");
  strcat(bbsenv[i], val);
}

#define MAXPATHLEN 82

int
do_exec(com, wd)
  char *com, *wd;
{
  char genbuf[200];
  char path[MAXPATHLEN];
  char pcom[MAXCOMSZ];
  char *arglist[MAXARGS];
  char *tz;
  register int i, len;
  register int argptr;
  register char *lparse;
  int status, w;
  pid_t pid;
  int pmode;
  void (*isig) (), (*qsig) ();

  strncpy(path, BINDIR, MAXPATHLEN);
  strncpy(pcom, com, MAXCOMSZ);
  len = MIN(strlen(com) + 1, MAXCOMSZ);
  pmode = LOOKFIRST;
  for (i = 0, argptr = 0; i < len; i++)
  {
    if (pcom[i] == '\0')
      break;
    if (pmode == QUOTEMODE)
    {
      if (pcom[i] == '\001')
      {
        pmode = LOOKFIRST;
        pcom[i] = '\0';
        continue;
      }
      continue;
    }
    if (pcom[i] == '\001')
    {
      pmode = QUOTEMODE;
      arglist[argptr++] = &pcom[i + 1];
      if (argptr + 1 == MAXARGS)
        break;
      continue;
    }
    if (pmode == LOOKFIRST)
      if (pcom[i] != ' ')
      {
        arglist[argptr++] = &pcom[i];
        if (argptr + 1 == MAXARGS)
          break;
        pmode = LOOKLAST;
      }
      else
        continue;
    if (pcom[i] == ' ')
    {
      pmode = LOOKFIRST;
      pcom[i] = '\0';
    }
  }
  arglist[argptr] = NULL;
  if (argptr == 0)
    return -1;
  if (*arglist[0] == '/')
    strncpy(path, arglist[0], MAXPATHLEN);
  else
    strncat(path, arglist[0], MAXPATHLEN);
  reset_tty();
  alarm(0);
  if ((pid = vfork()) == 0)
  {
    if (wd)
      if (chdir(wd))
      {
        fprintf(stderr, "Unable to chdir to '%s'\n", wd);
        exit(-1);
      }
    bbssetenv("PATH", "/bin:.");
    bbssetenv("TERM", "vt100"/* cuser.termtype */);
    bbssetenv("USER", cuser.userid);
    bbssetenv("USERNAME", cuser.username);
    /* added for tin's HOME and EDITOR */
/*
woju
*/
    sprintf(genbuf, "/home/bbs/home/%s", cuser.userid);
    bbssetenv("HOME", genbuf);
    bbssetenv("EDITOR", "/bin/ve");
    /* end */
    /* added for tin's reply to */
    bbssetenv("REPLYTO", cuser.email);
    bbssetenv("FROMHOST", fromhost);
    /* end of insertion */
    if ((tz = getenv("TZ")) != NULL)
      bbssetenv("TZ", tz);
    if (numbbsenvs == 0)
      bbsenv[0] = NULL;
    execve(path, arglist, bbsenv);
    fprintf(stderr, "EXECV FAILED... path = '%s'\n", path);
    exit(-1);
  }
  isig = signal(SIGINT, SIG_IGN);
  qsig = signal(SIGQUIT, SIG_IGN);
  while ((w = wait(&status)) != pid && w != 1)
     /* NULL STATEMENT */ ;
  signal(SIGINT, isig);
  signal(SIGQUIT, qsig);
  restore_tty();

#ifdef DOTIMEOUT
  alarm(IDLE_TIMEOUT);
#endif

  return ((w == -1) ? w : status);
}


int
exec_cmd(umode, pager, cmdfile, mesg)
  char *cmdfile, *mesg;
{
  char buf[64];
  int save_pager;

  if (!dashf(cmdfile))
  {
    move(2, 0);
    prints("ܩp,  %s (%s) \\.", mesg, cmdfile);
    return 0;
  }
  save_pager = currutmp->pager;
  if (pager == NA)
  {
    currutmp->pager = pager;
  }
  setutmpmode(umode);
  sprintf(buf, "/bin/sh %s", cmdfile);
  reset_tty();
  do_exec(buf, NULL);
  restore_tty();
  currutmp->pager = save_pager;
  clear();
  return 0;
}


#ifdef HAVE_TIN
x_tin()
{
  return exec_cmd(XMODE, YEA, "bin/tin.sh", "TIN");
}
#endif


#ifdef HAVE_GOPHER
x_gopher()
{
  return exec_cmd(XMODE, YEA, "bin/gopher.sh", "GOPHER");
}
#endif


#ifdef HAVE_ON_LINE
x_on_line()
{
  char buf[64];
  int save_pager;

  clear();
  outs("wiJ [31mHR[0m Өϥ[1;37mON-LINE Bible[0m\n");
  pressanykey();

  save_pager = currutmp->pager;
  currutmp->pager = NA;
  setutmpmode(ON_LINE);
  reset_tty();

  sprintf(buf, "%s/bin/online.sh",BBSHOME);
  do_exec(buf, NULL);

  restore_tty();
  currutmp->pager = save_pager;

  clear();
  prints(" [1;33m%s[0m {!!\n", cuser.userid);
  outs("wUAӨϥ!! ^o^\n");
  pressanykey();

  clear();
  return 0;
}
#endif


#ifdef HAVE_WWW
x_www()
{
  return exec_cmd(WWW, NA, "/home/bbs/bin/clynx.sh", "WWW");
}
#endif                          /* HAVE_WWW */

#ifdef HAVE_BOOK
x_book()
{
  char buf[64];
  int save_pager;

  clear();
  save_pager = currutmp->pager;
  currutmp->pager = NA;
  setutmpmode(BOOK);
  reset_tty();
  sprintf(buf, "%s/bin/db.sh ",BBSHOME);
  do_exec(buf, NULL);
  restore_tty();
  currutmp->pager = save_pager;
  clear();
  return 0;
}
#endif                          /* HAVE_WWW */

#ifdef HAVE_RBIBLE
x_rbible()
{
  char buf[64],buf1[128];
  int save_pager;

  clear();
  outs("wiJ [31mHR[0m Ӱѥ[[1;37mtgtŪpe[0m\n");
  pressanykey();

  save_pager = currutmp->pager;
  currutmp->pager = NA;
  setutmpmode(RBIBLE);
  reset_tty();
  sethomefile(buf1,cuser.userid,"bible.bib");
  sprintf(buf, "%s/bin/rbible.sh %s/%s",BBSHOME,BBSHOME,buf1);
  do_exec(buf, NULL);

  restore_tty();
  currutmp->pager = save_pager;

  clear();
  prints(" [1;33m%s[0m {!!\n", cuser.userid);
  outs("wUAӨϥ!! ^o^\n");
  pressanykey();

  clear();
  return 0;
}
#endif

#ifdef HAVE_IRC
x_irc()
{
  return exec_cmd(XMODE, NA, "bin/irc.sh", "IRC");
}
#endif                          /* HAVE_IRC */


#ifdef  HAVE_ADM_SHELL
x_csh()
{
  int save_pager;

  clear();
  refresh();
  reset_tty();
  save_pager = currutmp->pager;
  currutmp->pager = NA;

#ifdef  HAVE_REPORT
  report("shell out");
#endif

#ifdef SYSV
  do_exec("sh", NULL);
#else
  do_exec("tcsh", NULL);
#endif

  restore_tty();
  currutmp->pager = save_pager;
  clear();
  return 0;
}
#endif                          /* NO_ADM_SHELL */


#ifdef BBSDOORS
x_bbsnet()                      /* Bill Schwartz */
{
  int save_pager = currutmp->pager;

  currutmp->pager = NA;

  setutmpmode(BBSNET);
  /* bbsnet.sh is a shell script that can be customized without */
  /* having to recompile anything.  If you edit it while someone */
  /* is in bbsnet they will be sent back to the xyz menu when they */
  /* leave the system they are currently in. */

  reset_tty();
  do_exec("bbsnet.sh", NULL);
  restore_tty();
  currutmp->pager = save_pager;
  clear();
  return 0;
}
#endif


#ifdef HAVE_GAME
x_game()
{
  int save_pager = currutmp->pager;

  currutmp->pager = NA;

  setutmpmode(BBSNET);
  /* bbsnet.sh is a shell script that can be customized without */
  /* having to recompile anything.  If you edit it while someone */
  /* is in bbsnet they will be sent back to the xyz menu when they */
  /* leave the system they are currently in. */

  reset_tty();
  do_exec("okbridge.sh", NULL);
  restore_tty();
  currutmp->pager = save_pager;
  clear();
  return 0;
}
#endif                          /* HAVE_GAME */

#endif                          /* HAVE_EXTERNAL */
