/*
 * Copyright (c) 1989 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 */

#ifndef lint
static char copyright[] = "Copyright (c) 1990 Regents of the University of California.\nAll rights reserved.\n";
static char SccsId[] = "@(#)@(#)pop_quit.c      2.1  2.1 3/18/91";
#endif not lint

#include <stdio.h>
#include <sys/types.h>
#include "popper.h"

/*
 *  quit:   Terminate a POP session
 */

/*
Author: opus.bbs@bbs.cs.nthu.edu.tw
*/
/* ----------------------------------------------------- */
/* exclusively create file [*.new]                       */
/* ----------------------------------------------------- */


int
fexcl_creat(fold, fnew)
  char *fold;
  char *fnew;
{
  register int fd, i;
  extern int errno;

  sprintf(fnew, "%s.new", fold);
  i = 0;

  for (;;)
  {
    fd = open(fnew, O_WRONLY | O_CREAT | O_EXCL, 0644);
    if ((fd >= 0) || (errno != EEXIST))
      break;

    if (i == 0)
    {
      struct stat st;

      if (stat(fnew, &st) < 0)
        break;
      if (st.st_mtime < time(NULL) - 20 * 60);  /* ] 20 ӳBz */
      unlink(fnew);
    }
    else
    {
      if (i > 12)               /*  60  */
        break;
      sleep(5);
    }
    i++;
  }
  return fd;
}


mailbox_close(POP* p)
{
   int n, max, saved;
   int fdr, fdw;
   char fpath[80], fold[80], fnew[80], *home;
   fileheader mhdr;
   pop3header *phdr;

   strcpy(fold, p->temp_drop);
   if ((fdr = open(p->temp_drop, O_RDONLY, 0)) < 0)
      return;

   fdw = fexcl_creat(fold, fnew);
   if (fdw < 0)
   {
     close(fdr);
     return;
   }

   n = saved = 0;
   max = p->msg_count;
   phdr = p->cache;

   while (read(fdr, &mhdr, sizeof(mhdr)) == sizeof(mhdr))
   {
     if (n >= max || phdr->savemode != 'X')
     {
       write(fdw, &mhdr, sizeof(mhdr));
       saved = 1;
     }
     else
     {
       sprintf(fpath, "%s/%s", p->drop_name, mhdr.filename);
       unlink(fpath);
     }
     n++;
     phdr++;
   }
   close(fdr);
   close(fdw);

   if (saved)
     rename(fnew, fold);
   else
   {
     unlink(fnew);
     unlink(fold);
   }
}


int pop_quit (p)
POP     *   p;
{
/*
woju: bbs
*/
    if (p->bbs) {
       pop3header *phdr;
       int n;
       char* str;

       if (p->dirty)
          mailbox_close(p);
       if (phdr = p->cache) {
          n = p->msg_count;
          for (;;) {
             if (str = phdr->author)
                free(str);
             if (--n == 0)
               break;
             phdr++;
          }
         free(p->cache);
         p->cache = NULL;
       }
    }

    /*  Release the message information list */
    if (p->mlp) free ((char *)p->mlp);

    if (p->CurrentState == auth2) {
        pop_log(p, POP_SUCCESS, "Possible probe of account %s from host %s",
                                                        p->user, p->client);
    }

    return(POP_SUCCESS);
}
