/*-------------------------------------------------------*/
/* util/bbsmail.c       ( NTHU CS MapleBBS Ver 2.36 )    */
/*-------------------------------------------------------*/
/* target :  Internet HH BBS ϥΪ            */
/* create : 95/03/29                                     */
/* update : 95/12/15                                     */
/*-------------------------------------------------------*/
/*
 * $Log: bbsmail.c,v $
 * Revision 1.2  1997/04/16 00:32:38  bbsroot
 * Added MIME Quoted-printable decoding.
 *
 * Revision 1.1  1997/04/16 00:24:26  bbsroot
 * Initial revision
 *
 */

#include <stdio.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <fcntl.h>
#include <time.h>
#include <sysexits.h>

#include "bbs.h"
#include "qp_conv.c"

char *fn_passwd = BBSHOME "/.PASSWDS";


#define _BBS_UTIL_C_
#include "cache.c"
#include "record.c"


#define LOG_FILE        (BBSHOME "/etc/mailog")
#define ERRLOG_FILE        (BBSHOME "/etc/errmailog")
#define AUTOB5_BIN        (BBSHOME "/bin/autob5")
#define Header_Length   200


#define NOCODE     0
#define QPCODE     1
#define BASE64CODE 2
#define TRUE       1
#define FALSE      0
#define LINE_SIZE  256

#define XX 127
/*
 * Table for decoding hexadecimal in quoted-printable
 */
static char index_hex[256] = {
    XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
    XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
    XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
     0, 1, 2, 3,  4, 5, 6, 7,  8, 9,XX,XX, XX,XX,XX,XX,
    XX,10,11,12, 13,14,15,XX, XX,XX,XX,XX, XX,XX,XX,XX,
    XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
    XX,10,11,12, 13,14,15,XX, XX,XX,XX,XX, XX,XX,XX,XX,
    XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
    XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
    XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
    XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
    XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
    XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
    XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
    XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
    XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
};
#define HEXCHAR(c)  (index_hex[(unsigned char)(c)])


char mycoding = NOCODE;
char userid[256], mail_addr[256];
FILE *flog;

void
DecodeSubject(buf)
  char *buf;
{
   char tmpbuf[LINE_SIZE];
   int bpos = 0, tpos = 0;
   int len = 0;
   int subjcoding = NOCODE;
   int c1, c2, c3, c4;
   int DataDone = 0;

   while (buf[len] != '\0') len++;
   tmpbuf[0] = '\0';

   while (bpos < len) {
      if (buf[bpos] == '=' && buf[bpos+1] == '?') {	/* Encoded subject */
      /* Subject: xxx [** CHARSET **] xxx */
         bpos += 2;
         while (buf[bpos] != '?') bpos++;	/* skip the encoding info */
            bpos++;				/* skip the '?' */
            if (buf[bpos] == 'Q') {
               subjcoding = QPCODE;
               bpos++;
            } else if (buf[bpos] == 'B') {
               subjcoding = BASE64CODE;
               bpos++;
            } else {
               subjcoding = NOCODE;
            }
            switch (subjcoding) {
               case QPCODE:
                  bpos++;			/* skip the "?" */
                  while (buf[bpos] != '\0' && !(buf[bpos] == '?'
                          && buf[bpos+1] == '=')) {
                     if (buf[bpos] == '=') {
		        tmpbuf[tpos++] = HEXCHAR(buf[bpos+1]) <<4 |
                                HEXCHAR(buf[bpos+2]);
                        bpos += 3;
                     } else {
                        tmpbuf[tpos++] = buf[bpos++];
                     }
                  }
                  if (bpos+2 > len || buf[bpos] != '?' || buf[bpos+1] != '=') {
                     subjcoding = NOCODE;	/* forget it, wrong qp-coding */
                     break;
                  }
                  bpos += 2;	/* skip the "=?" */
                  break;
             }
        } else {
           tmpbuf[tpos++] = buf[bpos++];
        }
   }
   tmpbuf[tpos] = '\0';
   if (subjcoding != NOCODE) strcpy(buf, tmpbuf);
}


void
DecodeLine(buf)
  char *buf;
{
   char tmpbuf[LINE_SIZE];
   int bpos = 0, tpos = 0;
   int len = 0;
   int subjcoding = NOCODE;
   int c1, c2, c3, c4;
   int DataDone = 0;

   /* Make sure mycoding is QPCODE before entering this function */
   /* if (mycoding != QPCODE) return;
    * Support only quote-printable coding for the time being */

   while (buf[len] != '\0') len++;
   tmpbuf[0] = '\0';

   while (bpos < len) {
      if (buf[bpos] == '=') {			/* Encoded subject */
         tmpbuf[tpos++] = HEXCHAR(buf[bpos+1]) <<4 | HEXCHAR(buf[bpos+2]);
         bpos += 3;
      } else {
         tmpbuf[tpos++] = buf[bpos++];
      }
   }
   tmpbuf[tpos] = '\0';
   strcpy(buf, tmpbuf);
}


#ifndef MIMEDEBUG
void
mailog(msg)
  char *msg;
{
  FILE *fp;

  if (fp = fopen(LOG_FILE, "a"))
  {
    time_t now;
    struct tm *p;

    time(&now);
    p = localtime(&now);
    fprintf(fp, "%04d/%02d/%02d %02d:%02d:%02d <bbsmail> %s\n",
        1900+p->tm_year, p->tm_mon+1, p->tm_mday, p->tm_hour, p->tm_min, p->tm_sec,
        msg);
    fclose(fp);
  }
}
void
errmailog(msg)
  char *msg;
{
  FILE *fp;

  if (fp = fopen(ERRLOG_FILE, "a"))
  {
    time_t now;
    struct tm *p;

    time(&now);
    p = localtime(&now);
    fprintf(fp, "%04d/%02d/%02d %02d:%02d:%02d <errmail> %s\n",
        1900+p->tm_year, p->tm_mon+1, p->tm_mday, p->tm_hour, p->tm_min, p->tm_sec,
        msg);
    fclose(fp);
  }
}
#endif /* MIMEDEBUG */


int
mail2bbs(userid)
  char *userid;
{
  fileheader mymail;
  char genbuf[256], title[80], sender[80], *ip, *ptr;
  char genbufx[256],buf[256];
  char HD[Header_Length][260]; /*** header buffer ****/
  int  HDcnt,i,withto;
  time_t tmp_time;
  struct stat st;
  FILE *fout, *foutx;

#ifndef MIMEDEBUG
  /* check if the userid is in our bbs now */
  if (!strcmp(userid,"hi"))
  {
    sprintf(genbuf, "BBS user <%s> not existed", userid);
    puts(genbuf);
    mailog(genbuf);
    return EX_NOUSER;
  }
  if (!searchuser(userid))
  {
    sprintf(genbuf, "BBS user <%s> not existed", userid);
    puts(genbuf);
    mailog(genbuf);
    return EX_NOUSER;
  }

  sprintf(genbuf, BBSHOME "/home/%s", userid);

  if (stat(genbuf, &st) == -1)
  {
    if (mkdir(genbuf, 0755) == -1)
    {
#ifdef VERBOSE
      printf("mail box create error %s \n", genbuf);
#endif
      sprintf(genbuf,"%s mail box create error",userid);
      errmailog(genbuf);
      return -1;
    }
  }
  else if (!(st.st_mode & S_IFDIR))
  {
#ifdef VERBOSE
    printf("mail box error\n");
#endif
    sprintf(genbuf,"%s mail box error",userid);
    errmailog(genbuf);
    return -1;
  }

#ifdef VERBOSE
  printf("dir: %s\n", genbuf);
#endif

  /* allocate a file for the new mail */

  stampfile(genbuf, &mymail);
#ifdef VERBOSE
  printf("file: %s\n", genbuf);
#endif

  /* copy the stdin to the specified file */
   /*** add by tjm for autob5 ****/
  sprintf(genbufx,"%s>%s",AUTOB5_BIN,genbuf);
  //if ((fout = fopen(genbuf, "w")) == NULL)
  if ((fout = popen(genbufx, "w")) == NULL)
  {
#ifdef VERBOSE
    printf("Cannot open %s\n", genbuf);
#endif
    strcat(genbuf," cannot open!");
    errmailog(genbuf);
    return -1;
  }
#else
  fout = stdout;
#endif	/* MIMEDEBUG */

  /* parse header */
  HDcnt=0;
  withto=0;
  while (fgets(genbuf, 255, stdin))
  {
    if (!strncmp(genbuf, "Subject: ", 9))
    {
      strcpy(buf,genbuf);
      //DecodeSubject(genbuf);
      str_decode(genbuf, buf);
      strcpy(title, genbuf + 9);
    }
    /*** save Y  by tjm *****/
    if (HDcnt < Header_Length)
    {
      //strcpy(HD[HDcnt],":: ");
      strcpy(HD[HDcnt++],genbuf);
      /****siH****/
      if (strstr(genbuf,"plt")!=NULL)
      {
        if (strstr(genbuf,"Message-Id")!=NULL)
        {
           sprintf(genbuf,"%s from plt to %sI",sender,userid);
           errmailog(genbuf);
      	   return -1;
      	}   
      }
      if (strstr(genbuf,"HiMailer")!=NULL)
      {
        if (strstr(genbuf,"Message-Id")!=NULL)
        {
           sprintf(genbuf,"%s from HiMailer to %sI",sender,userid);
           errmailog(genbuf);
      	   return -1;
      	}   
      }
      if ((strstr(genbuf,"post.office MTA")!=NULL)||
          (strstr(genbuf,"Post.Office")!=NULL))
      {
           sprintf(genbuf,"from %s to %s post.officeI",sender,userid);
           errmailog(genbuf);
      	   return -1;
      }
      if ((strstr(genbuf,"url.com.tw")!=NULL))
      {
           sprintf(genbuf,"from %s to %s url.com.twI",sender,userid);
           errmailog(genbuf);
      	   return -1;
      }
      /**** for To filter ******/
      if ((strncasecmp(genbuf,"To:",3)==0)&& (strstr(genbuf,"Reply-To")==NULL))
      {
        withto=1;
        if (strstr(genbuf,"everyone")!=NULL)
        {
           sprintf(genbuf,"%s from everyone to %sI",sender,userid);
           errmailog(genbuf);
      	   return -1;
      	}else
      	if (strstr(genbuf,"FRIEND")!=NULL)
      	{
      	   sprintf(genbuf,"%s from FRIEND to %sI",sender,userid);
           errmailog(genbuf);
      	   return -1;
      	}else
      	if (strstr(genbuf,"money")!=NULL)
      	{
      	   sprintf(genbuf,"%s from money to %sI",sender,userid);
           errmailog(genbuf);
      	   return -1;
      	}
	else
      	if ((strstr(genbuf,"bbs@fhl")==NULL)&&
      	   (strstr(genbuf,"bbs@bbs")==NULL)&&
      	   (strstr(genbuf,"bbs@FHL")==NULL)&&
 	   (strstr(genbuf,"bbs@fHL")==NULL)&&
       	   (strstr(genbuf,"bbs@Fhl")==NULL))
      	{
      	   sprintf(genbuf,"%s from %s to %sI",sender,genbuf+3,userid);
           errmailog(genbuf);
      	   return -1;
      	}
      }
      /***** Authentication-Warning *****/
      	if (strstr(genbuf,"Authentication-Warning")!=NULL)
      	{
      	   if (strstr(genbuf,"HELO")!=NULL)
      	   {
      	    sprintf(genbuf,"%s from Authentication-Warning to %sI",sender,userid);
            errmailog(genbuf);
      	    return -1;
      	   }
      	}
	/*************************************
      if (strstr(genbuf,"root@")!=NULL)
      {
        if ((strstr(genbuf,"Received")!=NULL)
           &&(strstr(genbuf,"net")!=NULL))
        {
           sprintf(genbuf,"from %s to %s ~eI",sender,userid);
           errmailog(genbuf);
      	   return -1;
      	}   
      }
	**********************************/
      if (strstr(genbuf,"taiwanmail")!=NULL)
      {
           sprintf(genbuf,"from %s to %s taiwanmailI",sender,userid);
           errmailog(genbuf);
      	   return -1;
      }
    }
    if (!strncmp(genbuf, "From", 4))
    {
      if ((ip = strchr(genbuf, '<')) && (ptr = strrchr(ip, '>')))
      {
        *ptr = '\0';
        if (ip[-1] == ' ')
          ip[-1] = '\0';
        ptr = (char *) strchr(genbuf, ' ');
        while (*++ptr == ' ');
        sprintf(sender, "%s (%s)", ip + 1, ptr);
      }
      else
      {
        strtok(genbuf, " \t\n\r");
        strcpy(sender, (char *) strtok(NULL, " \t\n\r"));
      }
      continue;
    }
    
    /********************************************************
    if (!strncmp(genbuf, "Content-Type: ", 14))
    {
      ip = genbuf + 14;
      while (*ip == ' ') ip++;
      if (strncmp(ip, "text/plain", 10))
      {
        
        sprintf(genbuf,"from %s  to %s not plain text!",sender,userid);
        errmailog(genbuf);
        return 1;	
        // forget it if not plain text 
      }
    }
    ****************************************************************/
    if (!strncmp(genbuf, "Content-Transfer-Encoding: ", 27))
    {
      ip = genbuf + 27;
      while (*ip == ' ') ip++;
      if (ci_strcmp(ip, "quoted-printable")) mycoding = QPCODE;
      else if (ci_strcmp(ip, "base64")) mycoding = BASE64CODE;
      continue;
    }
    if (genbuf[0] == '\n')
      break;
  }/*** read header ****/
  
  if (withto==0) /****check no to field ***/
  {
     sprintf(genbuf,"from %s SToo@I",sender);
     errmailog(genbuf);
     return -1;
  }

  if (ptr = strchr(sender, '\n'))
    *ptr = '\0';

  if (ptr = strchr(title, '\n'))
    *ptr = '\0';

  if (strchr(sender, '@') == NULL)      /*  local host HH */
  {
    strcat(sender, "@" MYHOSTNAME);
  }

  time(&tmp_time);

  if (!title[0])
    sprintf(title, "Ӧ %.64s", sender);


  if (chk_forward(title)==1){
     // forward to e-mail address

     sprintf(genbufx, "/usr/sbin/sendmail -f %s %s > /dev/null", sender, mail_addr);
     foutx = popen(genbufx, "w");

     fprintf(foutx, "Reply-To: %s\nFrom: %s\n",mail_addr,sender);

     fprintf(foutx, "To: %s\nSubject: %-100s\n", mail_addr, title);

     fprintf(foutx, "X-Disclaimer: FHL.BBS (bbs.fhl.net) will NOT take "
                   "responsibility for any issues by this forward letter.\n\n");

     while (fgets(genbuf, 255, stdin)){
       // if (mycoding) DecodeLine(genbuf);
       fputs(genbuf, foutx);
     }

     fprintf(foutx, ".\n");

     pclose(foutx);
     pclose(fout);
  }
  else{ 

     fprintf(fout, "@: %s\nD: %s\nɶ: %s\n",
       sender, title, ctime(&tmp_time));
     for (i=0;i<HDcnt;i++) fputs(HD[i], fout);
     while (fgets(buf, 255, stdin))
     {
       //if (mycoding) DecodeLine(genbuf);
	 //str_decode(genbuf, buf);
       fputs(buf, fout);
     }
     pclose(fout);
  }


#ifndef MIMEDEBUG
  sprintf(genbuf, "%s => %s", sender, userid);
  mailog(genbuf);

  /* append the record to the MAIL control file */

  strncpy(mymail.title, title, 72);

  if (strtok(sender, " .@\t\n\r"))
    strcat(sender, ".");
  sender[IDLEN + 1] = '\0';
  strcpy(mymail.owner, sender);

  sprintf(genbuf, BBSHOME "/home/%s/.DIR", userid);
  if (chk_forward(title)==0)
     return append_record(genbuf, &mymail, sizeof(mymail));
  else
     return 0;
#endif /* MIMEDEBUG */
}

int chk_forward(titlex)
char * titlex;
{
  char genbuf[4];
  char fpath[100];
  FILE *fp;
  char *ptr;

  if (strcmp(titlex, "MAILER-OAEMON")) {
    return 0;
  }
  sprintf(fpath, "/home/bbs/home/%s/forward.on", userid);
  if (fp = fopen(fpath, "r")) {
        // forward open
        fgets(mail_addr,256,fp);
        if (ptr = strchr(mail_addr, '\n'))
          *ptr = '\0';

        fclose(fp);
        return 1;
  }
  else{
     // forward close
     return 0;
  }
}

void
main(argc, argv)
  int argc;
  char *argv[];
{
  char receiver[256];

  setgid(BBSGID);
  setuid(BBSUID);
  /* argv[1] is userid in bbs   */

  if (argc < 2)
  {
#ifdef VERBOSE
    printf("Usage:\t%s <bbs_uid>\n", argv[0]);
#endif
    exit(-1);
  }

  strcpy(receiver, argv[1]);
  strcpy(userid,receiver);

  
  if (mail2bbs(receiver))
  {
    /* eat mail queue */
    while (fgets(receiver, sizeof(receiver), stdin));
    exit(EX_NOPERM);
  }

  exit(0);
}
