/*-------------------------------------------------------*/
/* util/bbsmail.c       ( NTHU CS MapleBBS Ver 2.36 )    */
/*-------------------------------------------------------*/
/* target :  Internet HH BBS ϥΪ            */
/* create : 95/03/29                                     */
/* update : 95/12/15                                     */
/*-------------------------------------------------------*/
/*
 * $Log: bbsmail.c,v $
 * Revision 1.2  1997/04/16 00:32:38  bbsroot
 * Added MIME Quoted-printable decoding.
 *
 * Revision 1.1  1997/04/16 00:24:26  bbsroot
 * Initial revision
 *
 */


#include <stdio.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <fcntl.h>
#include <time.h>
#include <sysexits.h>

#include "bbs.h"


char *fn_passwd = BBSHOME "/.PASSWDS";


#define _BBS_UTIL_C_
#include "cache.c"
#include "record.c"
#define LOG_FILE        (BBSHOME "/etc/mailog")
#define ERRLOG_FILE        (BBSHOME "/etc/errmailog")
#define Header_Length   200

char MANAGER[64];


#ifndef MIMEDEBUG
void
mailog(msg)
  char *msg;
{
  FILE *fp;

  if (fp = fopen(LOG_FILE, "a"))
  {
    time_t now;
    struct tm *p;

    time(&now);
    p = localtime(&now);
    fprintf(fp, "%04d/%02d/%02d %02d:%02d:%02d <bbsmail> %s\n",
     1900+p->tm_year, p->tm_mon+1, p->tm_mday, p->tm_hour, p->tm_min, p->tm_sec,
        msg);
    fclose(fp);
  }
}
void
errmailog(msg)
  char *msg;
{
  FILE *fp;

  if (fp = fopen(ERRLOG_FILE, "a"))
  {
    time_t now;
    struct tm *p;

    time(&now);
    p = localtime(&now);
    fprintf(fp, "%04d/%02d/%02d %02d:%02d:%02d <errmail> %s\n",
     1900+p->tm_year, p->tm_mon+1, p->tm_mday, p->tm_hour, p->tm_min, p->tm_sec,
        msg);
    fclose(fp);
  }
}
#endif /* MIMEDEBUG */


int
mail2bbs(userid, mailfile)
  char *userid;
  char *mailfile;
{
  fileheader mymail;
  char genbuf[256], title[80], sender[80], *ip, *ptr;
  char HD[Header_Length][260]; /*** header buffer ****/
  int  HDcnt,i;
  time_t tmp_time;
  struct stat st;
  FILE *fout, *fin;

#ifndef MIMEDEBUG
  /* check if the userid is in our bbs now */
  if (!searchuser(userid))
  {
    sprintf(genbuf, "BBS user <%s> not existed", userid);
    puts(genbuf);
    mailog(genbuf);
    return EX_NOUSER;
  }

  if((fin=fopen(mailfile,"r"))==NULL)
  {
    printf("file=%s open error!\n",mailfile);
    exit(-1);
  }
  sprintf(genbuf, BBSHOME "/home/%s", userid);

  if (stat(genbuf, &st) == -1)
  {
    if (mkdir(genbuf, 0755) == -1)
    {
#ifdef VERBOSE
      printf("mail box create error %s \n", genbuf);
#endif
      sprintf(genbuf,"%s mail box create error",userid);
      errmailog(genbuf);
      return -1;
    }
  }
  else if (!(st.st_mode & S_IFDIR))
  {
#ifdef VERBOSE
    printf("mail box error\n");
#endif
    sprintf(genbuf,"%s mail box error",userid);
    errmailog(genbuf);
    return -1;
  }

#ifdef VERBOSE
  printf("dir: %s\n", genbuf);
#endif

  /* allocate a file for the new mail */

  stampfile(genbuf, &mymail);
#ifdef VERBOSE
  printf("file: %s\n", genbuf);
#endif

  /* copy the stdin to the specified file */

  if ((fout = fopen(genbuf, "w")) == NULL)
  {
#ifdef VERBOSE
    printf("Cannot open %s\n", genbuf);
#endif
    strcat(genbuf," cannot open!");
    errmailog(genbuf);
    return -1;
  }
#else
  fout = stdout;
#endif	/* MIMEDEBUG */

  /* parse header */


  time(&tmp_time);

  sprintf(title, "HRz@ʫH");

  fprintf(fout, "@: %s\nD: %s\nɶ: %s\n",
    MANAGER, title, ctime(&tmp_time));
   while (fgets(genbuf, 255, fin))
  {
     fputs(genbuf, fout);
  }

  fclose(fout);
  fclose(fin);

#ifndef MIMEDEBUG
  sprintf(genbuf, "%s => %s", sender, userid);
  mailog(genbuf);

  /* append the record to the MAIL control file */

  strncpy(mymail.title, title, 72);

  sender[IDLEN + 1] = '\0';
  strcpy(mymail.owner, MANAGER);

  sprintf(genbuf, BBSHOME "/home/%s/.DIR", userid);
  return append_record(genbuf, &mymail, sizeof(mymail));
#endif /* MIMEDEBUG */
}


void
main(argc, argv)
  int argc;
  char *argv[];
{
  char receiver[256],genbuf[256];
  FILE *fpt;
  setgid(BBSGID);
  setuid(BBSUID);
  /* argv[1] is userid in bbs   */

  if (argc < 4)
  {

    printf("Usage:\t%s <userlist file> <mail filename> <MANAGER name>\n", argv[0]);
    exit(-1);
  }

  if ((fpt=fopen(argv[1],"r"))==NULL)
  {

    printf("Error in open %s !\n",argv[1]);
    exit(-1);
  }
  if (strlen(argv[3])>=64)
  {
    strncpy(MANAGER, argv[3],63);
    MANAGER[63]=0;
  }else strcpy(MANAGER,argv[3]);
  
  while (fgets(genbuf,255,fpt))
  {
   if(isalpha(genbuf[0])&&(genbuf[0]!='=')&&
     ((genbuf[0]!='')||(genbuf[1]!='`')))
    {  
     sscanf(genbuf,"%s",receiver);
     if (mail2bbs(receiver, argv[2]))
     {
      printf("%s receive error! \n",receiver);
     }
    }
  }
  fclose(fpt);
  exit(0);
}
