/*-------------------------------------------------------*/
/* util/mailpost.c      ( NTHU CS MapleBBS Ver 2.36 )    */
/*-------------------------------------------------------*/
/* target : (1) general user E-mail post ݪO          */
/*          (2) BM E-mail post ذ                  */
/*          (3) ۰ʼf֨{ҫH礧^H               */
/* create : 95/03/29                                     */
/* update : 95/12/15                                     */
/*-------------------------------------------------------*/
/*
 * $Log: mailpost.c,v $
 * Revision 1.2  1997/04/16 00:23:38  bbsroot
 * Added MIME Quoted-printable decoding.
 *
 * Revision 1.1  1997/04/16 00:14:05  bbsroot
 * Initial revision
 *
 */


#include <stdio.h>
#include <ctype.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <fcntl.h>
#include <time.h>

#include "bbs.h"

char *fn_passwd = ".PASSWDS";
char *crypt();

#define NOCODE 0
#define QPCODE 1
#define BASE64CODE 2
#define TRUE    1
#define FALSE   0

#define _BBS_UTIL_C_
#include "cache.c"
#include "record.c"

userec record;
char myfrom[128], mysub[128], myname[128], mypasswd[128];
char myboard[128], mytitle[128], mydigest[128];
char mycoding = NOCODE;

#define JUNK            0
#define NET_SAVE        1
#define LOCAL_SAVE      2

int mymode = JUNK;

#define LOG_FILE        "etc/mailog"


/* ----------------------------------------------------- */
/* buffered I/O for stdin                                */
/* ----------------------------------------------------- */

#define POOL_SIZE       8192
#define LINE_SIZE       512

char pool[POOL_SIZE];
char mybuf[LINE_SIZE];
int pool_size = POOL_SIZE;
int pool_ptr = POOL_SIZE;


#define XX 127
/*
 * Table for decoding hexadecimal in quoted-printable
 */
static char index_hex[256] = {
    XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
    XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
    XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
     0, 1, 2, 3,  4, 5, 6, 7,  8, 9,XX,XX, XX,XX,XX,XX,
    XX,10,11,12, 13,14,15,XX, XX,XX,XX,XX, XX,XX,XX,XX,
    XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
    XX,10,11,12, 13,14,15,XX, XX,XX,XX,XX, XX,XX,XX,XX,
    XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
    XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
    XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
    XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
    XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
    XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
    XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
    XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
    XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX, XX,XX,XX,XX,
};
#define HEXCHAR(c)  (index_hex[(unsigned char)(c)])


void
DecodeSubject(buf)
  char *buf;
{
   char tmpbuf[LINE_SIZE];
   int bpos = 0, tpos = 0;
   int len = 0;
   int subjcoding = NOCODE;
   int c1, c2, c3, c4;
   int DataDone = 0;

   while (buf[len] != '\0') len++;
   tmpbuf[0] = '\0';

   while (bpos < len) {
      if (buf[bpos] == '=' && buf[bpos+1] == '?') {	/* Encoded subject */
      /* Subject: xxx [** CHARSET **] xxx */
         bpos += 2;
         while (buf[bpos] != '?') bpos++;	/* skip the encoding info */
            bpos++;				/* skip the '?' */
            if (buf[bpos] == 'Q') {
               subjcoding = QPCODE;
               bpos++;
            } else if (buf[bpos] == 'B') {
               subjcoding = BASE64CODE;
               bpos++;
            } else {
               subjcoding = NOCODE;
            }
            switch (subjcoding) {
               case QPCODE:
                  bpos++;			/* skip the "?" */
                  while (buf[bpos] != '\0' && !(buf[bpos] == '?'
                          && buf[bpos+1] == '=')) {
                     if (buf[bpos] == '=') {
                        tmpbuf[tpos++] = HEXCHAR(buf[bpos+1]) <<4 |
                                HEXCHAR(buf[bpos+2]);
                        bpos += 3;
                     } else {
                        tmpbuf[tpos++] = buf[bpos++];
                     }
                  }
                  if (bpos+2 > len || buf[bpos] != '?' || buf[bpos+1] != '=') {
                     subjcoding = NOCODE;	/* forget it, wrong qp-coding */
                     break;
                  }
                  bpos += 2;	/* skip the "=?" */
                  break;
             }
        } else {
           tmpbuf[tpos++] = buf[bpos++];
        }
   }
   tmpbuf[tpos] = '\0';
   if (subjcoding != NOCODE) strcpy(buf, tmpbuf);
}


void
DecodeLine(buf)
  char *buf;
{
   char tmpbuf[LINE_SIZE];
   int bpos = 0, tpos = 0;
   int len = 0;
   int subjcoding = NOCODE;
   int c1, c2, c3, c4;
   int DataDone = 0;

   /* Make sure mycoding is QPCODE before entering this function */
   /* if (mycoding != QPCODE) return;
    * Support only quote-printable coding for the time being */

   while (buf[len] != '\0') len++;
   tmpbuf[0] = '\0';

   while (bpos < len) {
      if (buf[bpos] == '=') {			/* Encoded subject */
         tmpbuf[tpos++] = HEXCHAR(buf[bpos+1]) <<4 | HEXCHAR(buf[bpos+2]);
         bpos += 3;
      } else {
         tmpbuf[tpos++] = buf[bpos++];
      }
   }
   tmpbuf[tpos] = '\0';
   strcpy(buf, tmpbuf);
}


int
readline(buf)
  char *buf;
{
   register char ch;
   register int len, bytes;

   len = bytes = 0;
   do
   {
      if (pool_ptr >= pool_size)
      {
         if (pool_size = fread(pool, 1, POOL_SIZE, stdin))
            pool_ptr = 0;
         else
            break;
      }
      ch = pool[pool_ptr++];
      bytes++;

      if (ch == '\r')
         continue;

      buf[len++] = ch;
   } while (ch != '\n' && len < (LINE_SIZE - 1));

   buf[len] = '\0';
   return bytes;
}


/* ----------------------------------------------------- */
/* record etc/mailog for management                      */
/* ----------------------------------------------------- */

void
mailog(mode, msg)
  char *mode, *msg;
{
   FILE *fp;

   if (fp = fopen(LOG_FILE, "a"))
   {
      time_t now;
      struct tm *p;

      time(&now);
      p = localtime(&now);
      fprintf(fp, "%04d/%02d/%02d %02d:%02d:%02d <%s> %s\n",
        1900+p->tm_year, p->tm_mon + 1, p->tm_mday, p->tm_hour, p->tm_min,
	p->tm_sec, mode, msg);
      fclose(fp);
   }
}


void
str_lower(t, s)
  char *t, *s;
{
   register uschar ch;

   do
   {
      ch = *s++;
      *t++ = (ch >= 'A' && ch <= 'Z') ? ch | 32 : ch;
   } while (ch);
}


int
valid_ident(ident)
  char *ident;
{
   static char *invalid[] = {"unknown@", "root@", "gopher@", "bbs@",
       "@bbs", "guest@", "@ppp", "@slip", NULL};
   char buf[128];
   int i;

   str_lower(buf, ident);
   for (i = 0; invalid[i]; i++)
      if (strstr(buf, invalid[i]))
         return 0;
   return 1;
}


int
get_userec(usrnum, record)
  int usrnum;
  userec *record;
{
  int fh;

  if ((fh = open(fn_passwd, O_RDWR)) == -1)
  {
    printf(":Err: unable to open %s file.\n", fn_passwd);
  }
  else
  {
    lseek(fh, (usrnum - 1) * sizeof(userec), SEEK_SET);
    read(fh, record, sizeof(userec));
  }
  return fh;
}


/* ------------------------------------------------------- */
/* OҸơGuser iॿbuWAҥHgJɮץHOP */
/* ------------------------------------------------------- */

void
justify_user()
{
  FILE *fp;
  char buf[80];

  sprintf(buf, "home/%s/email", record.userid);

  if (fp = fopen(buf, "w"))
  {
    fprintf(fp, "%s\n", myfrom);
    fclose(fp);
  }
  strncpy(record.justify, myfrom, 37);
  record.userlevel |= PERM_LOGINOK;
}


void
verify_user(magic)
  char *magic;
{
  char *ptr, *next, ch;
  ushort checksum, usrnum;
  int fh;

  if (ptr = (char *) strchr(magic, '('))
  {
    *ptr++ = '\0';
    if (next = (char *) strchr(ptr, ':'))
    {
      *next++ = '\0';
      usrnum = atoi(ptr) - MAGIC_KEY;
      if (ptr = (char *) strchr(next, ')'))
      {
        *ptr++ = '\0';
        checksum = atoi(next);

        if ((fh = get_userec(usrnum, &record)) == -1)
          return;

        if (!ci_strcmp(magic, record.userid))
        {
          ptr = myfrom;         /* record.email; */
          while (ch = *ptr++)
          {
            if (ch <= ' ')
              break;
            if (ch >= 'A' && ch <= 'Z')
              ch |= 0x20;
            usrnum = (usrnum << 1) ^ ch;
          }
          if ((usrnum == checksum) && valid_ident(myfrom))
          {
            justify_user();
            lseek(fh, -(sizeof record), SEEK_CUR);
            write(fh, &record, sizeof record);
            sprintf(mybuf, "[%s]%s", record.userid, myfrom);
            mailog("verify", mybuf);
          }
        }
        close(fh);
      }
    }
  }
}


int
post_article()
{
  fileheader header;
  char index[64], fpath[80],genbuf[100],namebuf[80],mynamebuf[128];
  FILE *fidx;
  struct stat st;

  sprintf(fpath, "boards/%s", mymode ? myboard : "junk");
  sprintf(index, "%s/.DIR", fpath);

#ifndef MIMEDEBUG
  if (mymode == JUNK)
  {
    pool_ptr = 0;
    if (!readline(mybuf))
      exit(0);

    if (!*myname)
      strcpy(myname, "w");
    if (!*mytitle)
      strcpy(mytitle, *mysub ? mysub : "[Ф]");
  }
  else
  {
    char msgbuf[256];

    sprintf(msgbuf, "[%s]%s => %s", record.userid, myfrom, myboard);
    mailog("mailpost", msgbuf);
    /**** add account post*****/
     sprintf(genbuf, "%s/postnum", fpath);
     logcnt(genbuf);
  }

  if (stat(fpath, &st) == -1)
  {
    if (mkdir(fpath, 0755) == -1)
    {
#ifdef VERBOSE     /* tΦb]ɨSHݧaH */
      printf("board dir create error\n");
#endif /* VERBOSE */
      return -1;
    }
  }
  else if (!(st.st_mode & S_IFDIR))
  {
#ifdef VERBOSE
    printf("board dir error\n");
#endif /* VERBOSE */
    return -1;
  }

#ifdef VERBOSE
  printf("dir: %s\n", fpath);
#endif /* VERBOSE */

  stampfile(fpath, &header);
  fidx = fopen(fpath, "w");
#endif /* MIMEDEBUG */

#ifdef VERBOSE
  printf("post to %s\n", fpath);
#endif /* VERBOSE */

  if (mymode)
  {
    time_t now = time(NULL);
    if (!strcmp("Anonymity", myboard))
    {
      strcpy(myname, "         ");
      strcpy(mynamebuf, "anonymous");
      strcpy(namebuf,"@ADڬO");
    }
    else
    {
      if (!strcmp("comfortable", myboard))
      {
        strcpy(mynamebuf,"anonymous");
        strcpy(namebuf,"@ADڬO");
      }
      else
      {
        strcpy(mynamebuf,myname);
        strcpy(namebuf,record.username);
      }
    }

#ifdef MIMEDEBUG
    printf("@: %s (%s)     %s: %s\nD: %s\nɶ: %s\n",
#else
    fprintf(fidx, "@: %s (%s)     %s: %s\nD: %s\nɶ: %s\n",
#endif /* MIMEDEBUG */
    mynamebuf, namebuf,  "ݪO",
    myboard, mytitle, ctime(&now));
    if (mymode == LOCAL_SAVE)
    {
      header.savemode = 'L';    /* local article */
      header.filemode = FILE_LOCAL;
    }
    else
      header.savemode = 'S';    /* H */
  }

#ifdef MIMEDEBUG
  printf("*** oOH ***\n");
  do
  {
    if (mycoding) DecodeLine(mybuf);
    printf("%s", mybuf);
  } while (readline(mybuf));
#else
  do
  {
    if (mycoding == QPCODE) DecodeLine(mybuf);
    fputs(mybuf, fidx);
  } while (readline(mybuf));
  fclose(fidx);

  strncpy(header.owner, myname, IDLEN);
  strncpy(header.title, mytitle, TTLEN);
  append_record(index, &header, sizeof(header));
#endif

#ifdef MIMEDEBUG
  if (mymode == NET_SAVE)
  {
    printf("%s\t%s\t%s\t%s\t%s\n",
      myboard, header.filename, myname, namebuf, mytitle);
  }
#else
  if ((mymode == NET_SAVE) && (fidx = fopen("innd/out.bntp", "a")))
  {
    fprintf(fidx, "%s\t%s\t%s\t%s\t%s\n",
      myboard, header.filename, myname, namebuf, mytitle);
    fclose(fidx);
  }
#endif /* MIMEDEBUG */
  return 0;
}


int
digest_article()
{
  char *str_mandex = "/.Names";
  char index[256], mpath[80], *ptr, ch;
  FILE *fh;
  time_t now;
  struct tm *ptime;

  return -1;
  sprintf(mybuf, "[%s]%s => %s", record.userid, myfrom, myboard);
  mailog("digest", mybuf);

  sprintf(mpath, "man/%s", myboard);
  sprintf(index, "%s%s", mpath, str_mandex);
  if (!(fh = fopen(index, "r")))
  {
    printf(":Err: Unable to digest in %s.\n", myboard);
    return -1;
  }

  ch = 1;
  while (fgets(index, 256, fh))
  {
    if (!strncmp(index, "# Title=", 8))
    {
      ch = 0;
      break;
    }
  }
  fclose(fh);

  if (ch)
    return -1;

  if (ptr = (char *) strstr(index, myname))
  {
    ch = ptr[-1];
    if ((ch == '[') || (ch == '/'))
    {
      ch = ptr[strlen(myname)];
      if ((ch == ']') || (ch == '/'))
      {
        /* truncate long lines */

        mydigest[79] = mytitle[62] = '\0';
        if (ptr = (char *) strchr(mydigest, ' '))
          *ptr = '\0';

        sprintf(index, "%s/%s", mpath, mydigest);
        if (fh = fopen(index, "a+"))
        {
#ifdef VERBOSE
          printf("digest: %s\n", index);
#endif /* VERBOSE */

          do
          {
            if (mycoding) DecodeLine(mybuf);
            fputs(mybuf, fh);
          } while (readline(mybuf));
          fclose(fh);

          now = time(NULL);
          ptime = localtime(&now);
          ptr = (char *) strrchr(index, '/');
          strcpy(mydigest, ptr + 1);
          strcpy(ptr, str_mandex);
          fh = fopen(index, "a+");
          fprintf(fh, "Name= %s\nDate=%04d/%02d/%02d\nPath=%s\n\n",
            mytitle, ptime->tm_mon + 1, ptime->tm_mday, 1900+ptime->tm_year, mydigest);
          fclose(fh);
          return 0;
        }
      }
    }
  }
  return -1;
}


int
mailpost()
{
  int uid, fh, dirty;
  char *ip, *ptr;
  char *token, *key;

  /* parse header */
  readline(mybuf);
  if (strncasecmp(mybuf, "From", 4))
    return post_article();      /* junk */

  dirty = *myfrom = *mysub = *myname = *mypasswd = *myboard =
	  *mytitle = *mydigest = 0;

  while (!*myname || !*mypasswd || !*myboard || !*mytitle)
  {
    if (mybuf[0] == '#')
    {
      key = mybuf + 1;

      /* skip trailing space */

      if (ptr = strchr(key, '\n'))
      {
        do
        {
          *ptr = '\0';
          fh = *(--ptr);
        } while (fh == ' ' || fh == '\t');
      }

      /* split token & skip leading space */

      if (token = strchr(key, ':'))
      {
        *token = '\0';
        do
        {
          fh = *(++token);
        } while (fh == ' ' || fh == '\t');
      }

      if (!ci_strcmp(key, "name") || !ci_strcmp(key, "userid"))
      {
        strcpy(myname, token);
      }
      else if (!ci_strcmp(key, "passwd") || !ci_strcmp(key, "password"))
      {
        strcpy(mypasswd, token);
      }
      else if (!ci_strcmp(key, "board"))
      {
        strcpy(myboard, token);
      }
      else if (!ci_strcmp(key, "title") || !ci_strcmp(key, "subject"))
      {
        strcpy(mytitle, token);
      }
      else if (!ci_strcmp(key, "digest"))
      {
        strcpy(mydigest, token);
      }
      else if (!ci_strcmp(key, "local"))
      {
        mymode = LOCAL_SAVE;
      }
    }
    else if (!strncasecmp(mybuf, "From", 4))
    {
      str_lower(myfrom, mybuf + 4);
      if (strstr(myfrom, "mailer-daemon"))
        return post_article();

      if ((ip = strchr(mybuf, '<')) && (ptr = strrchr(ip, '>')))
      {
        *ptr = '\0';
        if (ip[-1] == ' ')
          ip[-1] = '\0';
        ptr = (char *) strchr(mybuf, ' ');
        while (*++ptr == ' ');
        sprintf(myfrom, "%s (%s)", ip + 1, ptr);
      }
      else
      {
        strtok(mybuf, " ");
        strcpy(myfrom, (char *) strtok(NULL, " "));
      }
    }
    else if (!strncmp(mybuf, "Subject: ", 9))
    {
      /* audit justify mail */

      if (ptr = strstr(mybuf, "[SOB BBS]To "))
      {
        verify_user(ptr + 12);
        return -1;
      }
      if (ptr = strchr(token = mybuf + 9, '\n'))
        *ptr = '\0';
      strcpy(mysub, token);
    }
    else if (!strncmp(mybuf, "Content-Type: ", 14))
    {
      ip = mybuf + 14;
      while (*ip == ' ') ip++;
      if (strncmp(ip, "text/plain", 10))
        return 0;	/* forget it if not plain text */
    }
    else if (!strncmp(mybuf, "Content-Transfer-Encoding: ", 27))
    {
      ip = mybuf + 27;
      while (*ip == ' ') ip++;
      if (ci_strcmp(ip, "quoted-printable")) mycoding = QPCODE;
      else if (ci_strcmp(ip, "base64")) mycoding = BASE64CODE;
    }

    if ((++dirty > 50) || !readline(mybuf))
    {
      mymode = JUNK;
      return post_article();    /* junk */
    }
  }

  DecodeSubject(mysub);
  if (mycoding) DecodeLine(mytitle);

#ifdef MIMEDEBUG
  printf("myfrom = %s\n", myfrom);
  printf("mysub = %s\n", mysub);
  printf("myname = %s\n", myname);
  printf("mypasswd = %s\n", mypasswd);
  printf("myboard = %s\n", myboard);
  printf("mytitle = %s\n", mytitle);
  printf("mydigest = %s\n", mydigest);
  printf("mycoding = %d\n", mycoding);
#endif /* MIMEDEBUG */

  dirty = 0;

#ifndef MIMEDEBUG
  /* check if the userid is in our bbs now */
  if (!(uid = searchuser(myname)))
  {
#ifdef VERBOSE
    printf("BBS user <%s> not existed\n", myname);
#endif /* VERBOSE */
    return -1;
  }

  if ((fh = get_userec(uid, &record)) == -1)
  {
    return -1;
  }

  /* check password */

  key = crypt(mypasswd, record.passwd);
  if (strcmp(key, record.passwd))
  {
    printf(":Err: user [%s] password incorrect!\n", myname);
    close(fh);
    return -1;
  }

  if (valid_ident(myfrom))
  {

    /* ------------------------------ */
    /* KO user's E-mail address */
    /* ------------------------------ */

    justify_user();
    dirty = YEA;
  }

  /* check permission */

  if (!*mydigest)
  {
    if (mymode != LOCAL_SAVE)
      mymode = NET_SAVE;

    if (!strstr(myboard, "test"))
    {
      record.numposts++;
      dirty = YEA;
    }
  }
#endif /* MIMEDEBUG */

  while (mybuf[0] && mybuf[0] != '\n')
    readline(mybuf);

  while (mybuf[0] == '\n')
    readline(mybuf);

  if (dirty && mybuf[0])
  {
    lseek(fh, -sizeof(struct userec), SEEK_CUR);
    write(fh, &record, sizeof(struct userec));
  }
  close(fh);

  if (mybuf[0])
    return (*mydigest) ? digest_article() : post_article();

  mymode = JUNK;
  return post_article();
}


void
main(void)
{
#ifndef MIMEDEBUG
  chdir(BBSHOME);
  setgid(BBSGID);
  setuid(BBSUID);
#endif /* MIMEDEBUG */
  if (mailpost())
  {
    /* eat mail queue */
    while (fread(pool, 1, POOL_SIZE, stdin));
  }
  exit(0);
}

int
logcnt(char *filename)
{
 int i,fd,encnt;
  fd = open(filename, O_RDWR|O_CREAT,600);
    flock(fd, LOCK_EX);
    if (i=read(fd, (char*)(&encnt), 4)>0)
    {
       if ((encnt>0)&&(encnt<100000))
           encnt=encnt+1;
       else
           encnt=1;
    }
    else encnt=1;
       lseek(fd,0,SEEK_SET);
       write(fd,(char*)(&encnt),4);
    flock(fd, LOCK_UN);
    close(fd);
}
