/*-------------------------------------------------------*/
/* util/mandex.c        ( NTHU CS MapleBBS Ver 2.39 )    */
/*-------------------------------------------------------*/
/* target : ذϯ޵{ (man index)                   */
/* create : 95/03/29                                     */
/* update : 95/08/08                                     */
/*-------------------------------------------------------*/
/*-------------------------------------------------------*/
/* syntax : mandex [board]                               */
/*          [board]  ==> u] board                */
/*                  Ū ==> Ҧ boards ]          */
/*-------------------------------------------------------*/


#include        "bbs.h"


char fn_names[] = ".Names";
char fn_index[] = ".index";
char fn_new[] = ".index.new";


FILE *fndx;
int visited;
int ndir;
int nfile;
char pgem[128], pndx[128];


/* visit the hierarchy recursively */


void
mandex(level, fpath)
  int level;
  char *fpath;
{
  FILE *fgem;
  char *fname, *ptr, buf[256];
  struct stat st;
  int isdir, count;

  fgem = fopen(fpath, "r");
  if (fgem == NULL)
    return;

  fname = strrchr(fpath, '.');

  if (!level)
  {
    strcpy(pgem, fpath);

    strcpy(fname, fn_new);
    fndx = fopen(fpath, "w");
    if (fndx == NULL)
    {
      fclose(fgem);
      return;
    }
    fprintf(fndx, "Ǹ\t\t\tذϥDD\n"
      "-------------------------------------------------------------\n");
    strcpy(pndx, fpath);
    visited = ndir = nfile = 0;
  }

  isdir = count = 0;
  while (fgets(buf, sizeof(buf), fgem))
  {
    ptr = buf + 5;

    if (!memcmp(buf, "Name=", 5))
    {
      if (ptr[3] == '#')
        continue;

      if (!memcmp(ptr, " ", 3))
      {
        ndir++;
        isdir = 1;
      }
      else
      {
        nfile++;
        if (!memcmp(ptr, " ", 3))
          ptr += 3;
      }
      fprintf(fndx, "%*d. %s", 3 * level + 3, ++count, ptr);
    }

    if (!memcmp(buf, "Path=", 5))
    {
      if (!level && !memcmp(ptr, fn_index, 6))
      {
        visited = 1;
      }

      if (isdir)
      {
        char *str;

        if (str = strchr(ptr, '\n'))
          *str++ = '/';
        strcpy(str, fn_names);
        strcpy(fname, ptr);
        mandex(level + 1, fpath);
        isdir = 0;
      }
    }
  }

  if (!level)
  {
    fclose(fndx);
    strcpy(fname, fn_index);
    rename(pndx, fpath);

    if (!visited)
    {
      sprintf(pndx, "%s.new", pgem);
      if (fndx = fopen(pndx, "w"))
      {
        fprintf(fndx, "Name= ذϥؿ\nEdit=Ϫ\n"
          "Date=    \nPath=%s\n\n", fn_index);

        fseek(fgem, (off_t) 0, SEEK_SET);
        while (fgets(buf, sizeof(buf), fgem))
        {
          fputs(buf, fndx);
        }

        fclose(fgem);
        fclose(fndx);
        rename(pndx, pgem);
        return;
      }
    }
  }

  fclose(fgem);
}


void
main(argc, argv)
  int argc;
  char *argv[];
{
  DIR *dirp;
  struct dirent *de;

  int ch;
  struct stat st;
  char *fname, fpath[1024];

  chdir(BBSHOME "/man");

  if (argc > 1)
  {
    sprintf(fpath, "%s/%s", argv[1], fn_names);
    mandex(0, fpath);
    exit(0);
  }

  if (!(dirp = opendir(".")))
  {
    printf("## unable to enter [man]\n");
    exit(-1);
  }

  while (de = readdir(dirp))
  {
    fname = de->d_name;
    ch = fname[0];
    if (ch != '.' && ch != '#' && ch != '0')
    {
      sprintf(fpath, "%s/%s", fname, fn_names);
      mandex(0, fpath);
      printf("%-14sd: %d\tf: %d\n", fname, ndir, nfile);        /* report */
    }
  }
  closedir(dirp);
  exit(0);
}

