/*-------------------------------------------------------*/
/* util/showuser.c      ( NTHU CS MapleBBS Ver 2.36 )    */
/*-------------------------------------------------------*/
/* target : ϥΪ̸a                               */
/* create : 95/03/29                                     */
/* update : 95/12/15                                     */
/*-------------------------------------------------------*/
/*      $ showuser .PASSWDS ... :  all users           */
/*      $ ln showuser showsysop :  sysop               */
/*      $ ln showuser showBM    :  manager/sysop       */
/*      $ ln showuser showBM    :  manager/sysop       */
/*      $ ln showuser checkdg   : check a month no login */
/*-------------------------------------------------------*/


#include "bbs.h"
#include <time.h>

struct userec aman;
char *MYPASSFILE, field_str[80];
int field_count = 0;
int field_lst_no[16];
int field_lst_size[16];
int field_default_size[16] = {
  4, 12, 16, 4, 4,
  16, 24, 12, 24, 30,
  8, 16, 24, 40, 14, 0
};

char field_idx[] = "dihlpnvramtufjV";
char *field_name[] = {
  "No.",
  " UserID",
  "LastHost",
  "Login",
  "Post",
  "Nick",
  "LastVisit",
  "Real",
  "Addr",
  "Email",
  "Term",
  "Userlevel",
  "FirstVisit",
  "Justify",
  "LastVisitTime",
  NULL
};


void
set_opt(argc, argv)
  int argc;
  char *argv[];
{
  int i, flag, field, size, *p;
  char *ptr, *field_ptr;

  field_count = 0;

  for (i = 2; i < argc; i++)
  {
    field_ptr = (char *) strchr(field_idx, argv[i][0]);
    if (field_ptr == NULL)
      continue;
    else
      field = field_ptr - field_idx;

    size = atoi(argv[i] + 1);

    field_lst_no[field_count] = field;
    field_lst_size[field_count] = size ? size : field_default_size[field];
    field_count++;
  }
}


void
print_head()
{
  int i, field, size;

  for (i = 0; i < field_count; i++)
  {
    field = field_lst_no[i];
    size = field_lst_size[i];
    printf("%-*.*s ", size, size, field_name[field]);
  }
  printf("\n");
  for (i = 0; i < field_count; i++)
  {
    size = field_lst_size[i];
    while (size--)
      putchar('=');
    putchar(' ');
  }
  printf("\n");
}


void
my_ctime(t)
  time_t *t;
{
  strcpy(field_str, (char *) ctime(t));
  field_str[strlen(field_str) - 1] = '\0';
}


void
print_record(serial_no, p)
  int serial_no;
  struct userec *p;
{
  int i, j, field, size, pat;

  for (i = 0; i < field_count; i++)
  {
    field = field_lst_no[i];
    size = field_lst_size[i];

    switch (field)
    {
    case 0:
      sprintf(field_str, "%d", serial_no);
      break;

    case 1:
      strcpy(field_str, p->userid);
      break;

    case 2:
      strcpy(field_str, p->lasthost);
      break;

    case 3:
      sprintf(field_str, "%d", p->numlogins);
      break;

    case 4:
      sprintf(field_str, "%d", p->numposts);
      break;

    case 5:
      strcpy(field_str, p->username);
      break;

    case 6:
      my_ctime(&p->lastlogin);
      break;

    case 7:
      strcpy(field_str, p->realname);
      break;

    case 8:
      strcpy(field_str, p->address);
      break;

    case 9:
      strcpy(field_str, p->email);
      break;

/*    case 10:
      strcpy(field_str, p->termtype);
      break;                                    */

    case 11:
      pat = p->userlevel;
      for (j = 0; j < 31; j++, pat >>= 1)
      {
        field_str[j] = (pat & 1) ? '1' : '0';
      }
      field_str[j] = '\0';
      break;

    case 12:
      my_ctime(&p->firstlogin);
      break;

    case 13:
      strcpy(field_str, p->justify);
    case 14:
      sprintf(field_str, "%d", p->lastlogin);
    }

    printf("%-*.*s ", size, size, field_str);
  }
  printf("\n");
}


main(argc, argv)
  int argc;
  char *argv[];
{
  FILE *inf;
  int i, level,cnt;
  int acnt[32];
  char *p;
  time_t now;

  if (argc < 3)
  {
    printf("Usage: %s %s\n", argv[0], "password_file [XN] ....");
    printf("Example: %s %s\n", argv[0], "d3 i12 e30");
    printf("N is field width, X is one of the following char :\n");

    for (i = 0; field_name[i]; i++)
    {
      printf("\t%c[%2d] - %s\n",
        field_idx[i], field_default_size[i], field_name[i]);
    }
    exit(0);
  }
  else
  {
    set_opt(argc, argv);
    MYPASSFILE = argv[1];
  }

  if (strstr(argv[0], "showsysop"))
    level = PERM_SYSOP;
  else if (strstr(argv[0], "showBM"))
    level = PERM_BM;
  else if (strstr(argv[0], "showl3"))
      level = PERM_MAILLIMIT;
  else if (strstr(argv[0], "showl2"))
    {
      level = PERM_LOGINOK;
      inf = fopen(MYPASSFILE, "rb");
      if (inf == NULL)
      {
        printf("Error open %s\n", MYPASSFILE);
        exit(0);
      }
      printf(" ");
      print_head();
      i = 0;
      cnt =0;
      while (fread(&aman, sizeof(aman), 1, inf))
      {
        i++;
        if ((aman.userlevel & level)&&(!(aman.userlevel & PERM_MAILLIMIT)))
          {
              print_record(i, &aman);
              cnt++;
          }
      }
      printf("\n`@: %d H\n",cnt);
      fclose(inf);
      exit(0);
    }
  else if (strstr(argv[0], "showl1"))
    {
      level = PERM_POST;
      inf = fopen(MYPASSFILE, "rb");
      if (inf == NULL)
      {
        printf("Error open %s\n", MYPASSFILE);
        exit(0);
      }
      print_head();
      i = 0;
      cnt =0;
      while (fread(&aman, sizeof(aman), 1, inf))
      {
        i++;
        if ((aman.userlevel & level)&&(!(aman.userlevel & PERM_LOGINOK)))
          {
              print_record(i, &aman);
              cnt++;
          }
      }
      printf("\n`@: %d H\n",cnt);
      fclose(inf);
      exit(0);
    }
  else if (strstr(argv[0], "showl0"))
    {
      level = PERM_POST;
      inf = fopen(MYPASSFILE, "rb");
      if (inf == NULL)
      {
        printf("Error open %s\n", MYPASSFILE);
        exit(0);
      }
      print_head();
      i = 0;
      cnt =0;
      while (fread(&aman, sizeof(aman), 1, inf))
      {
        i++;
        if ((!(aman.userlevel & level))&&(aman.userlevel&PERM_BASIC))
          {
              print_record(i, &aman);
              cnt++;
          }
      }
      printf("\n`@: %d H\n",cnt);
      fclose(inf);
      exit(0);
    }
  else if (strstr(argv[0], "showcnt"))
    {
       inf = fopen(MYPASSFILE, "rb");
       if (inf == NULL)
       {
         printf("Error open %s\n", MYPASSFILE);
         exit(0);
       }

       for (i=0;i<=31;i++) acnt[i]=0;
       i=0;
       cnt=0;
       while (fread(&aman, sizeof(aman), 1, inf))
       {
         i++;
         if (aman.userlevel & PERM_SYSOP)
           {
               acnt[7]++;
               cnt++;
           }
         else if (aman.userlevel & PERM_BM)
           {
               acnt[4]++;
               cnt++;
           }
         else if (aman.userlevel & PERM_MAILLIMIT)
           {
               acnt[3]++;
               cnt++;
           }
         else if (aman.userlevel & PERM_LOGINOK)
           {
               acnt[2]++;
               cnt++;
           }
         else if (aman.userlevel & PERM_POST)
           {
               acnt[1]++;
               cnt++;
           }
         else if (aman.userlevel & PERM_BASIC)
           {
               acnt[0]++;
               cnt++;
           }
       }

        printf("\n 0     %5d H\n",acnt[0]);
        printf("\n 1     %5d H\n",acnt[1]);
        printf("\n 2     %5d H\n",acnt[2]);
        printf("\n 3     %5d H\n",acnt[3]);
        printf("\nOD       %5d H\n",acnt[4]);
        printf("\nSYSOP      %5d H\n",acnt[7]);
        printf("\nT`Ʀ@ %5d H\n",cnt);
        printf("\nKXɤ   %5d H\n",i);

       fclose(inf);
       exit(0);
    }
  else if (strstr(argv[0], "checkdg"))
    {
      inf = fopen(MYPASSFILE, "rb");
       if (inf == NULL)
       {
         printf("Error open %s\n", MYPASSFILE);
         exit(0);
       }

       i=0;
       cnt=0;
       now = time(NULL);
       while (fread(&aman, sizeof(aman), 1, inf))
       {
         i++;
         if ((aman.userlevel & PERM_BM)||(aman.userlevel & PERM_MAILLIMIT))
           {  
              if ((now-aman.lastlogin)>86400*31) 
                  {print_record(i, &aman);
                   cnt++;
                  }
           }
       }
       printf("\n`@: %d H\n",cnt);
       fclose(inf);
       exit(0);
    }
  else
    level = 0xffff;

  inf = fopen(MYPASSFILE, "rb");
  if (inf == NULL)
  {
    printf("Error open %s\n", MYPASSFILE);
    exit(0);
  }

  print_head();
  i = 0;
  cnt =0;
  while (fread(&aman, sizeof(aman), 1, inf))
  {
    i++;
    if (aman.userlevel & level)
      {
          print_record(i, &aman);
          cnt++;
      }
  }
  printf("\n`@: %d H\n",cnt);
  fclose(inf);
}
